<?php


namespace App;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Campaign extends Model
{
  use SoftDeletes;
    protected $dates = [
        'created_at',
        'updated_at',
    ];

    protected $fillable = [
        'title',
        'description',
        'social_media_id',
        'price',
        'duration',
        'user_provides_media',
        'user_provides_links',
        'user_provides_description',
        'status',
        'admin_status',
        'created_at',
        'updated_at',
        'example_links',
        'example_image'
    ];

    public function influencer() {
        return $this->belongsTo('App\Socialmedia', 'social_media_id');
    }

    public function packages()
    {
        return $this->belongsToMany(Package::class);
    }

    public function post() {
        return $this->hasOne('App\Post', 'campaign_id');
    }
}
