<?php


namespace App;
use Illuminate\Database\Eloquent\Model;

class CartItem extends Model
{
    protected $dates = [
        'created_at',
        'updated_at',
    ];

    protected $fillable = [
        'campaign_id',
        'package_id',
        'cart_id',
        'no_of_items',
        'created_at',
        'updated_at',
    ];

    public function campaign() {
        return $this->belongsTo(Campaign::class);
    }

    public static function post($brandId, $campaignId, $cartId, $influencerId) {
        return Post::where('brand_id', $brandId)->where('campaign_id', $campaignId)->where('cart_id', $cartId)->where('influencer_id', $influencerId)->first();
    }
}
