<?php
use Illuminate\Support\Facades\DB;
use App\Order;
use App\Notification;
use App\NotificationEvent;
use App\Notifications\PushNotification;
function pushNotification($about, $event, $id1 = null, $id2 = null, $id3 = null, $id4 = null, $text1 = null, $text2 = null){
  $event_data = NotificationEvent::where('name' , $event)->first();
if($event_data) {
  if ($about == 'order') {
    $order_id = $id1;
    /*ORDER ARRIVED NOTIFICATION*/
    if ($event == 'order_arrived') {
      $order = Order::where('orders.id', $order_id)
          ->leftJoin('users as from_user', 'from_user.id', '=', 'orders.buyer_id')
          ->select(
              'orders.amount as price',
              'orders.seller_id',
              'orders.buyer_id',
              'from_user.name'
          )->first();

      $notification = new Notification();

      $notification->from_user_id = $order->buyer_id;
      $notification->to_user_id = $order->seller_id;
      $notification->message = str_replace('{%buyername%}', $order->name, str_replace('{%price%}', $order->price, $event_data->text));
      $notification->url = route('frontend.user.order_details', ['id' => $order_id]);

      $notification->save();
    } else {

      $notification = new Notification();

      $notification->from_user_id = $id3;
      $notification->to_user_id = $id4;

      $message = str_replace('{%influencer%}', '<a href="' . route('frontend.user.influencer_details', ['id' => (!is_null($id2) ? $id2 : 0)]) . '">@' . $text1 . '</a>', $event_data->text);
      $message = str_replace('{%buyername%}', $text2, $message);

      $notification->message = $message;
      $notification->url = route('frontend.user.order_details', ['id' => $order_id]);

      $notification->save();

    }
    if ($event_data->send_email == 1) {
      $user = \App\User::find($notification->to_user_id);
      try {
        $user->notify(new PushNotification($notification, $event_data));
      } catch (Exception $exception) {
        //dd($exception);
      }

    }
  } else if ($about == 'influencer') {
    $notification = new Notification();

    $notification->from_user_id = $id3;
    $notification->to_user_id = $id4;

    $message = str_replace('{%influencer%}', '<a href="' . route('frontend.user.influencer_details', ['id' => (!is_null($id2) ? $id2 : 0)]) . '">@' . $text1 . '</a>', $event_data->text);
    $message = str_replace('{%buyername%}', $text2, $message);

    $notification->message = $message;
    $notification->url = route('frontend.user.influencer_details', ['id' => (!is_null($id2) ? $id2 : 0)]);

    $notification->save();
    if ($event_data->send_email == 1) {
      $user = \App\User::find($notification->to_user_id);
      try {
        $user->notify(new PushNotification($notification, $event_data));
      } catch (Exception $exception) {
        //dd($exception);
      }

    }
  }
  elseif($about == 'ticket_response'){
    $notification = new Notification();
    $notification->from_user_id = Auth::user()->id;
    $notification->to_user_id = $id2;
    $message = $text1;
    $notification->message = $message;
    $notification->url = (!is_null($id1)) ? route('frontend.user.order_details', ['id' => $id1]) : '';
    $notification->save();
    if ($event_data->send_email == 1) {
      $user = \App\User::find($notification->to_user_id);
      try {
        if($user)
            $user->notify(new PushNotification($notification, $event_data));
      } catch (Exception $exception) {
        //dd($exception);
      }
    }
  }
}
}

function get_unread_notification_count(){
  $count = Notification::where('to_user_id' , Auth::user()->id)->where('status' , 'Unread')->count();
if($count > 0){
  return '<span class="notifi">'.$count.'</span>';
}
}
?>