<?php

namespace App\Http\Controllers\Admin;

use App\FailedTransfer;
use App\Http\Controllers\Controller;
use App\Order;
use Illuminate\Http\Request;

class PaymentsController extends Controller
{
    public function failed_index(){
      $failed_transfers = FailedTransfer::orderBy('created_at', 'desc')->get();

      return view('admin.failed_transfers.index', compact('failed_transfers'));
    }

    public function ignore($id) {
        $failed = FailedTransfer::find($id);
        $failed->status = 'seen by admin';
        $failed->save();
        return redirect('admin/failed_transfers');
    }

    public function refund($id) {
        $failed = FailedTransfer::find($id);
        if($failed->transaction_type == 'refund') {
            pay_to_buyer($failed->order_id);
        } else if($failed->transaction_type == 'release') {
            $order = Order::where('id', $failed->order_id)->first(['seller_id']);
            pay_to_seller($failed->order_id, $order->seller_id, $failed->amount);
        }
        return redirect('admin/failed_transfers');
    }

    public function show($id)
    {
        $failed = FailedTransfer::find($id);
        return view('admin.failed_transfers.show', ['failed' => $failed]);
    }

    public function massDestroy(Request $request)
    {
        FailedTransfer::whereIn('id', request('ids'))->delete();
        return 1;
    }
}
