<?php
/**
 * Created by PhpStorm.
 * User: Muhammad Adil
 * Date: 2/12/2021
 * Time: 4:07 PM
 */

namespace App\Http\Controllers\Admin;


use App\Http\Controllers\Controller;
use App\Http\Requests\MassDestroyServiceRequest;
use App\Http\Requests\StoreServiceRequest;
use App\Http\Requests\UpdateServiceRequest;
use App\Service;

class ServicesController extends Controller
{
    public function index() {
        $services = Service::orderBy('created_at', 'desc')->get();

        return view('admin.services.index', compact('services'));
    }

    public function create()
    {
        return view('admin.services.create');
    }

    public function store(StoreServiceRequest $request)
    {
        $service = Service::create($request->all());
        return redirect()->route('admin.services.index');
    }

    public function edit(Service $service)
    {
        $data = [
            'service' => $service,
        ];

        return view('admin.services.edit', $data);
    }

    public function update(UpdateServiceRequest $request, Service $service)
    {

        $service->update($request->all());
        return redirect()->route('admin.services.index');
    }

    public function show(Service $service)
    {
        return view('admin.services.show', compact('service'));
    }

    public function destroy(Service $service)
    {

        $service->delete();

        return back();
    }

    public function massDestroy(MassDestroyServiceRequest $request)
    {

        Service::whereIn('id', request('ids'))->delete();

        return response(null, 204);
    }

}