<?php


namespace App\Http\Controllers\Admin;
use App\Http\Controllers\Controller;
use App\Setting;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;


class SettingsController extends Controller
{
    public function index()
    {
        $timezonesList = \DateTimeZone::listIdentifiers(\DateTimeZone::ALL);
        $settings = Setting::settings_array();
        $data = ['timezonesList' => $timezonesList, 'settings' => $settings];

        return view('admin.settings', $data);
    }
    public function validateRequest(Request $request) {

        $validatedData = $request->validate([
            'email' => ['required', 'string', 'email', 'max:255'],
            
            'phone' => ['required', 'numeric', 'digits_between:10,11']
        ]);
        return $validatedData;
    }
    public function save(Request $request)
    {
        $validatedData = $request->validate([
            'timezone' => 'required',
            'site_name' => 'required',
        ]);
        config(['app.timezone' => $request->timezone]);
        date_default_timezone_set($request->timezone);
        $keysArray = [
            'timezone'=>$request->timezone,
            'site_title'=>$request->site_name,
            'project_title'=>$request->project_name,
            'address'=>$request->address,
            'email'=>$request->email,
            'phone'=>$request->phone,
            'show_influencers' => $request->show_influencers,
            'address' => $request->address
        ];
        foreach($keysArray as $key=>$value) {
            $settings = Setting::where('key', $key)->update(array('value' => $value));
        }
        return back()->with('success', 'Settings Updated Successfully.');
    }
}
