<?php


namespace App\Http\Controllers\Admin;
use App\Http\Controllers\Controller;
use App\Tag;
use App\User;
use Illuminate\Http\Request;

class TagUsersController extends Controller
{
    public function index() {
        $users = User::all();

        return view('admin.tag_users.index', compact('users'));
    }

    public function edit($id) {

        $user = User::find($id);
        $tags = Tag::all()->pluck('title', 'id');
        $data = [
            'user' => $user,
            'tags' => $tags
        ];
        return view('admin.tag_users.edit', $data);

    }

    public function update(Request $request) {
        $user = User::find($request->user_id);
        $user->tags()->sync($request->input('tags', []));

        return redirect()->route('admin.tag_users.index');
    }
}
