<?php


namespace App\Http\Controllers\Admin;
use App\Http\Controllers\Controller;
use App\Http\Requests\MassDestroyTagRequest;
use App\Http\Requests\StoreTagRequest;
use App\Http\Requests\UpdateTagRequest;
use App\Tag;

class TagsController extends Controller
{
    public function index() {
        $tags = Tag::orderBy('created_at', 'desc')->get();

        return view('admin.tags.index', compact('tags'));
    }

    public function create()
    {
        return view('admin.tags.create');
    }

    public function store(StoreTagRequest $request)
    {
        $tag = tag::create($request->all());
        return redirect()->route('admin.tags.index');
    }

    public function edit(Tag $tag)
    {
        $data = [
            'tag' => $tag,
        ];

        return view('admin.tags.edit', $data);
    }

    public function update(UpdateTagRequest $request, Tag $tag)
    {

        $tag->update($request->all());
        return redirect()->route('admin.tags.index');
    }

    public function show(Tag $tag)
    {
        return view('admin.tags.show', compact('tag'));
    }

    public function destroy(Tag $tag)
    {

        $tag->delete();

        return back();
    }

    public function massDestroy(MassDestroyTagRequest $request)
    {

        Tag::whereIn('id', request('ids'))->delete();

        return response(null, 204);
    }
}
