<?php


namespace App\Http\Controllers\Frontend;
use App\Http\Controllers\Controller;
use App\Notification;
use App\Order;
use App\Role;
use App\Socialmedia;
use App\Ticket;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class TicketsController extends Controller
{
    public function index() {

    }

    public function create() {

        $user = Auth::user();
        /*$users = Role::users_not_admin($user);*/
        $socials = Socialmedia::where('status', 'Verified')->select('id', 'account_handle', 'account_type')->orderBy('account_handle')->get();
        $data = [
            'socials' => $socials,
            'user' => $user
        ];
        return view('frontend.create_ticket', $data);
    }

    public function store(Request $request)
    {
        $order_id = ($request->order_id) ? $request->order_id : null;
        $influencer_id = ($request->influencer_id) ? $request->influencer_id : null;
        $against_user_id = ($request->against_user_id) ? $request->against_user_id : 0;

        $ticket = new Ticket();

        if($influencer_id != null || $influencer_id != 0){
          $against_influencer   = Socialmedia::where('id' , $influencer_id)->first();
          if($against_influencer){
            $ticket->influencer_id = $influencer_id;
            $against_user_id = $against_influencer->user_id;
          }
        }

        $ticket->user_id = Auth::user()->id;
        $ticket->subject = $request->subject;
        $ticket->against_user_id = $against_user_id;
        $ticket->type = $request->type;
        $ticket->status = 'Initiated';
        $ticket->description = $request->description;
        $ticket->order_id = $order_id;
        $ticket->save();

      if(!is_null($order_id)){
        Order::find($order_id)->update(['status' => 'reopened']);

        pushNotification('order' , 'order_ticketed' , $order_id, null, Auth::user()->id, $against_user_id, null, Auth::user()->name);
      }

      if(!is_null($influencer_id)){
        if($against_influencer){
          pushNotification('influencer', 'ticket_against_influencer', null, $influencer_id, Auth::user()->id, $against_user_id,$against_influencer->account_handle, Auth::user()->name);
        }
      }

      // notification to admin
        $admins = User::where('role_id', 1)->get();
        foreach ($admins as $admin) {
            $notification = new Notification();

            $notification->from_user_id = $ticket->user_id;
            $notification->to_user_id = $admin->id;
            $notification->ticket_id = $ticket->id;

            $message = 'A new ticket has been created. Please go to tickets for details.';

            $notification->message = $message;
            $notification->url = url('admin/tickets/'. $ticket->id);
            $notification->save();
        }
      // notification to admin ends
        return redirect()->back()->with('success', 'Your Ticket is generated and a Notification is sent to Admin.');
    }
}
