<?php


namespace App\Http\Controllers\Frontend;
use App\Campaign;
use App\Cart;
use App\CartItem;
use App\Http\Controllers\Controller;
use App\PaymentAccount;
use App\Post;
use App\Role;
use App\Socialmedia;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use App\Traits\UploadTrait;

class UserCampaignsController extends Controller
{
  use UploadTrait;
    public function changeStatus($id, $status) {
        if(!Auth::check()) {
            return redirect('/')->with('error', 'You are not Logged in.');
        }
        /*$user = Auth::user();
        if($user->role->title != 'User') {
            return 'You do not have permissions to this page.';
        }*/
        /*if($status == 'enabled' || $status == 'disabled') {
            $campaign = Campaign::find($id);
            $campaign->status = $status;
            $campaign->save();
            return back()->with('success', 'Campaign Status Changed Successfully');
        } else {
            $campaign = Post::find($id);
            $campaign->status = $status;
            $campaign->save();
            $campaigns = $user->posts()->where('status', 'in-progress')->paginate(10);
            $data = [
                'campaigns' => $campaigns
            ];
            return view('partials.campaigns_table_ajax', $data);
        }*/
        $campaign = Campaign::where('campaigns.id' , $id)
                      ->leftJoin('socialmedias' , 'socialmedias.id' ,'=', 'campaigns.social_media_id')
                      ->get('socialmedias.user_id', 'campaigns.status')->first();

      if(Auth::user()->id != $campaign->user_id){
        return response()->json(['status' => 1]);
      }

      if($status == 'enabled'){
        Campaign::find($id)->update(['status' => 'enabled']);
      }else if($status == 'disabled'){
        Campaign::find($id)->update(['status' => 'disabled']);
      }

      return response()->json(['status' => 0]);
    }

    public function create($media_account_id) {
        if(!Auth::check()) {
            return redirect('/')->with('error', 'You are not Logged in.');
        }
        $user = Auth::user();

        $check_accounts = PaymentAccount::where('user_id' , $user->id)->first();
        if(!$check_accounts){
          return redirect()->route('frontend.user.addPayments')->with('redirect_url', route('frontend.user.create_campaign', ['media_account_id' => $media_account_id]));
        }

        $social_account = Socialmedia::find($media_account_id);
        if($social_account->status != 'Verified'){
          return redirect('/');
        }
        if(Auth::user()->id != $social_account->user_id){
          return redirect('/');
        }
        
        /*if($user->role->title != 'User') {
            return 'You do not have permissions to this page.';
        }*/
        $data = [
            'user' =>$user,
            'media_account_id' => $media_account_id
        ];
        return view('frontend.create_campaign', $data);
    }


    public function validateRequest(Request $request) {

        $validatedData = $request->validate([
            'title' => ['required', 'string', 'max:255'],
            /*'duration' => ['required', 'numeric', 'max:9999999999'],*/
            'price' => ['required', 'numeric', 'max:9999999999']
        ]);
        return $validatedData;
    }

    public function store(Request $request) {
        $this->validateRequest($request);
        if(!Auth::check()) {
            return redirect('/')->with('error', 'You are not Logged in.');
        }
       /* $user = Auth::user();
        if($user->role->title != 'User') {
            return 'You do not have permissions to this page.';
        }*/
       ($request->user_provides_media) ? $media =1 : $media =0;
       ($request->user_provides_links) ? $links =1 : $links =0;
       ($request->user_provides_description) ? $description =1 : $description =0;

        $campaign = Campaign::create([
            'title' => $request->title,
            'description' => $request->description,
            'price' => $request->price,
            /*'duration' => $request->duration,*/
            'social_media_id' => $request->social_media_id,
            'user_provides_media' => $media,
            'user_provides_links' => $links,
            'user_provides_description' => $description,
            'status' => 'enabled',
            'admin_status' => 'approved',
            'example_links' => $request->example_links
        ]);
        $this->uploadCampaignImage($request , $campaign);
        return redirect()->route('frontend.user.campaigns', ['status' => 'all']);
    }

    public function edit( $id ) {
        if(!Auth::check()) {
            return redirect('/')->with('error', 'You are not Logged in.');
        }
        $user = Auth::user();
        /*if($user->role->title != 'User') {
            return 'You do not have permissions to this page.';
        }*/
        $campaign = Campaign::where('campaigns.id' , $id)
          ->leftJoin('socialmedias' , 'socialmedias.id' ,'=', 'campaigns.social_media_id')
          ->select('campaigns.*','socialmedias.user_id')->first();
      $user = Auth::user();
      if($campaign->user_id != $user->id){
        return redirect('/')->with('error', 'Not Allowed');
      }

        $data = [
            'campaign' => $campaign,
            'user' =>$user
        ];

        return view('frontend.edit_campaign', $data);
    }

    public function update(Request $request) {
        if(!Auth::check()) {
            return redirect('/')->with('error', 'You are not Logged in.');
        }
        $user = Auth::user();
        /*if($user->role->title != 'User') {
            return 'You do not have permissions to this page.';
        }*/
        ($request->user_provides_media) ? $media =1 : $media =0;
        ($request->user_provides_links) ? $links =1 : $links =0;
        ($request->user_provides_description) ? $description =1 : $description =0;
        $campaign = Campaign::find($request->id);
        $campaign->update([
          'title' => $request->title,
          'description' => $request->description,
          'price' => $request->price,
          /*'duration' => $request->duration,*/
          'user_provides_media' => $media,
          'user_provides_links' => $links,
          'user_provides_description' => $description,
          'example_links' => $request->example_links
      ]);
        $this->uploadCampaignImage($request, $campaign);
        return redirect()->route('frontend.user.campaigns', ['status' => 'all']);
    }

    public function delete($id){
      if(!Auth::check()) {
        return redirect('/')->with('error', 'You are not Logged in.');
      }

      $owner = Campaign::where('campaigns.id' , $id)
          ->leftJoin('socialmedias' , 'socialmedias.id' ,'=', 'campaigns.social_media_id')
          ->get('socialmedias.user_id')->first();

      if($owner->user_id == Auth::user()->id){
        Campaign::find($id)->delete();
      }
      return redirect()->back();
    }

  public function uploadCampaignImage(Request $request, Campaign $camp){
    // Check if a profile image has been uploaded
    if ($request->has('example_image')) {
      // Get image file
      $image = $request->file('example_image');
      // Make a image name based on user name and current timestamp
      $name = $camp->id .'_example';
      // Define folder path
      $folder = '/uploads/campaign_example/';
      // Make a file path where image will be stored [ folder path + file name + file extension]
      $extension = $image->getClientOriginalExtension();
      $filePath = $folder . $name. '.' . $extension;
      // Upload image
      $this->uploadOne($image, $folder, 'public', $name);
      // Set user profile image path in database to filePath
      $camp->example_image = $folder.$name . '.' . $extension;
    }
    // Persist user record to database
    $camp->save();
  }
}
