<?php


namespace App\Http\Controllers\Frontend;
use App\Http\Controllers\Controller;
use App\Notification;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class UserNotificationsController extends Controller
{
    public function create() {
        if(!Auth::check()) {
            return redirect('/')->with('error', 'You are not Logged in.');
        }
        $user = Auth::user();
        $users = User::where('id', '!=', $user->id)->get();
        $data = [
            'users' => $users
        ];
        return view('frontend.create_notification', $data);
    }

    public function store(Request $request) {
        if(!Auth::check()) {
            return redirect('/')->with('error', 'You are not Logged in.');
        }
        $user = Auth::user();

        $notification = New Notification();
        $notification->from_user_id = $user->id;
        $notification->to_user_id = $request->to_user_id;
        $notification->message = $request->message;
        $notification->save();
        return back()->with('success', 'Notification successfully sent.');
    }
}
