<?php


namespace App\Http\Controllers\Frontend;
use App\Campaign;
use App\Cart;
use App\CartItem;
use App\Http\Controllers\Controller;
use App\Package;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class UserPackagesController extends Controller
{
    public function index() {
        if(!Auth::check()) {
            return redirect('/')->with('error', 'You are not Logged in.');
        }
        $user = Auth::user();
        $packages = Package::where('admin_id', $user->id)->get();
        $data = [
            'packages' => $packages
        ];
        return view('frontend.cart.package_list', $data);
    }

    public function create() {

        if(!Auth::check()) {
            return redirect('/')->with('error', 'You are not Logged in.');
        }
        $user = Auth::user();
        $campaigns = Campaign::all();
        $data = [
            'campaigns' => $campaigns,
            'user' => $user
        ];

        return view('frontend.cart.package_create', $data);
    }

    public function store(Request $request) {
        if(!Auth::check()) {
            return redirect('/')->with('error', 'You are not Logged in.');
        }
        $user = Auth::user();

        $package = Package::create($request->all());
        $package->campaigns()->sync($request->input('campaigns', []));
        return redirect()->route('frontend.user.packages');
    }
}
