<?php

namespace App\Http\Controllers;

use App\Review;
use App\Socialmedia;
use App\SocialmediaObject;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    /*public function __construct()
    {
        $this->middleware('auth');
    }*/

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        $socialMediaObject = new SocialmediaObject();
        //$socialMediaEarnings = $socialMediaObject->getRecordWithMaxEarning();

        if(Auth::check()) {
            $user = Auth::user();
            if( $user->role->title == 'Admin' ) {
                return redirect()->route('admin.home');
            }
        }

        $data = [];

        if( trans('global.show_influencers') == 'Yes' ) {

            $featuredInfluencers = Socialmedia::where('is_featured', 1)->get();
            /*$feedsDetails = [];
            foreach ($featuredInfluencers as $influencer) {
                    $feedsDetails[$influencer->id]['profile_picture'] = $influencer->profile_picture;
                    $feedsDetails[$influencer->id]['account_name'] = $influencer->account_name;
                    $feedsDetails[$influencer->id]['account_handle'] = $influencer->account_handle;
                    $feedsDetails[$influencer->id]['followers_count'] = $influencer->followers_count;
                    $feedsDetails[$influencer->id]['avg_likes'] = $influencer->avg_likes;
                    $feedsDetails[$influencer->id]['avg_comments'] = $influencer->avg_comments;
                    $feedsDetails[$influencer->id]['total_posts'] = $influencer->total_posts;

                    $socialMediaObject = new SocialmediaObject();
                    $cloutsource_score = $socialMediaObject->getCloutSourceScore($influencer->id);
                    $feedsDetails[$influencer->id]['score'] = $cloutsource_score;
                } else if ($socialMedia) {
                    $socialMediaObject = new SocialmediaObject();
                    $initialisedSocialMediaObject = $socialMediaObject->initializeSocialMediaObject($socialMedia->account_type, $socialMedia->account_handle);
                    $feeds = $initialisedSocialMediaObject->getSocialAccountFeedsDetails();
                    foreach ($feeds as $key => $value) {
                        $feedsDetails[$influencer->id][$key] = $value;
                    }
                    $feedsDetails[$influencer->id]['score'] = $socialMediaObject->getScore();
                }
            }
            $data ['feedsDetails'] = $feedsDetails;*/
            $data ['featuredInfluencers'] = $featuredInfluencers;
        }

        $reviews = Review::all();
        $data ['reviews'] = $reviews;
        //$data ['socialMediaEarnings'] = $socialMediaEarnings;

        return view('homepage', $data);
    }

    public function getAccountValue($accountHandle) {

        $socialMediaObject = new SocialmediaObject();
        $socialMediaEarnings = $socialMediaObject->getSocialAccountEarningValue($accountHandle);
        if($socialMediaEarnings) {
            $data = [
                'socialMediaEarnings' => $socialMediaEarnings
            ];
            return view('partials.ajax_homepage_earnings', $data);
        } else {
            return 'invalid_account_handle_error';
        }
    }
}
