<?php

namespace App\Http\Middleware;

use App\Role;
use Closure;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Gate;

class AuthGates
{
    public function handle($request, Closure $next)
    {
        $user = \Auth::user();

        if (!app()->runningInConsole() && $user) {
            $roles = Role::with('permissions')->get();

            foreach ($roles as $role) {
                foreach ($role->permissions as $permissions) {
                    $permissionsArray[$permissions->title][] = $role->id;
                }
            }

            foreach ($permissionsArray as $title => $roles) {
                Gate::define($title, function (\App\User $user) use ($roles) {
                    return count(array_intersect([$user->role->id], $roles)) > 0;
                });
            }
        }

        $currentRouteAction = \Route::getCurrentRoute()->getActionName();

        if ( strpos($currentRouteAction, 'App\Http\Controllers\Admin') !== false && Auth::check() ) {
            if($user->role->title != 'Admin') {
                return redirect('/')->with('error','You do not have permissions to Admin Panel.');
            }
        }

        return $next($request);
    }
}
