<?php

namespace App\Http\Requests;

use App\User;
use Illuminate\Foundation\Http\FormRequest;

class StoreUserRequest extends FormRequest
{
    public function authorize()
    {
        return \Gate::allows('user_create');
    }

    public function rules()
    {
        return [
            'name'     => [
                'required', 'string', 'max:255'
            ],
            'email'    => [
                'required','required', 'string', 'email', 'max:255', 'unique:users'
            ],
            'password' => [
                'required','string', 'min:8'
            ],
            'phone'  => [
                'required', 'numeric', 'digits_between:10,15'
            ],
            'country'  => [
                'nullable', 'string'
            ],
            'city'  => [
                'nullable', 'string'
            ],
            'zip_code'  => [
                'nullable', 'string'
            ]
        ];
    }
}
