<?php

namespace App\Http\Requests;

use App\User;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Support\Facades\Auth;

class UpdateProfileRequest extends FormRequest
{
    public function authorize()
    {
        return \Gate::allows('user_edit');
    }

    public function rules()
    {
        return [
            'name'     => [
                'required', 'string', 'max:255'
            ],
            'email'    => [
                'required', 'string', 'email', 'max:255', 'unique:users,email,' . $this->user_id
            ],
            'password' => [
                'nullable','string', 'min:8'
            ],
            'phone'  => [
                'required', 'numeric', 'digits_between:10,11'
            ]
        ];
    }
}