<?php

namespace App\Http\Requests;

use App\User;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Support\Facades\Auth;

class UpdateUserRequest extends FormRequest
{
    public function authorize()
    {
        return \Gate::allows('user_edit');
    }

    public function rules()
    {
        return [
            'name'     => [
                'required', 'string', 'max:255'
            ],
            'email'    => [
                'required', 'string', 'email', 'max:255', 'unique:users,email,' . $this->user_id
            ],
            'phone'  => [
                'required', 'numeric', 'digits_between:10,15'
            ],
            'country'  => [
                'nullable', 'string'
            ],
            'city'  => [
                'nullable', 'string'
            ],
            'zip_code'  => [
                'nullable', 'string'
            ]
        ];
    }
}
