<?php

namespace App\Notifications;

use Illuminate\Auth\Notifications\ResetPassword;
use Illuminate\Notifications\Messages\MailMessage;

class ResetPasswordNotification extends ResetPassword
{
    /**
     * Build the mail representation of the notification.
     *
     * @param  mixed  $notifiable
     * @return \Illuminate\Notifications\Messages\MailMessage
     */
    public function toMail($notifiable)
    {
        if (static::$toMailCallback) {
            return call_user_func(static::$toMailCallback, $notifiable, $this->token);
        }

        $notifiableArray = json_decode($notifiable, TRUE);

        return (new MailMessage)
            ->view(
                'auth.emails.password', ['token' => $this->token, 'email' => $notifiableArray['email']]
            )
            ->subject('Reset Password Notification');
    }
}
