<?php


namespace App;
use Illuminate\Database\Eloquent\Model;

class Order extends Model
{
    protected $dates = [
        'created_at',
        'updated_at',
    ];

    protected $fillable = [
        'name',
        'brand_id',
        'influencer_id',
        'seller_id',
        'package_id',
        'amount',
        'status',
        'created_at',
        'updated_at',
    ];

    public function campaigns() {
        return $this->belongsToMany(Campaign::class);
    }

    public function post() {
        return $this->belongsTo(Post::class, 'post_id');
    }

    public function buyer() {
        return $this->belongsTo(User::class, 'buyer_id');
    }

    public function seller() {
        return $this->belongsTo(User::class, 'seller_id');
    }
}
