<?php


namespace App;
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    protected $dates = [
        'created_at',
        'updated_at',
    ];

    protected $fillable = [
        'campaign_id',
        'brand_id',
        'cart_id',
        'influencer_id',
        'description',
        'image',
        'status',
        'social_media_flag',
        'brand_web_link',
        'start_date',
        'created_at',
        'updated_at',
        'link'
    ];

    public function campaign() {
        return $this->belongsTo(Campaign::class, 'campaign_id');
    }

    public function influencer() {
        return $this->belongsTo(User::class, 'influencer_id');
    }

    public function cart() {
        return $this->belongsTo(Cart::class, 'cart_id');
    }
}
