<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Role extends Model
{
    use SoftDeletes;

    protected $dates = [
        'created_at',
        'updated_at',
        'deleted_at',
    ];

    protected $fillable = [
        'title',
        'created_at',
        'updated_at',
        'deleted_at',
    ];

    public function permissions()
    {
        return $this->belongsToMany(Permission::class);
    }

    public static function users_not_admin($excludeUser){
        $roleAdmins = Role::where('title', 'Admin')->pluck('id');
        $roleAdminsArray = [];
        foreach ($roleAdmins as $key => $roleAdmin) {
            $roleAdminsArray[] = $roleAdmin;
        }
        $users = User::whereNotIn('role_id', $roleAdminsArray)->where('id', '!=', $excludeUser->id)->get();
        return $users;
    }

    public function users() {
        return $this->hasMany('App\User', 'role_id');
    }
}
