<?php


namespace App;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
class Socialmedia extends Model
{
    use SoftDeletes;
    protected $table = 'socialmedias';
    protected $dates = [
        'created_at',
        'updated_at',
    ];

    protected $fillable = [
        'user_id',
        'account_handle',
        'account_type',
        'verification_code',
        'status',
    ];

    public function owner(){
      $this->belongsTo('App\User' , 'user_id');
    }

    public function services() {
        return $this->belongsToMany(Service::class, 'service_socialmedia', 'service_id', 'socialmedia_id');
    }
}
