<?php


namespace App;
use Illuminate\Database\Eloquent\Model;


class Ticket extends Model
{
    protected $dates = [
        'created_at',
        'updated_at',
    ];

    protected $fillable = [
        'subject',
        'user_id',
        'against_user_id',
        'type',
        'status',
        'description',
        'created_at',
        'updated_at',
    ];

    public function user() {
        return $this->belongsTo('App\User', 'user_id');
    }

    public function against_user() {
        return $this->belongsTo('App\User', 'against_user_id');
    }

    public function order() {
        return $this->belongsTo('App\Order', 'order_id');
    }

}
