<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class Create1555355612782UsersTable extends Migration
{
    public function up()
    {
        Schema::create('users', function (Blueprint $table) {
            $table->increments('id');
            $table->integer('role_id')->unsigned();
            $table->foreign('role_id')->references('id')->on('roles');
            $table->string('name');
            $table->string('email');
            $table->string('username')->default('');
            $table->string('timezone')->default('')->nullable();
            $table->string('skype')->default('')->nullable();
            $table->string('website')->default('')->nullable();
            $table->string('phone');
            $table->datetime('email_verified_at')->nullable();
            $table->string('password');
            $table->string('remember_token')->nullable();
            $table->string('verify_token')->nullable();
            $table->string('status')->default('Inactive');
            $table->string('referral_code')->default('');
            $table->boolean('is_featured')->default(0);
            $table->timestamps();
            $table->softDeletes();
        });
    }

    public function down()
    {
        Schema::dropIfExists('users');
    }
}
