<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreatePostsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('posts', function (Blueprint $table) {
            $table->increments('id');
            $table->integer('campaign_id')->unsigned();
            $table->foreign('campaign_id')->references('id')->on('campaigns');
            $table->integer('brand_id')->unsigned();
            $table->foreign('brand_id')->references('id')->on('users');
            $table->integer('influencer_id')->default(0);
            $table->integer('cart_id')->default(0);
            $table->text('description');
            $table->string('image');
            $table->string('status')->default('new');
            $table->string('social_media_flag')->default('');
            $table->string('brand_web_link')->default('');
            $table->dateTime('start_date');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('posts');
    }
}
