<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateFeaturedInfluencers extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('featured_influencers', function (Blueprint $table) {
            $table->increments('id');
            $table->integer('influencer_id')->unsigned();
            $table->foreign('influencer_id')->references('id')->on('users');
            $table->boolean('is_featured')->default(0);
            $table->boolean('show_on_frontend')->default(0);
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('featured_influencers');
    }
}
