<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddAdressColumnsToSocialmedias extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('socialmedias', function (Blueprint $table) {
            $table->string('country')->nullable()->after('earning');
            $table->string('city')->nullable()->after('country');
            $table->string('zip_code')->nullable()->after('city');
            $table->text('extra_note')->nullable()->after('zip_code');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('socialmedias', function (Blueprint $table) {
            $table->dropColumn('country');
            $table->dropColumn('city');
            $table->dropColumn('zip_code');
            $table->dropColumn('extra_note');
        });
    }
}
