@extends('layouts.admin')
@section('content')

<div class="card">
    <div class="card-header">
        {{ trans('global.create') }} {{ trans('global.campaign.title_singular') }}
    </div>

    <div class="card-body">
        <form action="{{ route("admin.campaigns.store") }}" method="POST" enctype="multipart/form-data">
            @csrf

            <div class="form-group {{ $errors->has('name') ? 'has-error' : '' }}">
                <label for="start_date">{{ trans('global.campaign.fields.name') }}</label>
                <input type="text" name="name" class="form-control">
                @if($errors->has('name'))
                    <em class="invalid-feedback">
                        {{ $errors->first('name') }}
                    </em>
                @endif
                <p class="helper-block">
                    {{ trans('global.campaign.fields.name_helper') }}
                </p>
            </div>

            <div class="form-group {{ $errors->has('influencer_id') ? 'has-error' : '' }}">
                <label for="influencer_id">{{ trans('global.campaign.fields.influencer_name') }}*</label>
                <select  class="form-control" name="influencer_id">
                    @foreach($influencers as $influencer)
                        <option value="{{ $influencer->id }}">{{ $influencer->name }}</option>
                    @endforeach
                </select>

                @if($errors->has('influencer_id'))
                    <em class="invalid-feedback">
                        {{ $errors->first('influencer_id') }}
                    </em>
                @endif
                <p class="helper-block">
                    {{ trans('global.campaign.fields.influencer_name_helper') }}
                </p>
            </div>

            <div class="form-group {{ $errors->has('price') ? 'has-error' : '' }}">
                <label for="price">{{ trans('global.campaign.fields.price') }}</label>
                <input type="text" name="price" class="form-control">
                @if($errors->has('price'))
                    <em class="invalid-feedback">
                        {{ $errors->first('price') }}
                    </em>
                @endif
                <p class="helper-block">
                    {{ trans('global.campaign.fields.name_helper') }}
                </p>
            </div>

            <div class="form-group {{ $errors->has('duration') ? 'has-error' : '' }}">
                <label for="price">{{ trans('global.campaign.fields.duration') }}</label>
                <input type="text" name="duration" class="form-control">
                @if($errors->has('duration'))
                    <em class="invalid-feedback">
                        {{ $errors->first('duration') }}
                    </em>
                @endif
                <p class="helper-block">
                    {{ trans('global.campaign.fields.duration_helper') }}
                </p>
            </div>

            <div>
                <input class="btn btn-danger" type="submit" value="{{ trans('global.save') }}">
            </div>
        </form>
    </div>
</div>

@endsection
