@extends('layouts.admin')
@section('content')
    <div class="card">
        <div class="card-header">
            {{ trans('global.campaign.title_singular') }} {{ trans('global.list') }}

            <a class="btn btn-success" href="{{ route("admin.campaigns.create") }}" style="float: right; display: none;">
                {{ trans('global.add') }} {{ trans('global.campaign.title_singular') }}
            </a>

        </div>

        <div class="card-body">
            <div class="table-responsive">
                <table class=" table table-bordered table-striped table-hover datatable">
                    <thead>
                    <tr>
                        <th width="10">

                        </th>
                        <th>
                            {{ trans('global.campaign.fields.name') }}
                        </th>
                        <th>
                            {{ trans('global.campaign.fields.desc') }}
                        </th>
                        <th>
                            {{ trans('global.campaign.fields.influencer_name') }}
                        </th>
                        <th>
                            {{ trans('global.campaign.fields.price') }}
                        </th>

                        <th>
                            &nbsp;Actions
                        </th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach($campaigns as $key => $campaign)
                        <tr data-entry-id="{{ $campaign->id }}">
                            <td>

                            </td>
                            <td>
                                {{ $campaign->title ?? '' }}
                            </td>
                            <td>
                                {{ $campaign->description ?? '' }}
                            </td>
                            <td>
                                {{ '@'.$campaign->account_handle ?? '' }}
                            </td>
                            <td>
                                {{ $campaign->price ?? '' }}
                            </td>

                            <td>

                                    <a class="btn btn-xs btn-primary" href="{{ url('frontend/influencer/' . $campaign->social_media_id . '?scroll=1') }}">
                                        {{ trans('global.view') }}
                                    </a>
                                    <a class="btn btn-xs btn-danger" href="#" style="cursor: pointer" onclick="deleteCampaign({{ $campaign->id }})">
                                        Delete
                                    </a>

                                
                                       
                                    </a>
                                    <form id="delete_form_{{ $campaign->id }}" action="{{ route('admin.campaigns.destroy', $campaign->id) }}" method="POST" onsubmit="return confirm('{{ trans('global.areYouSure') }}');" style="display:none;" >
                                            <input type="hidden" name="_method" value="DELETE">
                                            <input type="hidden" name="_token" value="{{ csrf_token() }}">   
                                        </form>
                                    
                                    {{-- <a class="btn btn-xs btn-info" href="{{ route('admin.campaigns.edit', $campaign->id) }}">
                                        {{ trans('global.edit') }}
                                    </a>

                                    <form action="{{ route('admin.campaigns.destroy', $campaign->id) }}" method="POST" onsubmit="return confirm('{{ trans('global.areYouSure') }}');" style="display: inline-block;">
                                        <input type="hidden" name="_method" value="DELETE">
                                        <input type="hidden" name="_token" value="{{ csrf_token() }}">
                                        <input type="submit" class="btn btn-xs btn-danger" value="{{ trans('global.delete') }}">
                                    </form> --}}

                            </td>

                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
        </div>
    </div>
@section('scripts')
    @parent
    <script>
        $(function () {
            let deleteButtonTrans = '{{ trans('global.datatables.delete') }}'
            let deleteButton = {
                text: deleteButtonTrans,
                url: "{{ route('admin.campaigns.massDestroy') }}",
                className: 'btn-danger',
                action: function (e, dt, node, config) {
                    var ids = $.map(dt.rows({ selected: true }).nodes(), function (entry) {
                        return $(entry).data('entry-id')
                    });

                    if (ids.length === 0) {
                        alert('{{ trans('global.datatables.zero_selected') }}')

                        return
                    }

                    if (confirm('{{ trans('global.areYouSure') }}')) {
                        $.ajax({
                            headers: {'x-csrf-token': _token},
                            method: 'POST',
                            url: config.url,
                            data: { ids: ids, _method: 'DELETE' }})
                            .done(function (data) {
                                if(data == 'query_error') {
                                    alert('Cannot delete some campaigns, campaigns are found in In-Progress Orders.');
                                } else {
                                    location.reload()
                                }
                            })
                    }
                }
            }
            let dtButtons = $.extend(true, [], $.fn.dataTable.defaults.buttons)

            dtButtons.push(deleteButton)


            $('.datatable:not(.ajaxTable)').DataTable({ buttons: dtButtons })
        })

        function deleteCampaign(id) {
            if (confirm('{{ trans('global.areYouSure') }}')) {
                document.getElementById('delete_form_' + id).submit();
            }
        }

    </script>
@endsection
@endsection
