@extends('layouts.app')
@section('content')
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card-group">
                <div class="card p-4">
                    <div class="card-body">
                        <form id="emailForm" method="POST" action="{{ route('password.email') }}">
                            {{ csrf_field() }}
                            <input type="hidden" id="forget_token" value="{{ csrf_token() }}">
                            <input type="hidden" id="forget_route" value="{{ route('auth.validate_email') }}">
                            <h1>
                                <div class="login-logo">
                                    <a href="#">
                                        {{ trans('global.site_title') }}
                                    </a>
                                </div>
                            </h1>
                            <p class="text-muted"></p>
                            <div>
                                <div class="form-group has-feedback">
                                    <input type="email" name="email" id="forget_email" class="form-control" required="required" placeholder="{{ trans('global.login_email') }}">
                                    <em id="email-error" class="invalid-feedback"></em>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-12 text-right">
                                    <button type="button" onclick="validateEmail();" class="btn btn-primary btn-block btn-flat">
                                        Reset
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

<script src="{{ asset('frontend/js/jquery.js') }}"></script>
<script>

    window.validateEmail = function() {
        var email = $('#forget_email').val();
        var route = $('#forget_route').val();
        var token = $('#forget_token').val();
        var dataString = 'email='+ email + '&_token=' + token + '&admin_forget_password=1';
        $('#loading-div').show();
        $.ajax({
            type: "POST",
            url: route,
            data: dataString,
            success: function( data ) {
                $('#loading-div').hide();

                if(data == 'Success') {
                    $('#emailForm').submit();
                } else {
                    $('#email-error').show();
                    $('#email-error').html(data);
                }
            }

        });
    }
</script>
