@extends('layouts.admin')
@section('content')
    <div class="card">
        <div class="card-header">
            Failed Transfers
        </div>

        <div class="card-body">

                <table class="table table-bordered table-striped table-hover datatable table-responsive">
                    <thead>
                    <tr>
                        <th></th>
                        <th>Order ID</th>
                        <th>Amount</th>
                        <th>Payment Type</th>
                        <th>Transaction Type</th>
                        <th>Response</th>
                        <th>Status</th>
                        <th>Actions</th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach($failed_transfers as $key => $failed)
                        <tr data-entry-id="{{ $failed->id }}">
                            <td></td>
                            <td>{{ $failed->order_id }}</td>
                            <td>{{ $failed->amount }}</td>
                            <td>{{ $failed->payment_type }}</td>
                            <td>{{ $failed->transaction_type }}</td>
                            <td style="max-width: 400px;">{{ $failed->response_msg }}</td>
                            <td>
                                @if($failed->status == 'pending')
                                    <span class="badge badge-warning btn-sm">{{ $failed->status }}</span>
                                @else
                                    <span class="badge badge-info btn-sm">{{ $failed->status }}</span>
                                @endif
                            </td>
                            <td>
                                <a class="btn btn-xs btn-primary" href="{{ route('admin.failed_transfers.show', $failed->id) }}">
                                    View Campaign
                                </a>

                                <a class="btn btn-xs btn-primary" href="{{ url('frontend/order_details/'. $failed->order_id) }}">
                                    View Order
                                </a>

                                @if($failed->status == 'pending')
                                    <a href="{{ url('admin/failed_transfers/ignore/' . $failed->id) }}"><button class="btn btn-info">Ignore</button></a></li>
                                @endif
                                @if($failed->status != 'successful')
                                    <a href="{{ url('admin/failed_transfers/refund/' . $failed->id) }}"><button class="btn btn-success">Retry</button></a></li>
                                @endif

                            </td>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
        </div>
    </div>
@section('scripts')
    @parent
    <script>
        $(function () {
            let deleteButtonTrans = '{{ trans('global.datatables.delete') }}'
            let deleteButton = {
                text: deleteButtonTrans,
                url: "{{ url('admin/failed_transfers/mass_destroy') }}",
                className: 'btn-danger',
                action: function (e, dt, node, config) {
                    var ids = $.map(dt.rows({ selected: true }).nodes(), function (entry) {
                        return $(entry).data('entry-id')
                    });

                    if (ids.length === 0) {
                        alert('{{ trans('global.datatables.zero_selected') }}')

                        return
                    }

                    if (confirm('{{ trans('global.areYouSure') }}')) {
                        $.ajax({
                            method: 'GET',
                            url: config.url,
                            data: { ids: ids }})
                            .done(function () { location.reload() })
                    }
                }
            }
            let dtButtons = $.extend(true, [], $.fn.dataTable.defaults.buttons)
            dtButtons.push(deleteButton)

            $('.datatable:not(.ajaxTable)').DataTable({ buttons: dtButtons })
        })

    </script>
@endsection
@endsection