@extends('layouts.admin')
@section('content')
    <div class="card">
        <div class="card-header">
            {{ trans('global.featured_influencers.title_singular') }} {{ trans('global.list') }}
        </div>

        <div class="card-body">
            <div class="table-responsive">
                <table class=" table table-bordered table-striped table-hover datatable">
                    <thead>
                    <tr>
                        <th width="10">

                        </th>
                        <th>
                            {{ trans('global.featured_influencers.fields.influencer_name') }}
                        </th>
                        <th>
                            {{ trans('global.featured_influencers.fields.influencer_type') }}
                        </th>
                        <th>
                            {{ trans('global.featured_influencers.fields.followers_count') }}
                        </th>
                        <th>
                            {{ trans('global.featured_influencers.fields.set_unset') }}   
                        </th>

                    </tr>
                    </thead>
                    <tbody>
                    @foreach($influencers as $key => $influencer)
                        <tr data-entry-id="{{ $influencer->id }}">
                            <td>

                            </td>
                            <td>
                                {{'@'. $influencer->account_handle }}
                            </td>

                            <td>

                                <span class="badge
                                @if($influencer->account_type =='Instagram') badge-warning
                                @elseif($influencer->account_type == 'Tiktok') badge-dark
                                @else badge-info @endif
                                ">{{  $influencer->account_type }}</span>
                            </td>

                            <td>
                                {{ \App\SocialmediaObject::number_format_short($influencer->followers_count) }}
                            </td>

                            <td>

                                @if( (!$influencer->is_featured) )
                                    <a class="btn btn-xs btn-primary" href="{{ route('admin.featured_influencers.set_is_featured', [ 'influencer_id'=>$influencer->id, 'flag'=>1 ]) }}">
                                        {{ trans('global.featured_influencers.fields.set_featured') }}
                                    </a>

                                @elseif( $influencer->is_featured )
                                    <a class="btn btn-xs btn-primary" href="{{ route('admin.featured_influencers.set_is_featured', [ 'influencer_id'=>$influencer->id, 'flag'=>0 ]) }}">
                                        {{ trans('global.featured_influencers.fields.unset_featured') }}
                                    </a>
                                @endif


                            </td>

                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
        </div>
    </div>
@section('scripts')
    @parent
    <script>
        $(function () {
            let deleteButtonTrans = '{{ trans('global.datatables.delete') }}'
            let deleteButton = {
                text: deleteButtonTrans,
                url: "{{ route('admin.tags.massDestroy') }}",
                className: 'btn-danger',
                action: function (e, dt, node, config) {
                    var ids = $.map(dt.rows({ selected: true }).nodes(), function (entry) {
                        return $(entry).data('entry-id')
                    });

                    if (ids.length === 0) {
                        alert('{{ trans('global.datatables.zero_selected') }}')

                        return
                    }

                    if (confirm('{{ trans('global.areYouSure') }}')) {
                        $.ajax({
                            headers: {'x-csrf-token': _token},
                            method: 'POST',
                            url: '{{ url('admin/featured_influencers/mass_destroy') }}',
                            data: { ids: ids, _method: 'GET' }})
                            .done(function () { location.reload() })
                    }
                }
            }
            let dtButtons = $.extend(true, [], $.fn.dataTable.defaults.buttons)
            dtButtons.push(deleteButton)

            $('.datatable:not(.ajaxTable)').DataTable({ buttons: dtButtons })
            //$('.btn-danger').hide();
            //$('.select-checkbox').hide();
        })

    </script>
@endsection
@endsection
