@extends('layouts.admin')
@section('content')

    <div class="card">
        <div class="card-header">
            {{ trans('global.create') }} {{ trans('global.notifications.title_singular') }}
        </div>

        <div class="card-body">
            <form action="{{ route("admin.notifications.store") }}" method="POST" enctype="multipart/form-data">
                @csrf

                <div class="form-group {{ $errors->has('name') ? 'has-error' : '' }}">
                    <label for="to_user_id">{{ trans('global.notifications.fields.receiver') }}</label>
                    <select type="text" name="to_user_id" class="form-control">
                        @foreach($users as $user)
                            <option value="{{ $user->id }}">{{ $user->name }}</option>
                        @endforeach
                    </select>
                    @if($errors->has('to_user_id'))
                        <em class="invalid-feedback">
                            {{ $errors->first('to_user_id') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.notifications.fields.receiver_helper') }}
                    </p>
                </div>

                <div class="form-group {{ $errors->has('message') ? 'has-error' : '' }}">
                    <label for="message">{{ trans('global.notifications.fields.message') }}*</label>
                    <textarea name="message" class="form-control"></textarea>

                    @if($errors->has('message'))
                        <em class="invalid-feedback">
                            {{ $errors->first('message') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.notifications.fields.message_helper') }}
                    </p>
                </div>

                <input type="hidden" name="from_user_id" value="{{ $loggedInUser->id }}">

                <div>
                    <input class="btn btn-danger" type="submit" value="{{ trans('global.save') }}">
                </div>
            </form>
        </div>
    </div>

@endsection

