@extends('layouts.admin')
@section('content')

    <div class="card">
        <div class="card-header">
            {{ trans('global.edit') }} {{ trans('global.notifications.title_singular') }}
        </div>

        <div class="card-body">
            <form action="{{ route("admin.notifications.update", [$notification->id]) }}" method="POST" enctype="multipart/form-data">
                @csrf
                @method('PUT')

                <div class="form-group {{ $errors->has('message') ? 'has-error' : '' }}">
                    <label for="message">{{ trans('global.notifications.fields.message') }}*</label>
                    <textarea name="message" class="form-control">{{ $notification->message }}</textarea>

                    @if($errors->has('message'))
                        <em class="invalid-feedback">
                            {{ $errors->first('message') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.notifications.fields.message_helper') }}
                    </p>
                </div>

                <div>
                    <input class="btn btn-danger" type="submit" value="{{ trans('global.save') }}">
                </div>
            </form>
        </div>
    </div>
@endsection

