@extends('layouts.admin')
@section('content')
    <div class="card">
        <div class="card-header">
            {{ trans('global.notifications.title_singular') }} {{ trans('global.list') }}
            @can('notification_create')
                <a class="btn btn-success" href="{{ route("admin.notifications.create") }}" style="float: right; display: none">
                    {{ trans('global.add') }} {{ trans('global.notifications.title_singular') }}
                </a>
            @endcan
        </div>

        <div class="card-body">
      <div class="table-responsive">
                <table class=" table table-bordered table-striped table-hover datatable">
                    <thead>
                    <tr>
                        <th width="10">

                        </th>
                        <th>
                            {{ trans('global.notifications.fields.sent_by') }}
                        </th>
                        
                        <th>
                            {{ trans('global.notifications.fields.message') }}
                        </th>

                        <th>
                            {{ trans('global.notifications.fields.created_at') }}
                        </th>

                        <th>
                            &nbsp;
                        </th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach($notifications as $key => $notification)
                        <tr data-entry-id="{{ $notification->id }}">
                            <td>

                            </td>
                            <td>
                                {{ $notification->from_user_id == 0 ? 'None' : $notification->sender->name }}
                            </td>
                            <td>
                                {{ $notification->message }}
                            </td>
                            <td>
                                {{ $notification->created_at }}
                            </td>
                            <td>
                                @can('notification_show')
                                    <a class="btn btn-xs btn-primary" href="{{ $notification->url }}">
                                        {{ trans('global.view') }}
                                    </a>
                                @endcan

                                @can('notification_delete')
                                    <form action="{{ route('admin.notifications.destroy', $notification->id) }}" method="POST" onsubmit="return confirm('{{ trans('global.areYouSure') }}');" style="display: inline-block;">
                                        <input type="hidden" name="_method" value="DELETE">
                                        <input type="hidden" name="_token" value="{{ csrf_token() }}">
                                        <input type="submit" class="btn btn-xs btn-danger" value="{{ trans('global.delete') }}">
                                    </form>
                                @endcan
                            </td>

                        </tr>
                    @endforeach
                    </tbody>
                </table>
                </div>
            </div>
        </div>
@section('scripts')
    @parent
    <script>
        $(function () {
            let deleteButtonTrans = '{{ trans('global.datatables.delete') }}'
            let deleteButton = {
                text: deleteButtonTrans,
                url: "{{ route('admin.notifications.massDestroy') }}",
                className: 'btn-danger',
                action: function (e, dt, node, config) {
                    var ids = $.map(dt.rows({ selected: true }).nodes(), function (entry) {
                        return $(entry).data('entry-id')
                    });

                    if (ids.length === 0) {
                        alert('{{ trans('global.datatables.zero_selected') }}')

                        return
                    }

                    if (confirm('{{ trans('global.areYouSure') }}')) {
                        $.ajax({
                            headers: {'x-csrf-token': _token},
                            method: 'POST',
                            url: config.url,
                            data: { ids: ids, _method: 'DELETE' }})
                            .done(function () { location.reload() })
                    }
                }
            }
            let dtButtons = $.extend(true, [], $.fn.dataTable.defaults.buttons)
            @can('notification_delete')
            dtButtons.push(deleteButton)
            @endcan

            $('.datatable:not(.ajaxTable)').DataTable({ buttons: dtButtons })
        })

    </script>
@endsection
@endsection

