@extends('layouts.admin')
@section('content')

    <div class="card">
        <div class="card-header">
            {{ trans('global.edit') }} {{ trans('global.settings.title_singular') }}
        </div>

        <div class="card-body">
            <form action="{{ route('admin.settings.save') }}" method="POST" enctype="multipart/form-data">
                @csrf
                @method('POST')
                <div class="form-group {{ $errors->has('timezone') ? 'has-error' : '' }}">
                    <label for="name">{{ trans('global.settings.fields.timezone') }}*</label>
                    <select  class="form-control" name="timezone">
                        @foreach($timezonesList as $val)
                            <option value="{{ $val }}" @if($settings['timezone'] == $val) selected @endif>{{ $val }}</option>
                        @endforeach
                    </select>
                    @if($errors->has('timezone'))
                        <em class="invalid-feedback">
                            {{ $errors->first('timezone') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.settings.fields.timezone_helper') }}
                    </p>
                </div>

                <div class="form-group {{ $errors->has('site_name') ? 'has-error' : '' }}">
                    <label for="name">{{ trans('global.settings.fields.site_name') }}*</label>
                    <input type="text" id="site_name" name="site_name" class="form-control" value="{{ $settings['site_title'] }}">
                    @if($errors->has('site_name'))
                        <em class="invalid-feedback">
                            {{ $errors->first('site_name') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.settings.fields.site_name_helper') }}
                    </p>
                </div>

                <div class="form-group {{ $errors->has('project_name') ? 'has-error' : '' }}">
                    <label for="name">{{ trans('global.settings.fields.project_name') }}*</label>
                    <input type="text" id="project_name" name="project_name" class="form-control" value="{{ old('project_name', isset($settings) ? $settings['project_title'] : '') }}">
                    @if($errors->has('project_name'))
                        <em class="invalid-feedback">
                            {{ $errors->first('project_name') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.settings.fields.project_name_helper') }}
                    </p>
                </div>

                <div class="form-group {{ $errors->has('email') ? 'has-error' : '' }}">
                        <label for="name">{{ trans('global.settings.fields.email') }}*</label>
                        <input type="text" id="email" name="email" class="form-control" value="{{ $settings['email'] }}">
                        @if($errors->has('email'))
                            <em class="invalid-feedback">
                                {{ $errors->first('email') }}
                            </em>
                        @endif
                        <p class="helper-block">
                            {{ trans('global.settings.fields.email_helper') }}
                        </p>   
                </div>

                <div class="form-group {{ $errors->has('phone') ? 'has-error' : '' }}">
                        <label for="name">{{ trans('global.settings.fields.phone') }}*</label>
                        <input type="text" id="phone" name="phone" class="form-control" value="{{ $settings['phone'] }}">
                        @if($errors->has('phone'))
                            <em class="invalid-feedback">
                                {{ $errors->first('phone') }}
                            </em>
                        @endif
                        <p class="helper-block">
                            {{ trans('global.settings.fields.phone_helper') }}
                        </p>   
                </div>

                <div class="form-group {{ $errors->has('show_influencers') ? 'has-error' : '' }}">
                    <label for="show_influencers">{{ trans('global.settings.fields.show_influencers') }}</label>
                    <select  class="form-control" name="show_influencers">
                        <option value="Yes" @if($settings['show_influencers'] == 'Yes') selected @endif>Yes</option>
                        <option value="No" @if($settings['show_influencers'] == 'No') selected @endif>No</option>
                    </select>
                    @if($errors->has('show_influencers'))
                        <em class="invalid-feedback">
                            {{ $errors->first('show_influencers') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.settings.fields.show_influencers_helper') }}
                    </p>
                </div>

                <div class="form-group {{ $errors->has('address') ? 'has-error' : '' }}">
                        <label for="name">{{ trans('global.settings.fields.address') }}</label>
                        <textarea id="address" name="address" class="form-control">{{ $settings['address'] }}</textarea>
                        @if($errors->has('address'))
                            <em class="invalid-feedback">
                                {{ $errors->first('address') }}
                            </em>
                        @endif
                        <p class="helper-block">
                            {{ trans('global.settings.fields.address_helper') }}
                        </p>   
                </div>

                <div>
                    <input class="btn btn-success" type="submit" value="{{ trans('global.save') }}">
                </div>
            </form>
        </div>
    </div>


@endsection

