@extends('layouts.admin')
@section('content')
    <div class="card">
        <div class="card-header">
            {{ trans('global.site_review.title_singular') }} {{ trans('global.list') }}
        </div>

        <div class="card-body">
            <div class="table-responsive">
                <table class=" table table-bordered table-striped table-hover datatable">
                    <thead>
                    <tr>
                        <th width="10">

                        </th>
                        <th>
                            {{ trans('global.site_review.fields.title') }}
                        </th>

                        <th>
                            {{ trans('global.site_review.fields.message') }}   
                        </th>
                        <th>
                             {{ trans('global.site_review.fields.status') }}      
                        </th>
                    </tr>
                    </thead>
                    <tbody>
                        @foreach($site_reviews as $key => $site_review)
                        <tr>
                            <td>

                            </td>
                            <td>
                                {{ $site_review->title ?? '' }} 
                            </td>
                            
                            <td>
                                    {{ $site_review->message ?? '' }} 
                            </td>
                            <td>
                                    
                            </td>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
        </div>
    </div>
@section('scripts')
    @parent
    <script>
        $(function () {
            let deleteButtonTrans = '{{ trans('global.datatables.delete') }}'
            let deleteButton = {
                text: deleteButtonTrans,
                url: "{{ route('admin.tags.massDestroy') }}",
                className: 'btn-danger',
                action: function (e, dt, node, config) {
                    var ids = $.map(dt.rows({ selected: true }).nodes(), function (entry) {
                        return $(entry).data('entry-id')
                    });

                    if (ids.length === 0) {
                        alert('{{ trans('global.datatables.zero_selected') }}')

                        return
                    }

                    if (confirm('{{ trans('global.areYouSure') }}')) {
                        $.ajax({
                            headers: {'x-csrf-token': _token},
                            method: 'POST',
                            url: config.url,
                            data: { ids: ids, _method: 'DELETE' }})
                            .done(function () { location.reload() })
                    }
                }
            }
            let dtButtons = $.extend(true, [], $.fn.dataTable.defaults.buttons)
            dtButtons.push(deleteButton)

            $('.datatable:not(.ajaxTable)').DataTable({ buttons: dtButtons })
            //$('.btn-danger').hide();
            $('.select-checkbox').hide();
        })

    </script>
@endsection
@endsection
