@extends('layouts.admin')
@section('content')

    <div class="card">
        <div class="card-header">
            {{ trans('global.take_action') }}
        </div>

        <div class="card-body">
            <form action="{{ route("admin.tickets.post.action") }}" method="POST" enctype="multipart/form-data">

                @csrf
                <div class="form-group {{ $errors->has('description') ? 'has-error' : '' }}">
                @if(!empty($ticket->order_id))
                    <div class="form-check form-check-inline">
                        <input class="form-check-input" name="send_to_seller" type="checkbox" id="inlineCheckbox1" checked>
                        <label class="form-check-label" for="inlineCheckbox1">Send to Seller</label>
                    </div>
                    <div class="form-check form-check-inline">
                        <input class="form-check-input" name="send_to_buyer" type="checkbox" id="inlineCheckbox2">
                        <label class="form-check-label" for="inlineCheckbox2">Send to Buyer</label>
                    </div><hr>
                @endif
                    <label for="message_to_sender">Message</label>
                    <textarea name="message_to_sender" class="form-control"></textarea>

                    @if($errors->has('message_to_sender'))
                        <em class="invalid-feedback">
                            {{ $errors->first('message_to_sender') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.ticket.fields.message_to_against_user_helper') }}
                    </p>
                </div>

                <div class="form-group {{ $errors->has('description') ? 'has-error' : '' }}">
                    <label for="take_action">{{ trans('global.take_action') }}</label>
                    <select name="take_action" class="form-control">
                        @if(is_null($ticket->order_id))
                            <option value="0">Do not Take any Action</option>
                            <option value="1">Resolve Ticket</option>
                        @endif
                        @if(!is_null($ticket->order_id))
                            <option value="1">Completed as required “send money to seller"</option>
                            <option value="2">Not completed as required "send money to buyer"</option>
                        @endif
                    </select>

                    @if($errors->has('take_action'))
                        <em class="invalid-feedback">
                            {{ $errors->first('take_action') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.ticket.fields.message_to_against_user_helper') }}
                    </p>
                </div>

                <input type="hidden" name="ticket_id" value="{{ $ticket->id }}">

                <div>
                    <input class="btn btn-danger" type="submit" value="{{ trans('global.save') }}">
                </div>
            </form>
        </div>
    </div>

@endsection


