@extends('layouts.admin')
@section('content')

    <div class="card">
        <div class="card-header">
            {{ trans('global.create') }} {{ trans('global.ticket.title_singular') }}
        </div>

        <div class="card-body">
            <form action="{{ route("admin.tickets.store") }}" method="POST" enctype="multipart/form-data" onsubmit="disableSubmitButton()">
                @csrf

                <div class="form-group {{ $errors->has('name') ? 'has-error' : '' }}">
                    <label for="start_date">{{ trans('global.ticket.fields.subject') }}</label>
                    <input type="text" name="subject" class="form-control">
                    @if($errors->has('subject'))
                        <em class="invalid-feedback">
                            {{ $errors->first('subject') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.ticket.fields.subject_helper') }}
                    </p>
                </div>

                <div class="form-group {{ $errors->has('user_id') ? 'has-error' : '' }}">
                    <label for="against_user_id">{{ trans('global.ticket.fields.against_user_name') }}*</label>
                    <select  class="form-control" name="against_user_id">
                        <option value="0">Not Against any User</option>
                        @foreach($users as $user)
                            <option value="{{ $user->id }}">{{ $user->name }}</option>
                        @endforeach
                    </select>

                    @if($errors->has('against_user_id'))
                        <em class="invalid-feedback">
                            {{ $errors->first('against_user_id') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.ticket.fields.against_user_name_helper') }}
                    </p>
                </div>
                <div class="form-group {{ $errors->has('description') ? 'has-error' : '' }}">
                    <label for="post_id">{{ trans('global.ticket.fields.description') }}*</label>
                    <textarea name="description" class="form-control"></textarea>

                    @if($errors->has('description'))
                        <em class="invalid-feedback">
                            {{ $errors->first('description') }}
                        </em>
                    @endif
                    <p class="helper-block">
                        {{ trans('global.ticket.fields.description_helper') }}
                    </p>
                </div>

                <div>
                    <input class="btn btn-danger" type="submit" value="{{ trans('global.save') }}">
                </div>
            </form>
        </div>
    </div>

@endsection

@section('scripts')
    <script>
        function disableSubmitButton() {
            $('.btn-danger').attr('disabled', true);
        }
    </script>
@endsection

