@extends('layouts.frontend')
<!-- Header -->
@section('header')
@include('partials.header')
@endsection
@section('contents')
  @php
    $earnings = get_user_balance_hisory();
  @endphp
<div class="background_section social-influencer">
  <div class="profit-earned section">
    <div class="container">
      <div class="boxes-parent earned-boxes">
        <div class="boxes">
          <div class="box-payment">
            <h2>{{ '$'.App\SocialmediaObject::number_format_short( $earnings['monthly'] ) }}</h2>
          </div>
          <div class="earned">Earned This Month</div>
        </div>
        <div class="boxes">
          <div class="box-payment">
            <h2>{{ '$'.App\SocialmediaObject::number_format_short( $earnings['yearly'] ) }}</h2>
          </div>
          <div class="earned">Earned This Year</div>
        </div>
        <div class="boxes">
          <div class="box-payment">
            <h2>{{ '$'.App\SocialmediaObject::number_format_short($earnings['all_time'] ) }}</h2>
          </div>
          <div class="earned">Earned Total</div>
        </div>
      </div>
    </div>
  </div>
  <div class="section">
    @include('flash-message')
    <div class="container">
      
      <div class="row">
        <div class="col-md-12">
          <div class="social-heading-parent">
            <div class="insta_heading">
              <span>TIKTOK ACCOUNTS</span>
            </div>
            <div class = "social_button">
              <a href="{{ route('frontend.social.add_account' ,['account' => 'tiktok']) }}"><button type="button" class="button button-block">ADD NEW ACCOUNT</button></a>
            </div>
          </div>
        </div>

        <div class="col-md-12">
          <div class="wrapper">
          <div class="table-responsive">
            <table class="table table-striped" style="margin-bottom:0;">
              <thead class= "browse_table_heading">
                <tr>
                  <th scope="col">INFLUENCER ACCOUNT</th>
                  <th scope="col">FOLLOWERS</th>
                  <th scope="col">POSTS</th>
                  <th scope="col">ENGAGEMENT</th>
                  <th scope="col">EARNINGS</th>
                  <th scope="col">ACTIONS</th>
                </tr>
              </thead>
              <tbody class= "balance_table_body">
                @foreach( $socialAccounts as $socialAccount )
                @if( $socialAccount->account_type == 'Tiktok' )
                <tr>
                  <td>
                    <div class="insta_icon">
                      <img src="{{ $socialAccount->profile_picture }}" style="width: 50px;"class=" rounded-circle" alt="" />
                    </div>
                    <div class="insta_name">
                      <a>{{ preg_replace('/&#[(0-9)]*;/' , '' , $socialAccount->account_name) }}</a><br><a href="{{ asset( 'frontend/influencer/' . $socialAccount->id) }}" style="font-size: 14px;">{{ '@' . $socialAccount->account_handle }}</a>
                    </div>
                  </td>
                  <td><a>{{ App\SocialmediaObject::number_format_short( $socialAccount->followers_count ) }}</a></td>
                  <td><a>{{ $socialAccount->total_posts }}</a></td>
                  <td><a>{{ $socialAccount->engagements }}%</a></td>
                  <td><a>{{'$'.App\SocialmediaObject::number_format_short( $socialAccount->earning )}}</a></td>
                  <td>
                    <a href="{{ route('frontend.social.remove_account', ['id' => $socialAccount->id]) }}"><i class='fas fa-trash' style='color: #012d3e;'></i></a>
                    @if($socialAccount->status != 'Verified')
                    &nbsp;&nbsp; | &nbsp;&nbsp;
                    <a href="{{ route('frontend.social.verify_account', ['account' => 'tiktok','id' => $socialAccount->id]) }}"><i class='fas fa-user-check' style='color: #012d3e;'></i></a>
                    @endif
                  </td>
                </tr>
                @endif
                @endforeach
              </tbody>
            </table>
            </div>
          </div>
        </div>
      </div>
      
      <div class="row">
        <div class="col-md-12">
          <div class="social-heading-parent">
            <div class="insta_heading">
              <span>INSTAGRAM ACCOUNTS</span>
            </div>
            <div class = "social_button">
              <a href="{{ route('frontend.social.add_account' ,['account' => 'instagram']) }}"><button type="button" class="button button-block">ADD NEW ACCOUNT</button></a>
            </div>
          </div>
        </div>

        <div class="col-md-12">
          <div class="wrapper">
          <div class="table-responsive">
            <table class="table table-striped" style="margin-bottom:0;">
              <thead class= "browse_table_heading">
                <tr>
                  <th scope="col">INFLUENCER ACCOUNT</th>
                  <th scope="col">FOLLOWERS</th>
                  <th scope="col">POSTS</th>
                  <th scope="col">ENGAGEMENT</th>
                  <th scope="col">EARNINGS</th>
                  <th scope="col">ACTIONS</th>
                </tr>
              </thead>
              <tbody class= "balance_table_body">
                @foreach( $socialAccounts as $socialAccount )
                @if( $socialAccount->account_type == 'Instagram' )
                <tr>
                  <td>
                    <div class="insta_icon">
                      <img src="{{ $socialAccount->profile_picture }}" style="width: 50px;"class=" rounded-circle" alt="" />
                    </div>
                    <div class="insta_name">
                      <a>{{ $socialAccount->account_name }}</a><br><a href="{{ asset( 'frontend/influencer/' . $socialAccount->id) }}" style="font-size: 14px;">{{ '@' . $socialAccount->account_handle }}</a>
                    </div>
                  </td>
                  <td><a>{{ App\SocialmediaObject::number_format_short( $socialAccount->followers_count ) }}</a></td>
                  <td><a>{{ $socialAccount->total_posts }}</a></td>
                  <td><a>{{ $socialAccount->engagements }}%</a></td>
                  <td><a>{{'$'.App\SocialmediaObject::number_format_short( $socialAccount->earning )}}</a></td>
                  <td>
                    <a href="{{ route('frontend.social.remove_account', ['id' => $socialAccount->id]) }}"><i class='fas fa-trash' style='color: #012d3e;'></i></a>
                    @if($socialAccount->status != 'Verified')
                    &nbsp;&nbsp; | &nbsp;&nbsp;
                    <a href="{{ route('frontend.social.verify_account', ['account' => 'instagram','id' => $socialAccount->id]) }}"><i class='fas fa-user-check' style='color: #012d3e;'></i></a>
                    @endif
                  </td>
                </tr>
                @endif
                @endforeach
              </tbody>
            </table>
            </div>
          </div>
        </div>
      </div>
      {{-- Twitter --}}
      
      {{--<div class="row">
        <div class="col-md-12">
          <div class="social-heading-parent">
            <div class="twitter_heading">
              <span>TWITTER ACCOUNTS</span>
            </div>
            <div class = "social_button">
              <a href="{{ route('frontend.social.add_account' ,['account' => 'twitter']) }}"><button type="button" class="button button-block">ADD NEW ACCOUNT</button></a>
            </div>
          </div>
        </div>

        <div class="col-md-12">
          <div class="wrapper">
          <div class="table-responsive">
            <table class="table table-striped" style="margin-bottom:0;">
              <thead class= "browse_table_heading">
                <tr>
                  <th scope="col">INFLUENCER ACCOUNT</th>
                  <th scope="col">FOLLOWERS</th>
                  <th scope="col">POSTS</th>
                  <th scope="col">ENGAGEMENT</th>
                  <th scope="col">EARNINGS</th>
                  <th scope="col">ACTIONS</th>
                </tr>
              </thead>
              <tbody class= "balance_table_body">
                @foreach( $socialMediaObjects as $socialMediaObject )
                @if( $socialMediaObject->getSocialMedia()->account_type == 'Twitter' )
                <tr>
                  <td>
                    <div class="insta_icon">
                      <img src="{{ count($socialMediaObject->getFeeds()) > 0 ? $socialMediaObject->getFeeds()[0]['user']['profile_image_url_https'] : asset('images/default.jpg') }}" style="width: 50px;">
                    </div>
                    <div class="insta_name">
                      <a>{{ count($socialMediaObject->getFeeds()) >0 ? $socialMediaObject->getFeeds()[0]['user']['name'] : $socialMediaObject->getSocialMedia()->account_handle }}</a><br><a href="{{ asset( 'frontend/influencer/' . $socialMediaObject->getSocialMedia()->id) }}" style="font-size: 14px;">{{ '@' . $socialMediaObject->getSocialMedia()->account_handle }}</a>
                    </div>
                  </td>
                  <td><a>{{ App\SocialmediaObject::number_format_short( $socialMediaObject->getTwitterFollowers() ) }}</a></td>
                  <td><a>{{ count($socialMediaObject->getFeeds()) }}</a></td>
                  <td><a>1.85%</a></td>
                  <!-- <td><a>{{ $socialMediaObject->getScore() }}</a></td> -->
                  <td><a>223K</a></td>
                  <td>
                    <a href="{{ route('frontend.social.remove_account', ['id' => $socialMediaObject->getSocialMedia()->id]) }}"><img src="{{asset('frontend/images/remove.png')}}"></a>
                  </td>
                </tr>
                @endif
                @endforeach
              </tbody>
            </table>
            </div>
          </div>
        </div>
      </div>--}}
    </div>
  </div>
  <div class="section mt-5">
    <div class="container">
      <div class="row">
        <div class="col-12">
          <div id="switch">
            <div id="circle"></div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
@endsection
@section('footer')
@include('partials.footer')
@endsection
@section('scripts')
  <script src="{!! asset('js/firebase/firebase-app.js') !!}"></script>
  <script src="{!! asset('js/firebase/firebase-firestore.js') !!}"></script>
  <script src="{!! asset('js/firebase/firebase-messaging.js') !!}"></script>
  <script src="{!! asset('js/firebase/firebase-chat-config.js') !!}"></script>
  <script src="{!! asset('js/helper.js') !!}"></script>
  <script>


      //$(document).ready(function() {

          //var frm = document.getElementById('create_form');
      function removeAccount(id) {

          var base_url = "{{ url('/') }}";
          //$('#remove_button').on('click', function (event) {
              //$('.invalid-feedback').hide();
              $.ajax({
                  url: base_url + '/frontend/remove/' + id,
                  method: "GET",
                  //data: new FormData(frm),
                  //dataType: 'JSON',
                  //contentType: false,
                  //cache: false,
                  //processData: false,
                  success: function (data) {
                      //$('.invalid-feedback').hide();
                      db.collection(usersCollection).where("id", "==", parseInt(id)).limit(1)
                          .get()
                          .then(function(querySnapshot) {
                              querySnapshot.forEach(function(doc) {
                                  console.log(doc.id, " => ", doc.data());
                                  db.collection(usersCollection).doc(doc.id).delete();
                              });
                              window.location.reload();
                          });
                  },
                  error: function (data) {

                      /*var errors = data.responseJSON.errors;
                      $('.invalid-feedback').hide();
                      $.each(errors, function(key,val){
                          $('#' + key + '_error').show();
                          $('#' + key + '_error').html(errors[key]);
                      });
                      return false;*/
                      alert('Invalid Account Handle.')
                  }

              });
              return false;
          //});

      }

      //});

  </script>
@endsection