@extends('layouts.frontend')
<!-- Header -->
@section('header')

    @include('partials.header')

@endsection

@section('contents')

    <div class="background_section">
        <div class="section">
            @include('flash-message')
            <div class="container">
                <div class="insta_heading">
                    <span>Account/Add Tiktok</span>
                </div>
                <div class="row">
                    <div class="col-md-6" style="margin:auto;">
                        <div class="socialform">
                            <div class="form">

                                <div class="textform">
                                    <form action="{{ route('frontend.social.post_account' , ['account' => 'tiktok']) }}" method="post">
                                        @csrf

                                        <div class="field-wrap">

                                            <input type="text" name="account_handle" placeholder="Tiktok handle" autocomplete="off"/>

                                        </div>
                                        <button type="submit" class="button button-block">FIND</button>

                                    </form>

                                </div>


                            </div></div></div>

                </div> <!-- Row ends here -->

            </div>

        </div>
        <div class="section mt-5">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div id="switch">
                            <div id="circle"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </div>

@endsection

@section('footer')
    @include('partials.footer')
@endsection

@section('scripts')
    <script src="{!! asset('js/firebase/firebase-app.js') !!}"></script>
    <script src="{!! asset('js/firebase/firebase-firestore.js') !!}"></script>
    <script src="{!! asset('js/firebase/firebase-messaging.js') !!}"></script>
    <script src="{!! asset('js/firebase/firebase-chat-config.js') !!}"></script>
    <script src="{!! asset('js/helper.js') !!}"></script>
    <script>


        $(document).ready(function() {

            var frm = document.getElementById('create_form');

            $('#submit_button').on('click', function (event) {
                $('.invalid-feedback').hide();
                $.ajax({
                    url: "{{ route('frontend.social.post_account' , ['account' => 'tiktok']) }}",
                    method: "POST",
                    data: new FormData(frm),
                    dataType: 'JSON',
                    contentType: false,
                    cache: false,
                    processData: false,
                    success: function (data) {
                        //$('.invalid-feedback').hide();
                        if(data == 'exists') {
                            alert('Account already exists');
                        } else if(data == 'invalid') {
                            alert('Invalid account handle');
                        } else {

                            db.collection(usersCollection).add({
                                id: data.user.id,
                                name: data.user.name,
                                avatar: data.user.avatar,
                                blocked_users: [],
                                conversation_stopped_users: []
                                //is_online: true
                            })
                                .then(function (docRef) {
                                    //console.log("Document written with ID: ", docRef.id);
                                    window.location.href = data.user.redirect_to;
                                })
                                .catch(function (error) {
                                    console.error("Error adding document: ", error);
                                });
                        }
                    },
                    error: function (data) {

                        /*var errors = data.responseJSON.errors;
                        $('.invalid-feedback').hide();
                        $.each(errors, function(key,val){
                            $('#' + key + '_error').show();
                            $('#' + key + '_error').html(errors[key]);
                        });
                        return false;*/
                        if(data.responseText == 'exists') {
                            alert('Account already exists');
                        } else {
                            alert('Invalid Account Handle.')
                        }
                    }

                });
                return false;
            });

        });

    </script>
@endsection

