@extends('layouts.frontend')
<!-- Header -->
@section('header')
@include('partials.header')
@endsection
@section('contents')
<div class="background_section">
    <div class="section">
        @include('flash-message')
        <div class="container">
            <div class="post_heading">
                <span>CAMPAIGN CART</span><br>
            </div>
            <div class="row">
                <div class="col-md-8" style="margin:auto;">
                    <div class="campform" id="postForm" style="display: block;">
                        <div class="forrm">
                            <form id="postFormToSubmit" method="POST" @if(!isset($post)) action="{{ route('frontend.user.store_campaign_post') }}" @else action="{{ route('frontend.user.update_campaign_post' , ['id' => $post->id]) }}" @endif enctype="multipart/form-data">
                                @csrf
                                <div class="form-parent">
                                    @if($campaign->user_provides_description)
                                    <div class="field-wrap">
                                        <label class="camp_label" for="Comments">Post Caption</label>
                                        <textarea id="post-caption" name="description" placeholder="  Comments.." style="height:100px;width:100%;border-radius:5px;" autocomplete="off">{!! isset($post) ? $post->description : '' !!}</textarea>

                                        <span class="invalid-feedback" id="description_error" style="display: none;">
                                            <strong>Post caption is required</strong>
                                        </span>
                                    </div>
                                    @endif
                                    @if($campaign->user_provides_links)
                                    <div class="field-wrap">
                                        <label class="camp_label" for="Comments">Post Link</label>
                                        <input id="post-links" value="{!! isset($post) ? $post->link : '' !!}" type="text" name="link" placeholder="Link, If any.." style="border-radius:5px;">
                                        @if ($errors->has('link'))
                                        <span class="invalid-feedback" style="display: block;">
                                            <strong>{{ $errors->first('link') }}</strong>
                                        </span>
                                        @endif
                                    </div>
                                    @endif
                                    @if($campaign->user_provides_media)
                                    <div class="field-wrap">
                                        <label class="camp_label" for="Comments">Post Image/Media</label>
                                        <label class="button_label">CHOOSE FILE <input type="file" size="60"id="post-image" name="image" accept="image/x-png,image/jpg,image/jpeg,video/mp4"></label>

                                        <span class="invalid-feedback" id="image_error" style="display: none;">
                                            <strong>Image / Media is required</strong>
                                        </span>

                                    </div>
                                    @endif
                                    <hr>
                                    <div class="field-wrap">
                                        <label class="camp_label" for="date">Date</label>
                                        <div class="input-group mb-3" style="width:46%;">
                                            <input id="post-date" {!! isset($post) ? 'type="text" onfocus="(this.type=\'date\')"' : "type='date'" !!} name="start_date" class="form-control" min="{{ date('Y-m-d') }}"/>
                                            <span class="invalid-feedback" id="start_date_error" style="display: none;">
                                                <strong>Date is required</strong>
                                            </span>
                                        </div>
                                    </div>
                                    <input type="hidden" name="campaign_id" value="{!! isset($post) ? $post->campaign_id : $campaign->id !!}">
                                    <input type="hidden" name="brand_id" value="{!! isset($post) ? $post->brand_id : $user->id !!}">
                                    <input type="hidden" name="cart_id" value="{!! isset($post) ? $post->cart_id : $cart->id !!}">
                                    <input type="hidden" name="influencer_id" value="{!! isset($post) ? $post->influencer_od : $campaign->social_media_id !!}">
                                </div>
                            </form>
                            <div class="details">
                                <button class="button button-block review-btn">Review Post</button>
                            </div>
                        </div>
                    </div>
                    {{--REVIEW POST--}}
                    <div class="campform" style="display: none;" id="postReview">
                        <div class="forrm">
                            <div class="form-parent">
                                <div class="field-wrap text-center">
                                    <span class="align-items-center">
                                        @if(isset($post))
                                        @if(!empty($post->image))
                                        <img id="post-image-preview" class="rounded-circle preview-img" src="{!! asset('uploads/images/'.$post->image) !!}">
                                        <video style="display: none;" id="post-video-preview" width="320" height="240" controls>
                                            <source src="{{ asset('uploads/images/'.$post->video) }}" type="video/mp4">
                                            Your browser does not support the video tag.
                                        </video>
                                        @else
                                        <img style="display: none" id="post-image-preview" class="rounded-circle preview-img" src="{!! asset('uploads/images/'.$post->image) !!}">
                                        <video id="post-video-preview" width="320" height="240" controls>
                                            <source src="{{ asset('uploads/images/'.$post->video) }}" type="video/mp4">
                                            Your browser does not support the video tag.
                                        </video>
                                        @endif
                                        @else
                                        <img id="post-image-preview" class="rounded-circle preview-img" src="{!! asset('images/user-default.png') !!}">
                                        <video style="display: none" id="post-video-preview" width="320" height="240" controls>
                                            <source src="{!! asset('images/user-default.png') !!}" type="video/mp4">
                                            Your browser does not support the video tag.
                                        </video>
                                        @endif
                                    </span>
                                </div>
                                <div class="field-wrap text-center">
                                    <p class="align-items-center" id="post-caption-preview">
                                        Caption
                                    </p>
                                </div><hr>
                                <div class="field-wrap campaign-cart-icons">
                                    <div class="row text-center">
                                        <div class="col-md-6">
                                            <div class="row">
                                                <div class="campaign-post-parent">
                                                    <div class="reviewicon">
                                                        <img class="review-icon" src="{{ asset('frontend/images/calender.png') }}">
                                                    </div>
                                                    <div class="datetime-icon">
                                                        <strong>Date & time</strong><br>
                                                        <span id="post-date-preview">{!! isset($post) ? date('m/d/Y' , strtotime($post->start_date)) : '00/00/0000' !!}</span>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <div class="row">
                                                <div class="campaign-post-parent">
                                                    <div class="reviewicon">
                                                        <img class="review-icon" src="{{ asset('frontend/images/email.png') }}">
                                                    </div>
                                                    <div class="datetime-icon">
                                                        <span id="post-email-preview">{!! isset($post) ? Auth::user()->email : $user->email !!}</span>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div><hr>
                                    <div class="row text-center backbuy-btn">
                                        
                                        <div class="details">
                                            <button class="button button-block back-btn">Back</button>
                                        </div>
                                        
                                        
                                        <div class="details">
                                            <button class="button button-block submit-btn" form="postFormToSubmit">
                                            @if(!isset($post)) Add To Cart @else Update @endif
                                            </button>
                                        </div>
                                        
                                        @if(!isset($post))
                                        
                                        <div class="details">
                                            <button class="button button-block submit-btn" id="buyNowBtn">Buy Now</button>
                                        </div>
                                        
                                        @endif
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                </div> <!-- Row ends here -->
            </div>
        </div>
        <div class="section mt-5">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div id="switch">
                            <div id="circle"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    @endsection
    @section('footer')
    @include('partials.footer')
    @endsection
    @push('after-css')
    <style>
    .review-icon{
    font-size: 50px;
    }
    .preview-img{
    height: 200px;
    width: 200px;
    }
    </style>
    @endpush
    @push('after-js')
    <script>
    $(document).ready(function () {
    $('#buyNowBtn').on('click' , function () {
    $('#postFormToSubmit').attr('action' , '{{ route('frontend.user.buy_campaign_post') }}');
    $('#postFormToSubmit').submit();
    });
    @if(isset($post))
    document.getElementById("post-date").defaultValue = "{!! date('m/d/Y' , strtotime($post->start_date)) !!}";
    @endif
    $('#post-caption').on('change' , function(){
    $('#post-caption-preview').html(this.value);
    });
    $('#post-date').on('change' , function(){
    $('#post-date-preview').html(this.value);
    });
    $('#post-links').on('change' , function(){
    $('#post-links-preview').html(this.value);
    });
    var file_selected = 0;
    $('#post-image').on('change' , function(event){
    var ext = getFileNameWithExt(event);
    var file = URL.createObjectURL(event.target.files[0]);
    var extensions = ['png', 'PNG', 'jpg', 'JPG', 'jpeg', 'JPEG', 'mp4', 'MP4'];
    if(extensions.indexOf(ext) !== -1 && event.target.files[0].size <= 5000000) {
        file_selected = 1;
        if(ext == 'mp4' || ext == 'MP4'){
            $('#post-image-preview').hide();
            $('#post-video-preview').show();
            $('#post-video-preview').attr('src' , file);
        }else{
            $('#post-image-preview').show();
            $('#post-video-preview').hide();
            $('#post-image-preview').attr('src' , file);
        }
    } else if(extensions.indexOf(ext) == -1) {
        alert("Invalid file format selected");
        file_selected = 0;
    } else if(event.target.files[0].size > 5000000){
        file_selected = 0;
    alert("File is too big! Max allowed size is 5mbs");
    this.value = "";
    } /*else{
    if(ext == 'mp4' || ext == 'MP4'){
    $('#post-image-preview').hide();
    $('#post-video-preview').show();
    $('#post-video-preview').attr('src' , file);
    }else{
    $('#post-image-preview').show();
    $('#post-video-preview').hide();
    $('#post-image-preview').attr('src' , file);
    }
    }*/
    });
    $('.review-btn').on('click' , function () {
        $('.invalid-feedback').hide();
    if($('#post-caption').val() == '' || file_selected == 0 || $('#post-date').val() == '') {
        if($('#post-caption').val() == '') {
            $('#description_error').show();
        }

        if(file_selected == 0) {
            $('#image_error').show();
        }

        if($('#post-date').val() == '') {
            $('#start_date_error').show();
        }
    } else {
        document.getElementById("post-date").type = 'date';
        $('#postForm').hide();
        $('#postReview').show();
    }
    });
    $('.back-btn').on('click' , function () {
    $('#postForm').show();
    $('#postReview').hide();
    });
    function getFileNameWithExt(event) {
    if (!event || !event.target || !event.target.files || event.target.files.length === 0) {
    return;
    }
    const name = event.target.files[0].name;
    const lastDot = name.lastIndexOf('.');
    const fileName = name.substring(0, lastDot);
    const ext = name.substring(lastDot + 1);
    return ext;
    }
    });
    </script>
    @endpush