@extends('layouts.frontend')
<!-- Header -->
@section('header')
@include('partials.header')
@endsection

@section('contents')
<div class="background_section">
                <div class="section">
                        @include('flash-message')
                            <div class="container">

                                    <div class="cart_heading">
                                        @include('flash-message')
                                            <h3><strong>CAMPAIGN CART</strong></h3>
                                    </div>
                                @if($cart && sizeof($cartItems) > 0)
                                @foreach($cartItems as $cartItem)
                                    <?php
                                    $socialMediaAccount = $cartItem->campaign->influencer->social_medias->first();
                                    $feed = ['profile_picture' => asset('images/default.jpg'), 'followers_count' => 0];
                                    if($socialMediaAccount) {
                                        $socialMediaObject = new App\SocialmediaObject();
                                        $initializedSocialMediaObject = $socialMediaObject->initializeSocialMediaObject($socialMediaAccount->account_type, $socialMediaAccount->account_handle);
                                        $feed = $initializedSocialMediaObject->getSocialAccountFeedsDetails();
                                    }
                                    ?>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class= "cart_list">
                                                    <div class="row align-items-center h-100">
                                                    <div class="col-sm-3">
                                                            <img src="{{ $feed['profile_picture'] }}" style="width: 150px;" class=" rounded-circle" alt="" />
                                                    </div>
                                                    <div class="col-sm-3">
                                                            <a class="cart_follower_count"><strong style="color: #5ea956;">{{ App\SocialmediaObject::number_format_short( $feed['followers_count'] ) }}</strong></a>
                                                            <a class="cart_follower">  FOLLOWERS</a><br>
                                                            <a class="account_handle">{{ $socialMediaAccount ? '@' . $socialMediaAccount->account_handle : $cartItem->campaign->influencer->name }}</a>
                                                    </div>

                                                    <div class="col-sm-2">
                                                            <a><h3><strong>{{ $cartItem->campaign->duration }}HR</strong></h3></a>
                                                    </div>
                                                    <div class="col-sm-2">
                                                            <a><h3><strong>{{ $cartItem->campaign->price }}$</strong></h3></a>
                                                    </div>
                                                    <div class="col-sm-2">
                                                            <a onclick="deleteCartItem( {{ $cartItem->id }} )" style="color:black; cursor: pointer;"><i class="fa fa-trash" aria-hidden="true"></i></a>
                                                            <span id="no_of_items_{{ $cartItem->id }}">{{ $cartItem->no_of_items }}</span>
                                                    </div>
                                                </div>

                                            </div>
                                        </div>
                                    </div>
                                @endforeach

                                <div class="cart_button">
                                    <a href="{{ route('frontend.user.create_campaign_post') }}"><button type="button" class="button button-block">Proceed to Details</button></a>
                                </div>
                                {{ $cartItems->appends(request()->query())->links() }}
                                @else
                                    <h4>No Item Found In Cart</h4>
                                @endif
                                <input type="hidden" id="base_url" value="{{ asset('/') }}">


                                    </div>
                            </div>

                        <div class="section mt-5">
                            <div class="container">
                                <div class="row">
                                    <div class="col-12">
                                        <div id="switch">
                                            <div id="circle"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

    </div>

@endsection

@section('footer')
    @include('partials.footer')
@endsection
@section('scripts')
    <script>
        function deleteCartItem(itemId) {
            var url = $('#base_url').val() + 'frontend/delete_cart_item/' + itemId;
            $.ajax({

                type: "GET",
                url: url,
                success: function( data ) {
                    if( data > 0  ) {
                        $('#no_of_items_' + itemId).html(data);
                    } else {
                        $('#no_of_items_' + itemId).html(data);
                        window.location.href = $('#base_url').val() + 'frontend/campaign_cart'
                    }
                },
                error: function (data) {
                    alert(data);
                }

            });
        }
    </script>
@endsection

