@extends('layouts.frontend')
<!-- Header -->
@section('header')
    @include('partials.header')
@endsection

@section('contents')
    <div class="section full-height banner-section">
        <div class="section">
            @include('flash-message')
            <div class="container">
                <div class="campaign_heading">
                    <span>CAMPAIGN CART</span>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <div class= "campaign_list">

                            <div class="sort_div">
                                <a><strong>SORT</strong></a>
                                <select name="paginate" id="paginate">
                                    <option value="10" {{ isset($_REQUEST['pages']) && $_REQUEST['pages'] == 10 ? 'selected' : '' }}>10</option>
                                    <option value="50" {{ isset($_REQUEST['pages']) && $_REQUEST['pages'] == 50 ? 'selected' : '' }}>50</option>
                                    <option value="100" {{ isset($_REQUEST['pages']) && $_REQUEST['pages'] == 100 ? 'selected' : '' }}>100</option>
                                    <option value="150" {{ isset($_REQUEST['pages']) && $_REQUEST['pages'] == 150 ? 'selected' : '' }}>150</option>
                                </select>

                            </div>

                        </div>
                    </div>
                </div>
                <div class="row">

                    <div class="col-md-12">
                        <div class="table-responsive">
                            <!-- DATA TABLE STARTS -->
                            @if(count($cartItems))
                            <table id="dtBasicExample" class="table table-striped table-bordered" cellspacing="0" width="100%" style="background: #fff;">
                                <thead>
                                <tr>
                                    <th class="th-sm">CAMPAIGN NAME
                                    </th>
                                    <th class="th-sm">INFLUENCER
                                    </th>
                                    <th class="th-sm">POST DESCRTPTION
                                    </th>
                                    <th class="th-sm">POST FILE
                                    </th>
                                    <th class="th-sm">POST START DATE
                                    </th>
                                    <th class="th-sm">PRICE
                                    </th>
                                    <th class="th-sm">ACTIONS
                                    </th>

                                </tr>
                                </thead>
                                <tbody>


                                @foreach($cartItems as $cartItem)
                                    <tr>
                                        <td>{{ $cartItem->title }}</td>
                                        <td><a href="{{ asset( 'frontend/influencer/' . $cartItem->influencer_id) }}">{{ $cartItem->account_handle }}</a></td>
                                        <td>{{ $cartItem->description }}</td>
                                        <td>
                                            @if(!empty($cartItem->image))
                                                <img src="{{ asset('uploads/images/') . '/' . $cartItem->image }}" style="width: 200px;">
                                            @elseif(!empty($cartItem->video))
                                                <video width="200" height="120" controls>
                                                    <source src="{{ asset('uploads/images/'.$cartItem->video) }}" type="video/mp4">
                                                    Your browser does not support the video tag.
                                                </video>
                                            @else
                                                <img src="{{ asset('images/preview.jpg') }}" style="width: 200px;">
                                            @endif
                                        </td>
                                        <td>{{ date('d-m-Y' , strtotime($cartItem->start_date) )}}</td>
                                        <td>${{ $cartItem->price }}</td>
                                        <td>
<!--                                                 <a class="fa fa-cog dropdown-toggle" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"></a>
                                                <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                                                    <a class="dropdown-item" href="{{ route('frontend.user.checkout',['id' => $cartItem->id]) }}">Checkout</a>

                                                    <a class="dropdown-item" href="{{ route('frontend.user.delete_cart', ['id' => $cartItem->id]) }}">Delete</a>

                                                    <a class="dropdown-item" href="{{ route('frontend.user.edit_cart', ['id' => $cartItem->id]) }}">Edit</a>
                                                </div> -->

                                                <div class="dropdown campaign-action-dropdown">
                                                      <button class="dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                        <i class="fa fa-cog"></i>
                                                      </button>
                                                      <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                                                        <a class="dropdown-item" href="{{ route('frontend.user.checkout',['id' => $cartItem->id]) }}">Checkout</a>

                                                        <a class="dropdown-item" href="{{ route('frontend.user.delete_cart', ['id' => $cartItem->id]) }}">Delete</a>

                                                        <a class="dropdown-item" href="{{ route('frontend.user.edit_cart', ['id' => $cartItem->id]) }}">Edit</a>
                                                      </div>
                                                    </div>


                                        </td>
                                    </tr>
                                @endforeach

                                </tbody>
                            </table>
                            @else
                                <tr><h4>No Item Found In Cart</h4></tr>
                            @endif
                            <!-- DATA TABLE ENDS -->
                            {{ $cartItems->appends(request()->query())->links() }}

                            {{--<form class="w3-container w3-display-middle w3-card-4 w3-padding-16" method="POST" id="payment-form"
                                  action="{!! URL::to('frontend/paypal') !!}">
                                {{ csrf_field() }}
                                <input class="w3-input w3-border" id="amount" type="hidden" name="amount" value="">
                                <button class="w3-btn w3-blue">Pay with PayPal</button>
                            </form>--}}



                        </div>
                    </div>
                </div>




            </div>
        </div>




        <div class="section mt-5">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div id="switch">
                            <div id="circle"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </div>

@endsection

@section('footer')
    @include('partials.footer')
@endsection
@section('scripts')
    {{--<script src="{{ asset('frontend/js/jquery.js') }}"></script>
    <script src="{{ asset('frontend/js/popper.js') }}"></script>
    <script src="{{ asset('frontend/js/bootstrap.js') }}"></script>
    <script src="{{ asset('frontend/js/custom.js') }}"></script>--}}
    <script>
        $("#paginate").change(function(){
            var pages = $("#paginate").val();
            window.location.href = '{{ asset('/') }}' + 'frontend/cart?pages=' + pages;
        });
    </script>

@endsection
