@extends('layouts.frontend')
@section('modal')
<div id="loading-div" class="loading" style="display: none;">Loading&#8230;</div>
@include('partials.login_register_modal')
@endsection
<!-- Header -->
@section('header')
@include('partials.header')
@endsection
@section('contents')
@if($influencer->status != 'Verified')
<div class="modal fade" id="verifyAccountmodal">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-body p-4 text-center">
                <h1 class="text-center">VERIFICATION
                <span class="color-green">REQUIRED</span>
                </h1><hr>
                <p><strong>You need to verify your accout first</strong>     <br><br> To access most of the features for this profile, you first need to verify your accout. Click <strong>below</strong> to verify now. </p><hr>
                <div class="actionbtn">
                    <a href="{{ route('frontend.social.verify_account', ['account' => strtolower($influencer->account_type),'id' => $influencer->id]) }}">
                        <button>Verify Now!</button>
                    </a>
                </div>
            </div>
        </div>
    </div>
</div>
@endif
<div class="modal fade" id="deleteCampaign">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-body p-4 text-center">
                <h1 class="text-center">DELETING
                <span class="color-green">CAMPAIGN</span>
                </h1><hr>
                <p><strong>Are you sure you want to delete this campaign?</strong>     <br><br> This will not effect/delete ongoing orders against this campaign. </p><hr>
                <div class="actionbtn">
                    <a id="delete-campaign-btn" href="javascript:void(0);">
                        <button>Delete Now!</button>
                    </a>
                </div>
            </div>
        </div>
    </div>
</div>
<div class="modal fade" id="exampleCampaign">
    <div class="modal-dialog modal-dialog-centered modal-lg">
        <div class="modal-content">
            <div class="modal-body p-4 text-center">
                <img id="exampleImage" src="{!! asset('images/preview.jpg') !!}" height="250">
                <hr>
                <h3>Example Links:</h3>
                <span id="exampleLinks"></span>
                <hr>
                <div class="actionbtn">
                    <a data-dismiss="modal"  href="javascript:void(0)">
                        <button>OK</button>
                    </a>
                </div>
            </div>
        </div>
    </div>
</div>
<div class="background_section cart-pageinfo">
    <div class="section">
        @include('flash-message')
        <div class="container">
            <div class="influencer_name">
                <span>{{ $influencer->account_name }}</span>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <div class= "influencer_details">
                        <div class="row align-items-center h-100">
                            <div class="col-md-2 profileimg">
                                <img src="{{ $influencer->profile_picture }}" class=" rounded-circle" alt="" style="width: 150px;" onerror="this.src='{{asset('images/default.jpg')}}'" />
                            </div>
                            <div class="col-md-4 profileinfo">
                                <a class="account_handle"><strong>{{ 'Cloutsource account ' . $user->name . ' (@' . $influencer->account_handle . ')' }}</strong></a><br>
                                <img src="{{ asset('frontend/images/followers.png') }}">
                                <div class="follower_icon_text mb-2">
                                    <a class="cart_follower_count"><strong style="color: #5ea956;">{{ App\SocialmediaObject::number_format_short( $influencer->followers_count ) }}</strong><br><a class="cart_follower">FOLLOWERS</a></a>
                                </div>
                                @if(is_in_top10($influencer->id))
                                <br>
                                <a class="top-10">
                                    <i class="fa fa-star text-warning" aria-hidden="true"></i> <strong>Top 10 Percent</strong>
                                </a>
                                @endif
                            </div>
                            @if(auth()->check() && $influencer->user_id != auth()->user()->id)
                            <div class="chatbtn">
                                <a href="{{ url('frontend/user_messages?user_id=' . $user->id) }}" id="modal-open-button">Chat Now</a>
                            </div>
                            @endif
                            {{--<div class="col-md-6 text-center">
                                <img src="{{ asset('frontend/images/engagement.PNG') }}">
                                <div class="influencer_icon_text">
                                    <a class="badge badge-info">Top 10</a>
                                </div>
                            </div>--}}
                        </div>
                    </div>
                </div>
            </div>
            @if(!empty($influencer->description))
            <div class="row">
                <div class="col-md-12 parent-wrapper">
                    <div class="inner-header_left">
                        <a><strong>DESCRIPTION</strong></a>
                    </div>
                    <div class="inner-content-left min-height-upper">
                        <a class="inner_material_text">{!! $influencer->description !!}</a><br><br>
                        {{--<a class="inner_material_head">Impressions:</a>
                        <a class="inner_material_text">(Weekely)2.000,000+</a><br>
                        <a class="inner_material_head">Average likes per post:</a>
                        <a class="inner_material_text">15000-20000</a><br><br><br>--}}
                        {{--<a class="inner_material_head">Audience Statistics</a><br><br>
                        <a class="inner_material_head">-50%</a>
                        <a class="inner_material_text">Male</a><br>
                        <a class="inner_material_head">-50%</a>
                        <a class="inner_material_text">Female</a>--}}
                    </div>
                </div>
                <!--                                 <div class="col-md-12 parent-wrapper">
                    <div class="inner-header_right">
                        <a><strong>DEMOGRAPHY</strong></a>
                    </div>
                    <div class="inner-content-right min-height-upper">
                        @if($influencer->demography)
                        <a class="inner_material_head">Language: </a>
                        <a class="inner_material_text">{{ $influencer->demography->language }}</a><br>
                        <a class="inner_material_head">Country: </a>
                        <a class="inner_material_text">{{ $influencer->demography->country }}</a><br>
                        <a class="inner_material_head">Age: </a>
                        <a class="inner_material_text">{{ $influencer->demography->age }} Years</a><br>
                        <a class="inner_material_head">Activity: </a>
                        <a class="inner_material_text">{{ $influencer->demography->activity }}</a><br>
                        @endif
                    </div>
                </div> -->
            </div>
            @endif
            <div class="row">
                <div class="col-md-12 parent-wrapper">
                    <div class="inner-header_right">
                        <a><strong>STATICS</strong></a>
                    </div>
                    <div class="inner-content-right min-height-content">
                        <a class="inner_material_head"><i class="far fa-thumbs-up"></i> Avg. likes: </a>
                        <a class="inner_material_text">{{ \App\SocialmediaObject::number_format_short( $influencer->avg_likes ) }}</a><br>

                        <a class="inner_material_head"><i class="far fa-thumbs-up"></i> Total likes: </a>
                        <a class="inner_material_text">{{ \App\SocialmediaObject::number_format_short( $influencer->total_likes ) }}</a><br>

                        <a class="inner_material_head"><i class="far fa-comment"></i> Total posts: </a>
                        <a class="inner_material_text">{{ \App\SocialmediaObject::number_format_short( $influencer->total_posts ) }}</a><br>
                    </div>
                </div>
                @if(auth()->check() && $influencer->user_id == auth()->user()->id)
                <div class="col-md-12 parent-wrapper">
                    <div class="inner-header_right">
                        <a><strong>ADD/REMOVE SERVICES OFFERED AND TYPES OF ACCOUNT</strong></a>
                    </div>
                    <form action="{{ url('frontend/influencer/update_tags_services') }}" method="post">
                        @csrf
                        <input type="hidden" id="influencer_id" name="influencer_id" value="{{ $influencer->id }}">
                        <div class="inner-content-right min-height-content">
                            <a class="inner_material_head"></i> Please choose services </a> <br>
                            <select name="services[]" id="services" class="form-control select2" multiple>
                                @foreach($services as $service)
                                <option value="{{ $service->id }}" {{ in_array($service->id, $selectedServices) ? 'selected' : '' }}>{{ $service->title }}</option>
                                @endforeach
                            </select>
                            <a class="inner_material_head"></i> Please choose Account Types </a> <br>
                            <select name="tags[]" id="tags" class="form-control select2" multiple>
                                @foreach($tags as $tag)
                                <option value="{{ $tag->id }}" {{ in_array($tag->id, $selectedTags) ? 'selected' : '' }}>{{ $tag->title }}</option>
                                @endforeach
                            </select>
                            <a class="inner_material_head"></i> Please Fill address Fields </a> <br>
                            <input type="text" id="country" name="country" class="form-control" value="{{ $influencer->country }}" placeholder="Country"><br>
                            <input type="text" id="city" name="city" class="form-control" value="{{ $influencer->city }}" placeholder="City"><br>
                            <input type="text" id="zip_code" name="zip_code" class="form-control" value="{{ $influencer->zip_code }}" placeholder="Zip Code"><br>
                            <a class="inner_material_head"></i> Tell more about yourself (Optional) </a> <br>
                            <textarea id="extra_note" name="extra_note" class="form-control">{{ $influencer->extra_note }}</textarea><br>
                            <button type="submit">Update</button>
                        </div>
                    </form>
                </div>
                @elseif(sizeof($selectedServices) > 0 || sizeof($selectedTags) > 0 || !is_null($influencer->country) || !is_null($influencer->city) || !is_null($influencer->zip_code) || !is_null($influencer->extra_note))
                <div class="col-md-12 parent-wrapper">
                    <div class="inner-header_right">
                        <a><strong>ACCOUNT DETAILS</strong></a>
                    </div>
                    <div class="inner-content-right min-height-content">

                        @if(sizeof($selectedServices) > 0)
                        <div class="account-detail-inner">
                            <a class="inner_material_head"> Chosen Services </a>
                            <div class="form-control" style="border: none; padding: 0;">
                                @php $serviceTitles = []; @endphp
                                @foreach($services as $service)
                                @if(in_array($service->id, $selectedServices))
                                @php $serviceTitles[] = $service->title; @endphp
                                @endif
                                @endforeach
                                {{ implode(', ', $serviceTitles) }}
                            </div>
                        </div>
                        @endif

                        @if(sizeof($selectedTags) > 0)
                        <div class="account-detail-inner">
                            <a class="inner_material_head"> Account Types </a> 
                            <div class="form-control" style="border: none; padding: 0;">
                                @php $tagTitles = []; @endphp
                                @foreach($tags as $tag)
                                @if(in_array($tag->id, $selectedTags))
                                @php $tagTitles[] = $tag->title; @endphp
                                @endif
                                @endforeach
                                {{ implode(', ', $tagTitles) }}
                            </div>
                        </div>
                        @endif


                        @if(!is_null($influencer->country) || !is_null($influencer->city) || !is_null($influencer->zip_code))
                        <div class="account-detail-inner">
                        <a class="inner_material_head"></i> Address Fields </a> 
                        @if(!is_null($influencer->country))
                        {{ 'Country: ' . $influencer->country }}<br>
                        @endif
                        @if(!is_null($influencer->city))
                        {{ 'City: ' . $influencer->city }}<br>
                        @endif
                        @if(!is_null($influencer->zip_code))
                        {{ 'Zip Code: ' . $influencer->zip_code }}<br>
                        @endif
                        </div>
                        @endif

                        @if(!is_null($influencer->extra_note))
                        <div class="account-detail-inner">
                        <a class="inner_material_head"></i> Additional Info </a> 
                        {{ $influencer->extra_note }}<br>
                        </div>
                        @endif

                    </div>
                </div>
                @endif
                <div class="col-md-12 parent-wrapper">
                    <div class="inner-header_left">
                        <a><strong>CAMPAIGNS</strong></a>
                    </div>
                    <div class="inner-content-left min-height-content">
                        @if($influencer->status == 'Verified')
                        @if(!count($campaigns))
                        No Campaigns initialized
                        @endif
                        @foreach($campaigns as $campaign)
                        <div class="campain-inner">
                            <a style="cursor: pointer;" onclick="expand_campaign( {{ $campaign->id }} )"><i class="far fa-check-circle"></i> {{ !empty($campaign->title) ? $campaign->title : 'Campaign-'.$loop->iteration }} - <strong>{{ $campaign->price }}$</strong></a>
                            @if(Auth::check())
                            @if($influencer->user_id == Auth::user()->id)
                            <div class="switcher">
                                <label class="switch">
                                    <input class="enable-toggle" type="checkbox" id="enable-{{$campaign->id}}" value="{{$campaign->id}}" @if($campaign->status == 'enabled') checked @endif>
                                    <span class="slider round"></span>
                                </label>
                                <a class="fa fa-cog dropdown-toggle" data-toggle="dropdown"></a>
                                <div class="dropdown-menu">
                                    <a class="dropdown-item" href="javascript:void(0);" onclick="toggleDeleteModal('{{ route('frontend.user.delete_campaign', ['id' => $campaign->id]) }}')">Delete</a>
                                    <a class="dropdown-item" href="{{ route('frontend.user.edit_campaign', ['id' => $campaign->id]) }}">Edit</a>
                                </div>
                            </div>
                            @endif
                            @endif
                        </div>
                        <div class="row" id="popup_div_{{ $campaign->id }}" style="display:none;">
                            <div class="col-md-12">
                                <div class= "package_data">
                                    @if($campaign->description)
                                    <span>{!! $campaign->description !!}</span>
                                    @endif
                                    @if(!is_null($campaign->example_links) || !is_null($campaign->example_image))
                                    <a href="javascript:void(0)" onclick="toggleExampleModal('{{ $campaign->example_image }}' , '{{$campaign->example_links}}')" class="float-right text-primary">Show Example</a>
                                    @endif
                                    <hr>
                                    <span>Includes:</span><br>
                                    <span>
                                        <i @if($campaign->user_provides_media == 1) class="far fa-check-circle " style="color: #5ea956" @else class="fa fa-times-circle-o" style="color: red" @endif></i>
                                        &nbsp; Media
                                    </span><br>
                                    <span>
                                        <i @if($campaign->user_provides_links == 1) class="far fa-check-circle " style="color: #5ea956" @else class="fa fa-times-circle-o" style="color: red" @endif></i>
                                        &nbsp; Links
                                    </span><br>
                                    <span>
                                        <i @if($campaign->user_provides_description == 1) class="far fa-check-circle " style="color: #5ea956" @else class="fa fa-times-circle-o" style="color: red" @endif></i>
                                        &nbsp; Caption
                                        @if(!Auth::check() || $influencer->user_id != Auth::user()->id)
                                        <div class= "details_button">
                                            <a href="{{ route('frontend.user.create_campaign_post', ['campaign_id' => $campaign->id]) }}"><button type="submit" class="button button-block ml-auto">Buy Now</button></a>
                                        </div>
                                        @endif
                                    </span>
                                </div>
                            </div>
                        </div>
                        @endforeach
                        @else
                        <span class="text-danger">
                            You need to verify your account first. Click <a href="{{ route('frontend.social.verify_account', ['account' => strtolower($influencer->account_type),'id' => $influencer->id]) }}">here</a> to verify now.
                        </span>
                        @endif
                        <input type="hidden" id="base_url" value="{{ asset('/') }}">
                        @if(Auth::check())
                        @if($influencer->user_id == Auth::user()->id && $influencer->status == 'Verified')
                        <div class= "details_button">
                            <a href="{{ route('frontend.user.create_campaign', ['media_account_id' => $influencer->id]) }}"><button type="submit" class="button button-block">Create Campaigns</button></a>
                        </div>
                        @endif
                        @endif
                    </div>
                </div>
            </div>
        </div>
        <div class="section mt-5">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div id="switch">
                            <div id="circle"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    @endsection
    @section('footer')
    @include('partials.footer')
    @endsection
    @section('scripts')
    <script>
    function expand_campaign(campaignId) {
    /* var url = $('#base_url').val() + 'frontend/add_to_cart/' + campaignId;
    $.ajax({
    type: "GET",
    url: url,
    success: function( data ) {
    if(data == 'auth_error') {
    alert('Please Login to Add to Cart.');
    } else if (data == 'access_error') {
    alert('You don not have permissions to Add to Cart.');
    } else if(data == 'success') {
    alert('One Item added to Cart.');
    }
    },
    error: function (data) {
    alert(data);
    }
    }); */
    // $('#popup_div_' + campaignId).show();
    var popup = document.getElementById('popup_div_' + campaignId);
    var displaySetting = popup.style.display;
    if (displaySetting == 'none') {
    $('#popup_div_' + campaignId).show();
    }
    else {
    $('#popup_div_' + campaignId).hide();
    }
    }
    $(document).ready(function(){
    $('#verifyAccountmodal').modal('toggle');
    $('.enable-toggle').on('change' , function () {
    if(this.checked){
    update_status(this.value , 'enabled');
    }else{
    update_status(this.value , 'disabled');
    }
    });
    function update_status(id,flag){
    $('#loading-div').show();
    $.ajax({
    type: "GET",
    url: '{{URL::to('/')}}/frontend/change_campaign_status/'+id+'/'+flag,
    success: function( data ) {
    $('#loading-div').hide();
    if(data.status == 1) {
    alert('Somwthings Wrong');
    }
    },
    error: function (data) {
    $('#loading-div').hide();
    alert('Server Error');
    }
    });
    }
    $('.select2').select2({
    closeOnSelect: false
    });
    });
    function toggleExampleModal(image , links){
    $('#exampleLinks').html('');
    $('#exampleImage').show();
    if(links != null && links != ''){
    links = links.replace(' ' , '');
    var links_array = links.split(',');
    links_array.forEach(function (link) {
    if(!link.includes('https://')){
    link = 'https://'+link;
    }
    link = link.replace(' ' , '');
    $('#exampleLinks').append('<a href="'+link+'" target="_blank">'+link+'</a><br>');
    });
    }
    console.log(image.length);
    if(image.length > 0){
    $('#exampleImage').attr('src' , '{{ URL::to("/") }}/'+image);
    }else{
    $('#exampleImage').hide();
    }
    $('#exampleCampaign').modal('toggle');
    }
    function toggleDeleteModal(url){
    $('#delete-campaign-btn').attr('href' , url);
    $('#deleteCampaign').modal('toggle');
    }
    @if(isset($_REQUEST['scroll']))
    $("html, body").animate({ scrollTop: $(document).height()-$(window).height() });
    @endif
    </script>
    @endsection