@extends('layouts.frontend')
<!-- Header -->
@section('header')
    @include('partials.header')
@endsection

@section('contents')
    <div class="section full-height banner-section">
        <div class="absolute-center">
            <div class="section" style="margin-top: 180px;">
                <div class="container">
                    <div class="row">

                        <div class="col-4">

                            <div class="modal-body p-0">
                                <div class="signinform">
                                    <div class="form">

                                        <div id="signup">
                                            <h2><span>Create Campaign</span></h2>

                                            <div class="textform">
                                                <form method="POST" action="{{ route('frontend.user.post_package') }}">
                                                    @csrf

                                                    <div class="field-wrap">
                                                        <input type="text" name="name" placeholder="Title" required autocomplete="off"/>
                                                        @if ($errors->has('name'))
                                                            <span class="invalid-feedback" style="display: block;">
                                                            <strong>{{ $errors->first('name') }}</strong>
                                                            </span>
                                                        @endif
                                                    </div>

                                                    <div class="field-wrap">
                                                        <select name="campaigns[]" id="campaigns" class="form-control select2" multiple="multiple">
                                                            @foreach($campaigns as $campaign)
                                                                <option value="{{ $campaign->id }}">{{ $campaign->name }}</option>
                                                            @endforeach
                                                        </select>
                                                        @if ($errors->has('campaigns'))
                                                            <span class="invalid-feedback" style="display: block;">
                                                            <strong>{{ $errors->first('campaigns') }}</strong>
                                                            </span>
                                                        @endif
                                                    </div>

                                                    <div class="field-wrap">
                                                        <input type="text" name="cost" placeholder="Price" required autocomplete="off"/>
                                                        @if ($errors->has('cost'))
                                                            <span class="invalid-feedback" style="display: block;">
                                                            <strong>{{ $errors->first('cost') }}</strong>
                                                            </span>
                                                        @endif
                                                    </div>

                                                    <input type="hidden" name="admin_id" value="{{ $user->id }}">


                                                    <button type="submit" class="button button-block">CREATE</button>

                                                </form>

                                            </div>

                                        </div>
                                    </div></div></div></div>

                    </div> <!-- Row ends here -->

                </div>
            </div>
            <div class="section mt-5">
                <div class="container">
                    <div class="row">
                        <div class="col-12">
                            <div id="switch">
                                <div id="circle"></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('footer')
    @include('partials.footer')
@endsection
