@extends('layouts.frontend')
<!-- Header -->
@section('header')
    @include('partials.header')
@endsection

@section('contents')
    <div class="section full-height banner-section">
        <div class="absolute-center">
            @include('flash-message')
            <div class="section">
                <div class="container">
                    <div class="row">

                        <div class="col-4">

                            <div class="modal-body p-0">
                                <div class="signinform">
                                    <div class="form">

                                        <div id="signup">
                                            <h2><span>Create Notification</span></h2>

                                            <div class="textform">
                                                <form method="POST" action="{{ route('frontend.user.post_notification') }}">
                                                    @csrf

                                                    <div class="field-wrap">
                                                        <select name="to_user_id" class="form-control" required>
                                                            <option value="">Choose Receiver</option>
                                                            @foreach($users as $user)
                                                                <option value="{{ $user->id }}">{{ $user->name }}</option>
                                                            @endforeach
                                                        </select>
                                                        @if ($errors->has('to_user_id'))
                                                            <span class="invalid-feedback" style="display: block;">
                                        <strong>{{ $errors->first('to_user_id') }}</strong>
                                        </span>
                                                        @endif
                                                    </div>

                                                    <div class="field-wrap">
                                                        <textarea name="message" placeholder="Write a Message here" required class="form-control"></textarea>
                                                        @if ($errors->has('message'))
                                                            <span class="invalid-feedback" style="display: block;">
                                        <strong>{{ $errors->first('message') }}</strong>
                                        </span>
                                                        @endif
                                                    </div>


                                                    <button type="submit" class="button button-block">SEND</button>

                                                </form>

                                            </div>

                                        </div>
                                    </div></div></div></div>

                    </div> <!-- Row ends here -->

                </div>
            </div>
            <div class="section mt-5">
                <div class="container">
                    <div class="row">
                        <div class="col-12">
                            <div id="switch">
                                <div id="circle"></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('footer')
    @include('partials.footer')
@endsection



