@extends('layouts.frontend')
<!-- Header -->
@section('header')
    @include('partials.header')
@endsection

@section('contents')
    <div class="background_section">
            <div class="section">
                @include('flash-message')
                <div class="container">
                        <div class="ticket_heading">
                                <span>Create Ticket</span>
                        </div>
                    <div class="row">
                            <div class="col-md-6" style="margin:auto;">
                                    <div class="socialform">
                                    <div class="form" style="margin: 50px 0px 50px 0px;">


                                            <div class="textform">
                                                <form method="POST" action="{{ route('frontend.user.post_ticket') }}">
                                                    @csrf
                                                    <div class="field-wrap">
                                                        <input type="text" name="subject" placeholder="Subject" required autocomplete="off"/>
                                                        @if ($errors->has('subject'))
                                                            <span class="invalid-feedback" style="display: block;">
                                                            <strong>{{ $errors->first('subject') }}</strong>
                                                            </span>
                                                        @endif
                                                    </div>

                                                    <div class="field-wrap">
                                                        <div class="row-fluid">
                                                        <select name="influencer_id" class="selectpicker form-control" data-show-subtext="true" data-live-search="true">
                                                            <option value="0" selected>General</option>
                                                            @foreach($socials as $influencer)
                                                                <option value="{{ $influencer->id }}" data-subtext="{{ $influencer->account_type }}"><strong>{{ '@'.$influencer->account_handle }}</strong></option>
                                                            @endforeach
                                                        </select>
                                                        </div>
                                                        @if ($errors->has('against_user_id'))
                                                            <span class="invalid-feedback" style="display: block;">
                                                                <strong>{{ $errors->first('against_user_id') }}</strong>
                                                            </span>
                                                        @endif
                                                    </div>

                                                    <div class="field-wrap">
                                                        <div class="row-fluid">
                                                            <select name="type" class="form-control" required>
                                                                <option value="" disabled selected hidden>Choose a type</option>
                                                                <option value="spam">Spam</option>
                                                                <option value="conflict">Conflict</option>
                                                                <option value="complain">Complain</option>
                                                                <option value="improvement-required">Improvement required</option>
                                                            </select>
                                                        </div>
                                                    </div>

                                                    <div class="field-wrap">
                                                        <textarea name="description"  placeholder="Description"  class="form-control" required></textarea>
                                                        @if ($errors->has('description'))
                                                            <span class="invalid-feedback" style="display: block;">
                                                            <strong>{{ $errors->first('description') }}</strong>
                                                            </span>
                                                        @endif
                                                    </div>

                                                    <button type="submit" class="button button-block">CREATE</button>

                                                </form>

                                            </div>

                                        
                                    </div></div></div>

                    </div> <!-- Row ends here -->

                </div>
            </div>
            <div class="section mt-5">
                <div class="container">
                    <div class="row">
                        <div class="col-12">
                            <div id="switch">
                                <div id="circle"></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('footer')
    @include('partials.footer')
@endsection
@section('scripts')
    <script src="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/js/bootstrap-select.min.js"></script>
@endsection
@push('after-css')
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/css/bootstrap-select.min.css">
    <style>
        ul.dropdown-menu.inner.show {
            transform: translate3d(0px, 0px, 0px)!important;
            max-height: 100px;
        }
        .form{
            min-height: 350px;
        }
    </style>
@endpush

