@extends('layouts.frontend')
<!-- Header -->
@section('header')
    @include('partials.header')
@endsection

@section('contents')
    <div class="background_section">
                    <div class="section">
                            @include('flash-message')
                            <div class="container">
                                    <div class="edit_profile">
                                            <span>{{ $user->role->title }}</span>
                                    </div>
                                <div class="row">
                                    <div class="col-md-6" style="margin:auto;">
                                        <div class="edit_profile_box">
                                            <div class="editform">
                                                <div class="form">
                                                        <div class="edit_textform">

                                                                <form method="POST" id="create_form">
                                                                    @csrf

                                                                    <div class="field-wrap">
                                                                        <input type="text" name="name" placeholder="Full Name" required autocomplete="off" value="{{ $user->name }}"/>

                                                                            <span class="invalid-feedback" style="display: block;" id="name_error">
                                                                        <strong></strong>
                                                                        </span>

                                                                    </div>


                                                                    <div class="field-wrap">
                                                                        <input type="email" name="email" placeholder="Email" required autocomplete="off" value="{{ $user->email }}" readonly/>

                                                                            <span class="invalid-feedback" style="display: block;" id="email_error">
                                                                        <strong></strong>
                                                                        </span>

                                                                    </div>
                                                                    <div class="field-wrap">

                                                                        <input type="text" name="phone" placeholder="Contact" required autocomplete="off" value="{{ $user->phone }}" />

                                                                            <span class="invalid-feedback" style="display: block;" id="phone_error">
                                                                        <strong></strong>
                                                                        </span>


                                                                    </div>

                                                                    <div class="field-wrap">

                                                                        <select class="form-control" name="timezone">
                                                                            @foreach($timezonesList as $val)
                                                                            <option value="{{ $val }}" {{ $val == $user->timezone ? 'selected' : '' }}>{{ $val }}</option>
                                                                            @endforeach
                                                                        </select>

                                                                    </div>

                                                                    <div class="field-wrap">

                                                                            <input type="text" name="website" placeholder="Website" autocomplete="off" value="{{ $user->website }}"/>

                                                                    </div>
                                                                    <div class="field-wrap">

                                                                        <input type="text" name="website" placeholder="Website" autocomplete="off" value="{{ $user->website }}"/>

                                                                    </div>

                                                                    <div class="field-wrap">

                                                                        <input type="text" name="country" placeholder="Country" required autocomplete="off" value="{{ $user->country }}" />

                                                                        <span class="invalid-feedback" style="display: block;" id="country_error">
                                                                        <strong></strong>
                                                                        </span>


                                                                    </div>

                                                                    <div class="field-wrap">

                                                                        <input type="text" name="city" placeholder="City" autocomplete="off" value="{{ $user->city }}" />

                                                                        <span class="invalid-feedback" style="display: block;" id="city_error">
                                                                        <strong></strong>
                                                                        </span>


                                                                    </div>

                                                                    <div class="field-wrap">

                                                                        <input type="text" name="zip_code" placeholder="Zip Code" autocomplete="off" value="{{ $user->zip_code }}" />

                                                                        <span class="invalid-feedback" style="display: block;" id="zip_code_error">
                                                                        <strong></strong>
                                                                        </span>


                                                                    </div>

                                                                    <button type="button" class="button button-block" id="submit_button">UPDATE</button>

                                                                </form>

                                        </div>
                                </div></div></div></div>

                                </div> <!-- Row ends here -->

                            </div>
                        </div>
                        <div class="section mt-5">
                            <div class="container">
                                <div class="row">
                                    <div class="col-12">
                                        <div id="switch">
                                            <div id="circle"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
    </div>

    <div class="Referral">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <h5><b>Referrals</b></h5>
                    <p>Send "REFERRAL" to your friends and ask them to use this while register to earn reward credits.Enter your friend's email address and click on send button to send this code via email.</p>
                </div>
            </div>
        </div>
    </div>
  
@endsection

@section('footer')
    @include('partials.footer')
@endsection

@section('scripts')
    <script src="{!! asset('js/firebase/firebase-app.js') !!}"></script>
    <script src="{!! asset('js/firebase/firebase-firestore.js') !!}"></script>
    <script src="{!! asset('js/firebase/firebase-messaging.js') !!}"></script>
    <script src="{!! asset('js/firebase/firebase-chat-config.js') !!}"></script>
    <script src="{!! asset('js/helper.js') !!}"></script>

    <script>
        $(document).ready(function() {

            var frm = document.getElementById('create_form');

            $('#submit_button').on('click', function (event) {
                $('.invalid-feedback').hide();
                $.ajax({
                    url: "{{ route('frontend.user.update_profile') }}",
                    method: "POST",
                    data: new FormData(frm),
                    dataType: 'JSON',
                    contentType: false,
                    cache: false,
                    processData: false,
                    success: function (data) {
                        $('.invalid-feedback').hide();
                        db.collection(usersCollection).where("id", "==", parseInt({{ $user->id }})).limit(1)
                            .get()
                            .then(function(querySnapshot) {
                                querySnapshot.forEach(function(doc) {
                                    console.log(doc.id, " => ", doc.data());
                                    db.collection(usersCollection).doc(doc.id).update({
                                        //id: user.id,
                                        name: data.name,
                                        //avatar: user.avatar
                                    });
                                });
                                window.location.href = "{{ url('frontend/edit_profile') }}";
                            });
                    },
                    error: function (data) {

                        var errors = data.responseJSON.errors;
                        $('.invalid-feedback').hide();
                        $.each(errors, function(key,val){
                            $('#' + key + '_error').show();
                            $('#' + key + '_error').html(errors[key]);
                        });
                        return false;
                    }

                });
                return false;
            });

        });
    </script>
@endsection



