@extends('layouts.frontend')
<!-- Header -->
@section('header')
    @include('partials.header')
@endsection

@section('contents')
    <div class="background_section">
                    <div class="section">
                            @include('flash-message')
                            <div class="container">
                                    <div class="campaign_heading">
                                            <span>CAMPAIGN LIST</span>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class= "campaign_list">
                                                {{--@if(Auth::user()->role->title == 'User')
                                                    <div class = "campaign_button">
                                                        <a href="{{ route('frontend.user.create_campaign') }}"><button type="button" class="button button-block">New Campaign</button></a>
                                                    </div>
                                                @endif--}}

                                                <div class="sort_div" style="display: none">

                                                            <div class="input-group mb-3">
                                                                    {{--<div class="input-group-prepend">
                                                                    <span class="input-group-text">
                                                                    <a>SORT</a>
                                                                    <span>
                                                                    </div>
                                                            <select name="pages">
                                                                    <option value="0">6 Entries</option>
                                                                    <option value="1">10 Entries</option>
                                                                    <option value="2">15 Entries</option>
                                                                    <option value="3">20Entries</option>
                                                                </select>--}}
                                                            </div>


                                                </div>

                                            </div>
                                        </div>
                                </div>
                                    <div class="row">

                                            <div class="col-md-12">
                    <div class="table-responsive">
                                         <!-- DATA TABLE STARTS -->
                                            <table id="dtBasicExample" class="table table-striped table-bordered" cellspacing="0" width="100%" style="background: #fff; margin-bottom:0px">
                                                <thead>
                                                <tr>
                                                    <th class="th-sm">COMPAIGN NAME
                                                    </th>
                                                    <th class="th-sm">ACCOUNT
                                                    </th>
                                                    <th class="th-sm">PRICE
                                                    </th>
                                                    <th class="th-sm">STATUS
                                                    </th>
                                                    {{--<th class="th-sm">ADMIN STATUS
                                                    </th>--}}
                                                    <th class="th-sm">SETTING
                                                    </th>

                                                </tr>
                                                </thead>
                                                <tbody>

                                                @foreach($campaigns as $campaign)
                                                <tr>
                                                    <td>{{ $campaign->title }}</td>
                                                    <td><a href="{{ asset( 'frontend/influencer/' . $campaign->account_id) }}">{{'@'. $campaign->account_handle }}</a></td>
                                                    <td>{{ $campaign->price.'$' }}</td>
                                                    <td>
                                                        <label class="switch">
                                                            <input class="enable-toggle" type="checkbox" id="enable-{{$campaign->id}}" value="{{$campaign->id}}" @if($campaign->status == 'enabled') checked @endif>
                                                            <span class="slider round"></span>
                                                        </label>
                                                    </td>
                                                    {{--<td>
                                                        @if($campaign->admin_status == 'approved')
                                                            <span class="badge badge-success">{{ $campaign->admin_status ?? '' }}</span>
                                                        @elseif($campaign->admin_status == 'pending')
                                                            <span class="badge badge-warning">{{ $campaign->admin_status ?? '' }}</span>
                                                        @else
                                                            <span class="badge badge-danger">{{ $campaign->admin_status ?? '' }}</span>
                                                        @endif
                                                    </td>--}}
                                                    <td>
                                                    <div class="dropdown allcampaign-dropdown">
                                                          <button class="dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                            <i class="fa fa-cog"></i>
                                                          </button>
                                                          <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                                                         <a class="dropdown-item" href="{{ route('frontend.user.delete_campaign', ['id' => $campaign->id]) }}">Delete</a>

                                                         <a class="dropdown-item" href="{{ route('frontend.user.edit_campaign', ['id' => $campaign->id]) }}">Edit</a>
                                                          </div>
                                                        </div>
                                                    </td>
                                                </tr>
                                                @endforeach

                                                </tbody>
                                            </table>
                                         <!-- DATA TABLE ENDS -->
                                            {{ $campaigns->links() }}
                                            </div>
                                        </div>
                                        </div>




                            </div>
                    </div>




                        <div class="section mt-5">
                            <div class="container">
                                <div class="row">
                                    <div class="col-12">
                                        <div id="switch">
                                            <div id="circle"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

    </div>

@endsection

@section('footer')
    @include('partials.footer')
@endsection

@push('after-js')
    <script>
      $(document).ready(function(){
        $('.enable-toggle').on('change' , function () {
          if(this.checked){
            update_status(this.value , 'enabled');
          }else{
            update_status(this.value , 'disabled');
          }
        });

        function update_status(id,flag){
          $('#loading-div').show();
          $.ajax({

            type: "GET",
            url: '{{URL::to('/')}}/frontend/change_campaign_status/'+id+'/'+flag,
            success: function( data ) {
              $('#loading-div').hide();
              if(data.status == 1) {
                alert('Somwthings Wrong');
              }
            },
            error: function (data) {
              $('#loading-div').hide();
              alert('Server Error');
            }
          });
        }
      });
    </script>
@endpush


