@extends('layouts.frontend')
<!-- Header -->
@section('header')
    @include('partials.header')
@endsection

@section('contents')
    <div class="background_section">
        <div class="section">
            @include('flash-message')
            <div class="container">
                <div class="campaign_heading">
                    <span>ORDER LIST</span>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <div class= "campaign_list">

                            <div class="sort_div" style="display: none">
                                <div class="input-group mb-3">
                                    <div class="input-group-prepend">
                                                                <span class="input-group-text">
                                                                <a>SORT</a>
                                                                <span>
                                    </div>
                                    <select name="pages">
                                        <option value="0">6 Entries</option>
                                        <option value="1">10 Entries</option>
                                        <option value="2">15 Entries</option>
                                        <option value="3">20Entries</option>
                                    </select>
                                </div>
                            </div>

                        </div>
                    </div>
                </div>
                <div class="row">

                    <div class="col-md-12" id="campaigns_table_div">
                        <div class="table-responsive">
                            <!-- DATA TABLE STARTS -->
                            @if(count($orders))
                            <table id="dtBasicExample" class="table table-striped table-bordered" cellspacing="0" width="100%" style="background: #fff; margin-bottom:0px">
                                <thead>
                                <tr>
                                    <th class="th-sm">INFLUENCER ACCOUNT
                                    </th>
                                    <th class="th-sm">TOTAL AMOUNT
                                    </th>
                                    <th class="th-sm">STATUS
                                    </th>
                                    <th class="th-sm">ACTIONS
                                    </th>

                                </tr>
                                </thead>
                                <tbody>

                                @foreach($orders as $order)
                                    <tr>
                                        <td><a href="{{ route('frontend.user.influencer_details' , ['id' => $order->influencer_id]) }}">{{ '@'.$order->account_handle }}</a></td>
                                        <td>{{ $order->amount }}</td>
                                        <td>
                                            @if($order->status == 'pending')
                                                <span class="badge badge-warning">{{ucwords(str_replace('-' , ' ' ,$order->status))}}</span>
                                            @elseif($order->status == 'new')
                                                <span class="badge badge-success">{{ucwords(str_replace('-' , ' ' ,$order->status))}}</span>
                                            @elseif($order->status == 'in-progress')
                                                <span class="badge badge-info">{{ucwords(str_replace('-' , ' ' ,$order->status))}}</span>
                                            @elseif($order->status == 'completed')
                                                <span class="badge badge-success">{{ucwords(str_replace('-' , ' ' ,$order->status))}}</span>
                                            @elseif($order->status == 'feedback-required')
                                                <span class="badge badge-primary">{{ucwords(str_replace('-' , ' ' ,$order->status))}}</span>
                                            @elseif($order->status == 'rejected')
                                                <span class="badge badge-danger">{{ucwords(str_replace('-' , ' ' ,$order->status))}}</span>
                                            @elseif($order->status == 'reopened')
                                                <span class="badge badge-warning">{{ucwords(str_replace('-' , ' ' ,$order->status))}}</span>
                                            @elseif($order->status == 'order-refund')
                                                <span class="badge badge-primary">{{ucwords(str_replace('-' , ' ' ,$order->status))}}</span>
                                            @endif
                                        </td>
                                        <td>
                                            <a class="text-dark" href="{{route('frontend.user.order_details' , ['id' => $order->id])}}"><i class="fa fa-eye"></i> &nbsp; View Details</a>
                                        </td>
                                    </tr>
                                @endforeach

                                </tbody>
                            </table>
                            <!-- DATA TABLE ENDS -->
                            {{ $orders->links() }}
                            @else
                                No Orders found
                            @endif
                        </div>

                    </div>
                    <input type="hidden" id="base_url" value="{{ asset('/') }}">
                </div>




            </div>
        </div>




        <div class="section mt-5">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div id="switch">
                            <div id="circle"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </div>

@endsection

@section('footer')
    @include('partials.footer')
@endsection
