@extends('layouts.frontend')
<!-- Header -->
@section('header')
    @include('partials.header')
@endsection

@section('contents')

    <div id="notif_modal" class="modal fade" role="dialog">
        <div class="modal-dialog">
            <!-- Modal content-->
            <div class="modal-content">
                <div class="modal-header">
                   
                    <h1 class="text-center">Notification
                <span class="color-green">Details</span>
                </h1>
                    <button type="button" class="close"
                            data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <p id="notif_details"></p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Close
                    </button>
                </div>
            </div>
        </div>
    </div>


    <div id="notifications-section" class="section banner-section">
                    <div class="section">
                            @include('flash-message')
                            <div class="container notification-container">
                                    <div class="notification_heading">
                                            <span>NOTIFICATIONS</span>
                                    </div>

                                @foreach($notifications as $notification)
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class= "notification_list" @if($notification->status == 'Unread') style="background-color: #d4d4d4;" @endif>
                                                    <div class="notification_icon">
                                                        <i class="fa {!! ($notification->status == 'Read') ? 'fa-eye':'fa-volume-up' !!} circle-icon"></i>
                                                    </div>
                                                    <div class="notification_text">
                                                        <span>{!! $notification->message !!}</span>
                                                        <div class="notification_time">
                                                            <i class="fa fa-calendar" aria-hidden="true"></i>
                                                            <span>{{ date('d-m-Y', strtotime($notification->created_at)) }}</span>
                                                            <i class="fa fa-clock-o" aria-hidden="true"></i>
                                                            <span>{{ date('H:i a', strtotime($notification->created_at)) }}</span>
                                                            @if(!is_null($notification->url) && $notification->url != '')
                                                            <a href="{{route('frontend.user.read_notification' , ['id' => $notification->id])}}"><strong class="notifyy float-right">VIEW DETAILS</strong></a>
                                                            @else
                                                             <a href="#" onclick="showNotificationDetails({{ $notification->id }})"><strong class="notifyy float-right">VIEW DETAILS</strong></a>
                                                            @endif
                                                        </div>
                                                    </div>
                                            </div>
                                        </div>
                                    </div>
                                @endforeach
                            </div>
                        <div id="load-more-notifications"></div>
                        <div id="ajax-load" class="container" style="display: none;">
                            <div class="row">
                                <div class="col-md-12">
                                    <div class="notification_list text-center" style="background-color: #d4d4d4;">
                                        <div class="notification_text" id="loader_text">
                                            <div class="spinner-border text-center" role="status"></div>
                                        </div>
                                    </div>
                                </div></div>
                        </div>
                            </div>

                        <div class="section mt-5">
                            <div class="container">
                                <div class="row">
                                    <div class="col-12">
                                        <div id="switch">
                                            <div id="circle"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

    </div>

@endsection

@section('footer')
    @include('partials.footer')
@endsection
@push('after-css')
    <style>
        .notifyy{
            color: black;
            text-decoration: none;
        }
        .notifyy:hover{
            color: #007bff;
        }
        .notification_list:hover{
            background-color: #ccdcf1 !important;
        }
    </style>
@endpush
@section('scripts')
    <script type="text/javascript">
        $(document).ready(function () {
          localStorage.setItem('scroll' , '1');
        })
      var page = 1;
      $(window).scroll(function() {
        var scroll = localStorage.getItem('scroll');
        if($(window).scrollTop() + $(window).height() >= $('#load-more-notifications').height()-100 && scroll == '1') {
          page++;
          loadMoreData(page);
        }
      });


      function loadMoreData(page){
        $.ajax(
            {
              url: '{{ route("frontend.user.notifications") }}?flag=true&page=' + page,
              type: "get",
              beforeSend: function()
              {
                $('#ajax-load').show();
                localStorage.setItem('scroll' , '0');
              }
            })
            .done(function(data)
            {
              if(data == ""){
                localStorage.setItem('scroll' , '0');
                $('#loader_text').html("No more Notifications");
                return;
              }
              localStorage.setItem('scroll' , '1');
              $('#ajax-load').hide();
              $(".notification-container").append(data);
            })
            .fail(function(jqXHR, ajaxOptions, thrownError)
            {
              localStorage.setItem('scroll' , '0');
              $('#ajax-load').hide();
              alert('server not responding...');
            });
      }

      function showNotificationDetails(id) {
          //$('#notif_modal').modal('show');
          $.ajax(
              {
                  url: '{{ url("frontend/get_notification_details/") }}/' + id,
                  type: "get",
                  beforeSend: function()
                  {
                      //$('#ajax-load').show();
                      //localStorage.setItem('scroll' , '0');
                  }
              })
              .done(function(data)
              {
                  localStorage.setItem('scroll' , '1');
                  $('#ajax-load').hide();
                  //alert(data.message)
                  $('#notif_details').html('<span>Message:</span> ' + data.message + '<br>' + '<span>Status:</span> ' + data.status + '<br>' + '<span>Sender:</span> ' + data.sent_by);
                  $('#notif_modal').modal('show');
                  var count = parseInt( $('.notifi').html() );
                  if(count > 0) {
                      count--;
                      $('.notifi').html(count);
                  }

              })
              .fail(function(jqXHR, ajaxOptions, thrownError)
              {
                  localStorage.setItem('scroll' , '0');
                  $('#ajax-load').hide();
                  alert('Server not responding...');
              });
      }
    </script>
@endsection

