@extends('layouts.frontend')
<!-- Header -->
@section('header')


@include('partials.header')

@endsection

@section('contents')

<div class="background_section">
        <div class="section">
                <div class="container">
                        <div class="social_heading">
                                <span>Account/Add Instagram</span>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                    <div class="insta_pic">
                                            <img src="{{ $feed->getProfilePicture() }}" class=" rounded-circle" alt="" />

                                        <div class="insta_text">
                                            <span>{{ $feed->getFullName() }}</span><br>
                                            <a style="font-size:17px;font-weight:normal;" href="{{ route('frontend.social.add_account' ,['account' => 'instagram']) }}">Add Account</a>

                                        </div>
                                    </div>
                            </div>
                        </div>

                        <div class="ref_code">
                            <p>Please verify this account by placing</p>
                            <p><div class="input-group col-md-5 m-auto">
                                <input type="text" class="form-control" value="{{$verification_code}}" placeholder="Username" disabled>
                                <input type="hidden" class="form-control" id="verification-code" value="{{$verification_code}}">
                                <div class="input-group-prepend copy-verification">
                                    <div class="btn btn-primary input-group-text copy-btn" data-toggle="tooltip" data-placement="top" title="Copy to Clipboard"><i class="fa fa-copy"></i></div>
                                </div>
                            </div>
                            <p>in your bio section, then click verify.</p>
                        </div>
                    <form id="verify_form" action="{{ route('frontend.social.post_verify_account' ,['account' => 'instagram']) }}" method="post">
                        {{ csrf_field() }}
                        <input type="hidden" name="verification_code" value="{{ $verification_code }}">
                        <input type="hidden" name="account_handle" value="{{ $account_handle }}">
                        <input type="hidden" name="social_account_id" value="{{ $social_account_id }}">
                    </form>

                        <div class="row">
                                <div class="verify-btn">
                                        <button onclick="document.getElementById('verify_form').submit()" class="green">Verify</button>
                                    <a href="{{ route('frontend.social.home') }}"><button class="blue">Cancel</button></a>
                                </div>

                        </div>
            </div>
        </div>
    <div class="section mt-5">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div id="switch">
                            <div id="circle"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
</div>
@endsection

@section('footer')
    @include('partials.footer')
@endsection
@section('scripts')

    <script>
      $('[data-toggle="tooltip"]').tooltip();
      $('.copy-verification').on('click' , function () {
        var dummy = document.createElement("input");
        document.body.appendChild(dummy);
        dummy.setAttribute("id", "dummy_id");
        document.getElementById("dummy_id").value='{{$verification_code}}';
        dummy.select();
        document.execCommand("copy");
        $('#dummy_id').remove();
        $('.copy-btn i').removeClass('fa-copy').addClass('fa-calendar-check-o');
        $('.copy-btn').attr('data-original-title' , 'Copied');
      });
    </script>
@endsection
