@extends('layouts.frontend')
<!-- Header -->
@section('header')


    @include('partials.header')

@endsection

@section('contents')

    <div class="background_section">
        <div class="section">
            <div class="container">
                <div class="social_heading">
                    <span>Account/Add Twitter</span>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <div class="insta_pic">
                            <img src="{{ count($twitter_feed) > 0 ? $twitter_feed[0]['user']['profile_image_url_https'] : asset('images/default.jpg') }}" class=" rounded-circle" alt="" />

                            <div class="insta_text">
                                <span>{{ count($twitter_feed) > 0 ? $twitter_feed[0]['user']['name'] : $account_handle }}</span><br>
                                <a style="font-size:17px;font-weight:normal;" href="{{ asset('frontend/add_twitter') }}">Add Account</a>

                            </div>
                        </div>
                    </div>
                </div>

                <div class="ref_code">
                    <span>Please verify the account by placing {{ '"' . $verification_code . '"' }} in your twitter bio section, then click 'Verify'</span>
                </div>
                <form id="verify_form" action="{{ route('frontend.social.verify_twitter') }}" method="post">
                    {{ csrf_field() }}
                    <input type="hidden" name="verification_code" value="{{ $verification_code }}">
                    <input type="hidden" name="account_handle" value="{{ $account_handle }}">
                    <input type="hidden" name="social_account_id" value="{{ $social_account_id }}">
                </form>

                <div class="row">
                    <div class="verify-btn">
                        <button onclick="document.getElementById('verify_form').submit()" class="green">Verify</button>
                        <a href="{{ route('frontend.social.home') }}"><button class="blue">Cancel</button></a>
                    </div>

                </div>
            </div>
        </div>
        <div class="section mt-5">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div id="switch">
                            <div id="circle"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('footer')
    @include('partials.footer')
@endsection
@section('scripts')
    <script src="{{ asset('frontend/js/jquery.js') }}"></script>
    <script src="{{ asset('frontend/js/popper.js') }}"></script>
    <script src="{{ asset('frontend/js/bootstrap.js') }}"></script>
    <script src="{{ asset('frontend/js/custom.js') }}"></script>
@endsection

