<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <meta http-equiv="X-UA-Compatible" content="ie=edge" />
  <link rel="icon" type="image/png" sizes="16x16" href="{{ asset('frontend/images/favicon.png') }}">
  <link rel="stylesheet" href="https://pro.fontawesome.com/releases/v5.14.0/css/all.css">
  <!--    Font Awesome 5.9-->
<!--     <script src="{{ asset('frontend/js/fontawesome.js') }}"></script> -->
  <!--    Bootstrap 4.3.1-->
  <link rel="stylesheet" href="{{ asset('frontend/css/bootstrap.min.css') }}" />
  <!-- Custom Style Sheet -->
  <link rel="stylesheet" href="{{ asset('frontend/css/style.css') }}" />
  <link rel="stylesheet" href="{{ asset('frontend/css/custom_style.css') }}" />
  @stack('after-css')
  <link href="https://fonts.googleapis.com/css?family=Montserrat&display=swap" rel="stylesheet">
  <link href="https://fonts.googleapis.com/css?family=Rubik&display=swap" rel="stylesheet">
  <link href="https://fonts.googleapis.com/css?family=Raleway&display=swap" rel="stylesheet">
  <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/css/select2.min.css" rel="stylesheet" />
  <title>Cloutsource Home</title>
</head>
<body class="hero-anime">

@if(auth()->check() && auth()->user()->role->title != 'Admin') <!-- chat section -->
<div class="fabs">
  <div class="chat">
    <div class="chat_header">
      <div class="chat_option">
        <div class="header_img" id="chat_user_section" style="display: none;">

          <div class="dropdown">
            <button id="chat_user_details_section" class="btn dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              <img src=""/> Ghania Arshad
            </button>
            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
              <a class="dropdown-item" id="open_in_messenger_link" href="#">Open in Messenger</a>
              <a class="dropdown-item" href="#" style="display: none">View Profile</a>
              <a class="dropdown-item" href="#" onclick="stopConversation()" style="display: none;">Stop conversation</a>
              <a class="dropdown-item" href="#" onclick="blockUser()" style="display: none;">Block</a>
            </div>
          </div>
          <div class="header-close"><a id="prime1" class="fab "><i class="fas fa-times prime"></i></a></div>
        </div>

      </div>
    </div>
    <div class="bar searchbox">
      <div class="inner">
        <input id="search" type="search" class="search-input" Placeholder="Search for users" onkeyup="getAllChatUsers()"/>
        <span data-icon="&#xe000;" aria-hidden="true" class="search-btn">
              <input type="submit" class="searchsubmit" value="">
            </span>
      </div>
    </div>
    <div class="content-list" id="list">
      <ul class="drop-list" id="chat_users_list"></ul>
    </div>

    <div id="chat_first_screen" class="chat_conversion chat_converse">
        <!--<span class="chat_msg_item chat_msg_item_admin">
          <div class="chat_avatar">
            <img src="{{ url('images/default.jpg') }}"/>
          </div>
          Hi How are you?
        </span>
      <span class="chat_msg_item chat_msg_item_user">
          I am fine thanks
        </span>


      <span class="status">
          2 days ago
        </span>

      <span class="img-attachement-right">
           <img src="{{ asset('frontend/images/card-img.jpg') }}" alt=""/>
           <img src="{{ asset('frontend/images/card-img2.jpg') }}" alt=""/>
           <img src="{{ asset('frontend/images/card-img3.jpg') }}" alt=""/>
        </span>
      <span class="file-attachement-right">
          <div>Chatbox</div>
        </span>

      <span class="file-attachement-right">
          <div>Chatbox</div>
        </span>

      <span class="img-attachement-left">
           <img src="{{ asset('frontend/images/card-img.jpg') }}" alt=""/>
           <img src="{{ asset('frontend/images/card-img2.jpg') }}" alt=""/>
           <img src="{{ asset('frontend/images/card-img3.jpg') }}" alt=""/>
        </span>
      <span class="file-attachement-left">
          <div>Chatbox</div>
        </span>-->


    </div>
    <div class="wanttochat" id="invite_section" style="display: none;">
      <div class="letchattext">Let's chat on cloutsource</div>
      <div class="sendinvite-btn"><a href="#" onclick="sendInvite()">Send Invite</a></div>
    </div>
    <div class="wanttochat" id="your_invited_section" style="display: none;">
      <div class="letchattext">You are invited</div>
      <div class="sendinvite-btn">
        <a href="#" onclick="acceptInvite()">Accept</a> / <a href="#" onclick="rejectInvite()">Reject</a>
      </div>
    </div>
    <div class="wanttochat" id="invite_status_section" style="display: none;">
      <div class="letchattext" id="invite_status_message_section"></div>
    </div>
    <div class="wanttochat" id="unmute_section" style="display: none;">
      <div class="letchattext">You muted this user.</div>
      <div class="sendinvite-btn"><a href="#" onclick="unstopConversation()">Un mute</a></div>
    </div>
    <div class="wanttochat" id="your_muted_section" style="display: none;">
      <div class="letchattext">You are muted by this user.</div>
    </div>
    <div class="wanttochat" id="unblock_section" style="display: none;">
      <div class="letchattext">You blocked this user.</div>
      <div class="sendinvite-btn"><a href="#" onclick="unblockUser()">Unblock</a></div>
    </div>
    <div class="wanttochat" id="your_blocked_section" style="display: none;">
      <div class="letchattext">You are blocked by this user.</div>
    </div>
    <div class="fab_field" id="message_fields" style="display: none;">
      <div class="btn-attachement1">
        <!--         <label class="btn">
          <input type="file" hidden class="form-control-file"  multiple/>
          <i class="far fa-paperclip" onclick="$('#message-main-attachment').click()"></i>
          <div id="message-main-attachment"></div>

        </label>  -->
        <div class="fileattachement-div">
          <label for="attachment">
            <a class="attachement-link" role="button" aria-disabled="false"><i class="far fa-paperclip" onclick="$('#message-main-attachment').click()"></i></a>

          </label>
          <input type="file" name="file" id="message-main-attachment" style="visibility: hidden;" multiple/>
        </div>
      </div>
      <div class="avatar-upload1">
        <div class="avatar-edit" style="display: none">
          <input type='file' id="imageUpload" accept=".png, .jpg, .jpeg" />
          <label for="imageUpload"><i class="far fa-camera"></i></label>
        </div>
      </div>
      <div class="mesgbox1">
        <textarea id="main-chat-input" name="main-chat-input" placeholder="Send a message" class="" onfocus="mainReadMessages()"></textarea>
        <a id="fab_send" class="fab" onclick="sendMainMessage()"><i class="fal fa-paper-plane"></i></a>
      </div>
    </div>
    <div id="files-area">
        <span id="filesList">
          <span id="files-names"></span>
        </span>
    </div>

  </div>
  <a id="prime" class="fab"><i class="far fa-comment-alt prime zmdi zmdi-comment-outline"></i><span class="chatcounter" id="main_unread_count">0</span></a>
</div>
<input type="hidden" id="main_my_id" value="{{ auth()->user()->id }}">
<input type="hidden" id="main_user_id" value="0">
@endif <!-- chat section ends -->
<form id="logoutform" action="{{ route('logout') }}" method="POST" style="display: none;">
  {{ csrf_field() }}
</form>
@yield("modal")
@include('partials.review_site_modal')
@yield("header")
@yield("contents")
@yield("footer")
    <script src="{{ asset('frontend/js/jquery.js') }}"></script>
    <script src="{{ asset('frontend/js/popper.js') }}"></script>
    <script src="{{ asset('frontend/js/bootstrap.js') }}"></script>
    <script src="{{ asset('frontend/js/custom.js') }}"></script>
    <script src="{{ asset('frontend/js/reg-login.js') }}"></script>
    <script src="{{ asset('frontend/js/Chart.min.js') }}"></script>
    <script src="{{ asset('frontend/js/utils.js') }}"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js"></script>
    <script>
        hideChat(0);

        $('#prime1').click(function() {
            toggleFab();
        });
        //Toggle chat and links
        function toggleFab() {
            $('.prime').toggleClass('zmdi-comment-outline');
            $('.prime').toggleClass('zmdi-close');
            $('.prime').toggleClass('is-active');
            $('.prime').toggleClass('is-visible');
            $('#prime').toggleClass('is-float');
            $('#prime1').toggleClass('is-float');
            $('.chat').toggleClass('is-visible');
            $('.fab').toggleClass('is-visible');

        }
        $('#chat_fullscreen_loader').click(function(e) {
            $('.fullscreen').toggleClass('zmdi-window-maximize');
            $('.fullscreen').toggleClass('zmdi-window-restore');
            $('.chat').toggleClass('chat_fullscreen');
            $('.fab').toggleClass('is-hide');
            $('.header_img').toggleClass('change_img');
            $('.img_container').toggleClass('change_img');
            $('.chat_header').toggleClass('chat_header2');
            $('.fab_field').toggleClass('fab_field2');
            $('.chat_converse').toggleClass('chat_converse2');
        });
        function hideChat(hide) {
            switch (hide) {
                case 0:
                    $('#chat_converse').css('display', 'block');
                    $('#chat_body').css('display', 'none');
                    $('#chat_form').css('display', 'none');
                    $('.chat_login').css('display', 'none');
                    $('.chat_fullscreen_loader').css('display', 'block');
                    break;

            }
        }
    </script>
    <script>
        function readURL(input) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();
                reader.onload = function(e) {
                    $('#imagePreview').css('background-image', 'url('+e.target.result +')');
                    $('#imagePreview').hide();
                    $('#imagePreview').fadeIn(650);
                }
                reader.readAsDataURL(input.files[0]);
            }
        }
        $("#imageUpload").change(function() {
            readURL(this);
        });
    </script>

    @if(auth()->check())

      <script src="{!! asset('js/firebase/firebase-app.js') !!}"></script>
      <script src="{!! asset('js/firebase/firebase-firestore.js') !!}"></script>
      <script src="{!! asset('js/firebase/firebase-messaging.js') !!}"></script>
      <script src="{!! asset('js/firebase/firebase-chat-config.js') !!}"></script>
      <script src="{!! asset('js/helper.js') !!}"></script>

    @endif

      @if(auth()->check() && auth()->user()->role->title != 'Admin')
      <script>
          var blocked_users  = [];
          var conversation_stopped_users = [];
          var muted_by_users = [];
          var mainAttachments = [];
          var messageMainAttachments = [];
          var mainFirstTimeFlag = 1;
          var mainInviteFirstTimeFlag = 1;
          var main_my_id = $('#main_my_id').val();
          var attachmentsRemovedIndexes = [];
          var unreadMessagesUsers = [];
          var message_users = [];
          var allUsers = [];
          var registeredUsers = [];
          var addedMessagesDosIds = [];
          var sendMainMessageCalled = false;

          jQuery(document).ready(function($) {

              $('#prime').click(function() {
                  toggleFab();
                  getAllChatUsers();
                  $('#chat_first_screen').html('');

                  // 
                  $('#message_fields').hide();
                  $('#chat_user_section').hide();
                  $('#invite_section').hide();
                  $('#your_invited_section').hide();
                  $('#invite_status_section').hide();
                  $('#unmute_section').hide();
                  $('#your_muted_section').hide();
                  $('#unblock_section').hide();
                  $('#your_blocked_section').hide();

              });

              $('#search').click( function(event){
                  getAllChatUsers();
                  //event.stopPropagation();
                  //$("#list").fadeIn("fast");
              });

              $(document).click( function(){
                  $('#list').hide();
              });
              $('#main-chat-input').keypress(function(event){
                  var keycode = (event.keyCode ? event.keyCode : event.which);
                  if(keycode == '13'){
                      sendMainMessage();
                  }
              });
              $("#message-main-attachment").change(function(event){
                  var files = event.target.files;
                  var totalFiles = mainAttachments.length;
                  var counter = totalFiles;
                  if(files) {
                      var files_count = files.length;
                      for (var i = 0; i < files_count; i++) {
                          mainAttachments.push(files[i]);
                          var fileBloc = $('<span/>', {class: 'file-block', id: 'file-' + counter}),
                          fileName = $('<span/>', {class: 'name', text: files[i].name});
                          fileBloc.append('<span class="file-delete" onclick="removeFileItem(' + counter + ')"><span>+</span></span>')
                              .append(fileName);
                          $("#filesList > #files-names").append(fileBloc);
                          counter++;
                      }
                  }
                  //console.log(mainAttachments)
              });
              //getAllChatUsers();
              getMainUnreadMessagesCount();
          });

          function removeFileItem(index) {
              attachmentsRemovedIndexes.push(index);
              $('#file-' + index).remove();
          }
          function getAllChatUsers() {


              var usersHtml = '';
              var searchVal = ($('#search').val()).toLowerCase();
              var count = 0;
              for (var key in unreadMessagesUsers) {

                  //console.log(key + " -> " + allUsers[key].messageCount);
                  if(count < 10) {
                      var userData = unreadMessagesUsers[key].userData;
                      var unreadCount = unreadMessagesUsers[key].messageCount;
                      var unreadHtml = '';
                      if (unreadCount > 0) {
                          unreadHtml = '<span class="chat-mesg-count">' + unreadCount + '</span>';
                      }

                      usersHtml += '<li>\n' +
                          '          <a style="cursor: pointer;" onclick="return getUserDetails(' + userData.id + ')">\n' +
                          '            <span class="item">\n' +
                          '             <span class="icon-type">\n' +
                          unreadHtml +
                          '                <img src="' + userData.avatar + '" alt="" />\n' +
                          '              </span>\n' +
                          '              <span class="text">' + userData.name + '</span>\n' +
                          '            </span>\n' +
                          '          </a>\n' +
                          '          <input type="hidden" id="chat_user_id_' + userData.id + '" value="' + userData.id + '">' +
                          '          <input type="hidden" id="chat_user_name_' + userData.id + '" value="' + userData.name + '">' +
                          '          <input type="hidden" id="chat_user_avatar_' + userData.id + '" value="' + userData.avatar + '">'
                      '        </li>';
                      count++;
                  } else {
                      break;
                  }
              }

              if(count <= 10) {

                  var limit = 10 - count;

                  db.collection(usersCollection).limit(limit + 1)
                      .get().then(function (userSnapshot) {
                      userSnapshot.forEach(function (userDoc) {

                          var userData = userDoc.data();

                          var userName = (userData.name).toLowerCase();

                          if (!message_users.includes(userData.id) && main_my_id != userData.id && !blocked_users.includes(parseInt(main_my_id)) && (userName.indexOf(searchVal) !== -1 || searchVal == '')) {

                              var userData = userDoc.data();

                              usersHtml += '<li>\n' +
                                  '          <a style="cursor: pointer;" onclick="return getUserDetails(' + userData.id + ')">\n' +
                                  '            <span class="item">\n' +
                                  '             <span class="icon-type">\n' +
                                  '                <img src="' + userData.avatar + '" alt="" />\n' +
                                  '              </span>\n' +
                                  '              <span class="text">' + userData.name + '</span>\n' +
                                  '            </span>\n' +
                                  '          </a>\n' +
                                  '          <input type="hidden" id="chat_user_id_' + userData.id + '" value="' + userData.id + '">' +
                                  '          <input type="hidden" id="chat_user_name_' + userData.id + '" value="' + userData.name + '">' +
                                  '          <input type="hidden" id="chat_user_avatar_' + userData.id + '" value="' + userData.avatar + '">'
                              '        </li>';
                          }

                      });

                      $('#chat_users_list').html(usersHtml);
                      $("#list").fadeIn("fast");
                  });

              } else {

                  $('#chat_users_list').html(usersHtml);
                  $("#list").fadeIn("fast");

              }

          }
          function getUserDetails(id) {
              var base_url = "{{ url('/') }}";
              var id = $('#chat_user_id_' + id).val();
              var name = $('#chat_user_name_' + id).val();
              var avatar = $('#chat_user_avatar_' + id).val();
              var chat_user_details_html = '<img src="' + avatar + '"/>' + name;
              $('#chat_user_details_section').html(chat_user_details_html);
              $('#chat_user_section').show();
              $('#main_user_id').val(id);
              $('#open_in_messenger_link').attr('href', base_url + '/frontend/user_messages?user_id=' + id);
              getMainMessages();
              // initialize here
              if(!registeredUsers.includes(id)) {
                  registeredUsers.push(id);
                  mainFirstTimeFlag = 1;
                  mainMessageAdded();
              }
              //inviteChanged();
          }
          function getMainMessages() {
              var main_user_id = parseInt( $('#main_user_id').val() );
              $('#unblock_section').hide();
              $('#unmute_section').hide();
              $('#your_blocked_section').hide();
              $('#your_muted_section').hide();
              $('#invite_section').hide();
              $('#your_invited_section').hide();
              $('#invite_status_section').hide(); // status of invite sent by you
              if( blocked_users.includes(main_user_id) ) { // user is blocked
                  $('#unblock_section').show();
                  //$('#invite_section').hide();
                  $('#message_fields').hide();
                  $("#chat_first_screen").html('');
                  $("#chat_first_screen").animate({scrollTop: $("#chat_first_screen").prop('scrollHeight')}, 0);
              } else {
                  //$('#unblock_section').hide();
                  var user_avatar = $('#chat_user_avatar_' + main_user_id).val();
                  var chatHtml = '';
                  var messagesRef = db.collection(messagesCollection)
                      .where('user_ids', 'array-contains', main_my_id + '-' + main_user_id)
                      .orderBy("sent_at", "asc");
                  messagesRef.get().then(function (querySnapshot) {
                      if(querySnapshot.size == 0) { // when there is no message
                          if( conversation_stopped_users.includes(main_user_id) ) { // user is muted by you
                              $('#unmute_section').show();
                          } else if( muted_by_users.includes(parseInt(main_my_id)) ) { // user is muted by you
                              $('#your_muted_section').show();
                              $('#message_fields').hide();
                          } else { // invitation section
                              db.collection(invitationsCollection).where("user_ids", "array-contains", main_my_id + '-' + main_user_id).limit(1)
                                  .get()
                                  .then(function(querySnapshot) {
                                      if(querySnapshot.size > 0) { // if any invitation is already sent
                                          querySnapshot.forEach(function (doc) {
                                              console.log(doc.id, " => ", doc.data());
                                              var invData = doc.data();
                                              if (invData.sent_to == main_my_id) { // invite sent to you
                                                  if (invData.status == 'pending') {
                                                      $('#your_invited_section').show();
                                                  } else if (invData.status == 'accepted') {
                                                      $('#message_fields').show();
                                                  } else {
                                                      $('#invite_status_section').show();
                                                      $('#invite_status_message_section').html('You have ' + invData.status + ' the invite.');
                                                  }
                                              } else { // invite sent by you
                                                  if(invData.status == 'accepted') {
                                                      $('#message_fields').show();
                                                  } else {
                                                      $('#invite_status_section').show();
                                                      $('#invite_status_message_section').html('Your invite is ' + invData.status);
                                                  }
                                              }
                                          });
                                      } else { // no invite is already sent
                                          $('#invite_section').show();
                                          $('#message_fields').hide();
                                      }
                                      $("#chat_first_screen").html('');
                                  });
                          }
                          $("#chat_first_screen").animate({scrollTop: $("#chat_first_screen").prop('scrollHeight')}, 0);
                      } else { // retrieve messages
                          $('#invite_section').hide();
                          $('#your_invited_section').hide();
                          $('#invite_status_section').hide();
                          $('#message_fields').show();
                          if( conversation_stopped_users.includes(main_user_id) ) { // user is muted by you
                              $('#unmute_section').show();
                          }else if( muted_by_users.includes(parseInt(main_my_id)) ) { // user is muted by you
                              $('#your_muted_section').show();
                              $('#message_fields').hide();
                          }
                          querySnapshot.forEach(function (doc) {
                              console.log(doc.id, ' => ', doc.data());
                              var data = doc.data();
                              var sent_time = data.sent_at;
                              var msgAttachments = data.attachments;

                              var image_files = [];
                              var normal_files = [];
                              var normal_files_names = [];
                              var imageExtensions = ['jpg', 'jpeg', 'png', 'gif', 'tiff'];
                              var imgHtml = '';
                              var imgFilesHtml = '';
                              var normalFilesHtml = '';
                              var combineFilesHtml = '';

                              if(msgAttachments.length > 0) {
                                  for(var i=0; i < msgAttachments.length; i++) {
                                      var explodedFileString = msgAttachments[i].split(', ');

                                      var filePath = explodedFileString[0];
                                      var fileName = explodedFileString[1];
                                      var extensionArray = filePath.split('.');
                                      var extension = extensionArray[ extensionArray.length-1 ];
                                      if(imageExtensions.includes(extension.toLowerCase())) {
                                          image_files.push(filePath);
                                      } else {
                                          normal_files.push(filePath);
                                          normal_files_names.push(fileName);
                                      }
                                  }

                                  if(image_files.length > 0 && normal_files.length == 0) {
                                      for(var i = 0; i<image_files.length; i++) {
                                          imgHtml += '<a href="' + image_files[i] + '" target="_blank"><img src="' + image_files[i] + '"></a>';
                                      }

                                      if (data.sent_to == main_my_id) { // left images
                                          var msgHtml = data.message.trim().length == '' ? '' : '<span class="leftside-text">' + data.message + '</span>';
                                          imgFilesHtml = '<span class="attach-combine-left">\n' +
                                              '<span class="chat_msg_item chat_msg_item_admin">\n' +
                                              '          <div class="chat_avatar">\n' +
                                              '            <img src="' + user_avatar + '">\n' +
                                              '          </div>' + msgHtml +
                                              '</span>\n' +
                                              '\n' +
                                              '<span class="img-attachement-left">\n' +
                                              imgHtml +
                                              '</span>\n' +
                                              '</span>';
                                      } else { // right images
                                          var msgHtml = data.message.trim().length == '' ? '' : '<span class="chat_msg_item chat_msg_item_user">' + data.message + '</span>';
                                          imgFilesHtml = '<span class="attach-combine-right">\n' +
                                              '\n' +
                                              msgHtml +
                                              '    \n' +
                                              '    <span class="img-attachement-right">' + imgHtml + '</span>\n' +
                                              '    \n' +
                                              '</span>';
                                      }
                                  } else if(normal_files.length > 0 && image_files.length == 0) {

                                      var leftFilesHtml = '';
                                      var rightFilesHtml = '';
                                      for(var i = 0; i<normal_files.length; i++) {
                                          var fileName = normal_files_names[i];

                                          if (data.sent_to == main_my_id) {
                                              leftFilesHtml += '<span class="file-attachement-left"> <div><a href="' + normal_files[i] + '" target="_blank">' + fileName + '</a></div> </span>';
                                          } else {
                                              rightFilesHtml += '<span class="file-attachement-right"> <div><a href="' + normal_files[i] + '" target="_blank">' + fileName + '</a></div> </span>';
                                          }

                                      }

                                      if (data.sent_to == main_my_id) { // left normal images
                                          var msgHtml = data.message.trim().length == '' ? '' : '<span class="leftside-text">' + data.message + '</span>';
                                          normalFilesHtml += '<span class="file-pdf-attachement-left">\n' +
                                              '<span class="chat_msg_item chat_msg_item_admin">\n' +
                                              '          <div class="chat_avatar">\n' +
                                              '            <img src="' + user_avatar + '">\n' +
                                              '          </div>' + msgHtml + '</span>\n' +
                                              '\n' +
                                              leftFilesHtml +
                                              '    \n' +
                                              '</span>';
                                      } else { // right normal images
                                          var msgHtml = data.message.trim().length == '' ? '' : '<span class="chat_msg_item chat_msg_item_user">' + data.message + '</span>';
                                          normalFilesHtml += '<span class="file-pdf-attachement-right">\n' +
                                              msgHtml +
                                              rightFilesHtml +
                                              '</span>';
                                      }
                                  } else if(normal_files.length > 0 && image_files.length > 0) {

                                      for(var i = 0; i<image_files.length; i++) {
                                          imgHtml += '<a href="' + image_files[i] + '" target="_blank"><img src="' + image_files[i] + '"></a>';
                                      }

                                      var leftFilesHtml = '';
                                      var rightFilesHtml = '';
                                      for(var i = 0; i<normal_files.length; i++) {
                                          var fileName = normal_files_names[i];

                                          if (data.sent_to == main_my_id) {
                                              leftFilesHtml += '<span class="file-attachement-left"> <div><a href="' + normal_files[i] + '" target="_blank">' + fileName + '</a></div> </span>';
                                          } else {
                                              rightFilesHtml += '<span class="file-attachement-right"> <div><a href="' + normal_files[i] + '" target="_blank">' + fileName + '</a></div> </span>';
                                          }

                                      }

                                      if (data.sent_to == main_my_id) { // left images
                                          var msgHtml = data.message.trim().length == '' ? '' : '<span class="leftside-text">' + data.message + '</span>';
                                          combineFilesHtml = '<span class="attach-combine-left">\n' +
                                              '<span class="chat_msg_item chat_msg_item_admin">\n' +
                                              '          <div class="chat_avatar">\n' +
                                              '            <img src="' + user_avatar + '">\n' +
                                              '          </div>' + msgHtml +
                                              '</span>\n' +
                                              '\n' +
                                              '<span class="img-attachement-left">\n' +
                                              imgHtml +
                                              '</span>\n' + leftFilesHtml +
                                              '</span>';
                                      } else { // right images
                                          var msgHtml = data.message.trim().length == '' ? '' : '<span class="chat_msg_item chat_msg_item_user">' + data.message + '</span>';
                                          combineFilesHtml = '<span class="attach-combine-right">\n' +
                                              '\n' +
                                              msgHtml +
                                              '    \n' +
                                              '    <span class="img-attachement-right">' + imgHtml + '</span>\n' + rightFilesHtml +
                                              '    \n' +
                                              '</span>';
                                      }
                                  }
                              }

                              var messageHtml = '';

                              if (data.sent_to == main_my_id) {

                                  if(data.message != '') {
                                      var msgHtml = data.message.trim().length == '' ? '' : '<span class="leftside-text">' + data.message + '</span>';
                                      messageHtml = '<span class="chat_msg_item chat_msg_item_admin">\n' +
                                          '          <div class="chat_avatar">\n' +
                                          '            <img src="' + user_avatar + '"/>\n' +
                                          '          </div>' + msgHtml + '</span>';
                                  }

                                  //chatHtml += messageHtml + imgFilesHtml + normalFilesHtml;
                              } else {

                                  if(data.message != '') {
                                      var msgHtml = data.message.trim().length == '' ? '' : '<span class="leftside-text">' + data.message + '</span>';
                                      messageHtml = '<span class="chat_msg_item chat_msg_item_user">' +
                                          msgHtml +
                                          '</span>' +
                                          '<span class="status">' +
                                          timeDifference(Date.now(), sent_time) +
                                          '</span>';
                                  }

                                  //chatHtml += messageHtml + imgFilesHtml + normalFilesHtml;

                              }

                              if(normal_files.length == 0 && image_files.length == 0) {
                                  chatHtml += messageHtml;
                              } else if(normal_files.length == 0 && image_files.length > 0) {
                                  chatHtml += imgFilesHtml;
                              } else if(normal_files.length > 0 && image_files.length == 0) {
                                  chatHtml += normalFilesHtml;
                              } else if(normal_files.length > 0 && image_files.length > 0) {
                                  chatHtml += combineFilesHtml;
                              }
                              
                          });
                          $("#chat_first_screen").html(chatHtml);
                          $("#chat_first_screen").animate({scrollTop: $("#chat_first_screen").prop('scrollHeight')}, 0);
                      }
                  });
              }
          }
          function sendMainMessage() {
              if(sendMainMessageCalled == false) {
                  sendMainMessageCalled = true;
                  var main_user_id = $('#main_user_id').val();
                  db.collection(usersCollection).where('id', '==', parseInt(main_user_id)) // query for blocked and stopped users
                      .get().then(function (mainUserSnapshot) {
                      mainUserSnapshot.forEach(function (mainUserDoc) {
                          var mainUserData = mainUserDoc.data();
                          var current_blocked_users = mainUserData.blocked_users;
                          var current_muted_users = mainUserData.conversation_stopped_users;
                          if (current_blocked_users.includes(parseInt(main_my_id)) || current_muted_users.includes(parseInt(main_my_id))) {
                              if (current_blocked_users.includes(parseInt(main_my_id))) {
                                  $('#your_blocked_section').show();
                                  $("#chat_first_screen").html('');
                              } else {
                                  $('#your_muted_section').show();
                              }
                              $('#message_fields').hide();
                              sendMainMessageCalled = false;
                          } else {

                              // remove deleted files from attachments
                              for (var i = 0; i < attachmentsRemovedIndexes.length; i++) {
                                  mainAttachments.splice(i, 1);
                              }

                              if (mainAttachments.length > 0) {
                                  uploadMainAttachments();
                              } else {
                                  addMainMessageToFirebase();
                              }
                          }
                      });
                  });
              }
          }
          function addMainMessageToFirebase() {
              var message = $('#main-chat-input').val();
              var main_user_id = $('#main_user_id').val();
              if(messageMainAttachments.length > 0 || message.trim().length > 0 ) {

                  db.collection(messagesCollection).add({
                      sent_to: main_user_id,
                      sent_by: main_my_id,
                      sent_at: Date.now(),
                      message: message,
                      user_ids: [main_user_id, main_my_id, main_my_id + '-' + main_user_id, main_user_id + '-' + main_my_id],
                      attachments: messageMainAttachments,
                      is_read: 0
                  })
                      .then(function (docRef) {
                          console.log("Document written with ID: ", docRef.id);
                          mainAttachments = [];
                          messageMainAttachments = [];
                          attachmentsRemovedIndexes = [];
                          sendMainMessageCalled = false;
                          $('#files-names').html('');
                      })
                      .catch(function (error) {
                          console.error("Error adding document: ", error);
                          mainAttachments = [];
                          messageMainAttachments = [];
                          attachmentsRemovedIndexes = [];
                          sendMainMessageCalled = false;
                          $('#files-names').html('');
                      });

              } else {
                  sendMainMessageCalled = false;
              }
          }
          function mainMessageAdded() {

              var messageRef = db.collection(messagesCollection);
              messageRef
                  .orderBy("sent_at","desc")
                  .limit(1)
                  .onSnapshot(function (doc) { // this is the event listener on messages collection

                      var main_user_id = $('#main_user_id').val();
                      var user_avatar = $('#chat_user_avatar_' + main_user_id).val();
                      var chatHtml = '';
                      var docM = doc.docs[0];

                      if(docM != undefined) {
                          var data = docM.data();
                          doc.docChanges().forEach(function (change) {
                              if (change.type === 'added' && mainFirstTimeFlag == 0) {
                                  var sent_time = data.sent_at;
                                  if (data.user_ids.includes(main_my_id + '-' + main_user_id)) {

                                      var msgAttachments = data.attachments;

                                      var image_files = [];
                                      var normal_files = [];
                                      var normal_files_names = [];
                                      var imageExtensions = ['jpg', 'jpeg', 'png', 'gif', 'tiff'];
                                      var imgHtml = '';
                                      var imgFilesHtml = '';
                                      var normalFilesHtml = '';
                                      var combineFilesHtml = '';

                                      if(msgAttachments.length > 0) {
                                          for(var i=0; i < msgAttachments.length; i++) {
                                              var explodedFileString = msgAttachments[i].split(', ');

                                              var filePath = explodedFileString[0];
                                              var fileName = explodedFileString[1];
                                              var extensionArray = filePath.split('.');
                                              var extension = extensionArray[ extensionArray.length-1 ];
                                              if(imageExtensions.includes(extension.toLowerCase())) {
                                                  image_files.push(filePath);
                                              } else {
                                                  normal_files.push(filePath);
                                                  normal_files_names.push(fileName);
                                              }
                                          }

                                          if(image_files.length > 0 && normal_files.length == 0) {
                                              for(var i = 0; i<image_files.length; i++) {
                                                  imgHtml += '<a href="' + image_files[i] + '" target="_blank"><img src="' + image_files[i] + '"></a>';
                                              }

                                              if (data.sent_to == main_my_id) { // left images
                                                  var msgHtml = data.message.trim().length == '' ? '' : '<span class="leftside-text">' + data.message + '</span>';
                                                  imgFilesHtml = '<span class="attach-combine-left">\n' +
                                                      '<span class="chat_msg_item chat_msg_item_admin">\n' +
                                                      '          <div class="chat_avatar">\n' +
                                                      '            <img src="' + user_avatar + '">\n' +
                                                      '          </div>' + msgHtml +
                                                      '</span>\n' +
                                                      '\n' +
                                                      '<span class="img-attachement-left">\n' +
                                                      imgHtml +
                                                      '</span>\n' +
                                                      '</span>';
                                              } else { // right images
                                                  var msgHtml = data.message.trim().length == '' ? '' : '<span class="chat_msg_item chat_msg_item_user">' + data.message + '</span>';
                                                  imgFilesHtml = '<span class="attach-combine-right">\n' +
                                                      '\n' +
                                                      msgHtml +
                                                      '    \n' +
                                                      '    <span class="img-attachement-right">' + imgHtml + '</span>\n' +
                                                      '    \n' +
                                                      '</span>';
                                              }
                                          } else if(normal_files.length > 0 && image_files.length == 0) {

                                              var leftFilesHtml = '';
                                              var rightFilesHtml = '';
                                              for(var i = 0; i<normal_files.length; i++) {
                                                  var fileName = normal_files_names[i];

                                                  if (data.sent_to == main_my_id) {
                                                      leftFilesHtml += '<span class="file-attachement-left"> <div><a href="' + normal_files[i] + '" target="_blank">' + fileName + '</a></div> </span>';
                                                  } else {
                                                      rightFilesHtml += '<span class="file-attachement-right"> <div><a href="' + normal_files[i] + '" target="_blank">' + fileName + '</a></div> </span>';
                                                  }

                                              }

                                              if (data.sent_to == main_my_id) { // left normal images
                                                  var msgHtml = data.message.trim().length == '' ? '' : '<span class="leftside-text">' + data.message + '</span>';
                                                  normalFilesHtml += '<span class="file-pdf-attachement-left">\n' +
                                                      '<span class="chat_msg_item chat_msg_item_admin">\n' +
                                                      '          <div class="chat_avatar">\n' +
                                                      '            <img src="' + user_avatar + '">\n' +
                                                      '          </div>' + msgHtml + '</span>\n' +
                                                      '\n' +
                                                      leftFilesHtml +
                                                      '    \n' +
                                                      '</span>';
                                              } else { // right normal images
                                                  var msgHtml = data.message.trim().length == '' ? '' : '<span class="chat_msg_item chat_msg_item_user">' + data.message + '</span>';
                                                  normalFilesHtml += '<span class="file-pdf-attachement-right">\n' +
                                                      msgHtml +
                                                      rightFilesHtml +
                                                      '</span>';
                                              }
                                          } else if(normal_files.length > 0 && image_files.length > 0) {

                                              for(var i = 0; i<image_files.length; i++) {
                                                  imgHtml += '<a href="' + image_files[i] + '" target="_blank"><img src="' + image_files[i] + '"></a>';
                                              }

                                              var leftFilesHtml = '';
                                              var rightFilesHtml = '';
                                              for(var i = 0; i<normal_files.length; i++) {
                                                  var fileName = normal_files_names[i];

                                                  if (data.sent_to == main_my_id) {
                                                      leftFilesHtml += '<span class="file-attachement-left"> <div><a href="' + normal_files[i] + '" target="_blank">' + fileName + '</a></div> </span>';
                                                  } else {
                                                      rightFilesHtml += '<span class="file-attachement-right"> <div><a href="' + normal_files[i] + '" target="_blank">' + fileName + '</a></div> </span>';
                                                  }

                                              }

                                              if (data.sent_to == main_my_id) { // left images
                                                  var msgHtml = data.message.trim().length == '' ? '' : '<span class="leftside-text">' + data.message + '</span>';
                                                  combineFilesHtml = '<span class="attach-combine-left">\n' +
                                                      '<span class="chat_msg_item chat_msg_item_admin">\n' +
                                                      '          <div class="chat_avatar">\n' +
                                                      '            <img src="' + user_avatar + '">\n' +
                                                      '          </div>' + msgHtml +
                                                      '</span>\n' +
                                                      '\n' +
                                                      '<span class="img-attachement-left">\n' +
                                                      imgHtml +
                                                      '</span>\n' + leftFilesHtml +
                                                      '</span>';
                                              } else { // right images
                                                  var msgHtml = data.message.trim().length == '' ? '' : '<span class="chat_msg_item chat_msg_item_user">' + data.message + '</span>';
                                                  combineFilesHtml = '<span class="attach-combine-right">\n' +
                                                      '\n' +
                                                      msgHtml +
                                                      '    \n' +
                                                      '    <span class="img-attachement-right">' + imgHtml + '</span>\n' + rightFilesHtml +
                                                      '    \n' +
                                                      '</span>';
                                              }
                                          }
                                      }

                                      var messageHtml = '';

                                      if (data.sent_to == main_my_id) {

                                          if(data.message != '') {
                                              messageHtml = '<span class="chat_msg_item chat_msg_item_admin">\n' +
                                                  '          <div class="chat_avatar">\n' +
                                                  '            <img src="' + user_avatar + '"/>\n' +
                                                  '          </div>' + data.message + '</span>';
                                          }

                                          //chatHtml += messageHtml + imgFilesHtml + normalFilesHtml;
                                      } else {

                                          if(data.message != '') {
                                              messageHtml = '<span class="chat_msg_item chat_msg_item_user">' +
                                                  data.message +
                                                  '</span>' +
                                                  '<span class="status">' +
                                                  timeDifference(Date.now(), sent_time) +
                                                  '</span>';
                                          }

                                          //chatHtml += messageHtml + imgFilesHtml + normalFilesHtml;

                                      }

                                      if(normal_files.length == 0 && image_files.length == 0) {
                                          chatHtml = messageHtml;
                                      } else if(normal_files.length == 0 && image_files.length > 0) {
                                          chatHtml = imgFilesHtml;
                                      } else if(normal_files.length > 0 && image_files.length == 0) {
                                          chatHtml = normalFilesHtml;
                                      } else if(normal_files.length > 0 && image_files.length > 0) {
                                          chatHtml = combineFilesHtml;
                                      }

                                      if(!addedMessagesDosIds.includes(docM.id)) {  // unique message

                                          addedMessagesDosIds.push(docM.id);
                                          var oldHtml = $("#chat_first_screen").html();
                                          var newHtml = oldHtml + chatHtml;
                                          $("#chat_first_screen").html(newHtml);

                                      }

                                      $("#chat_first_screen").animate({scrollTop: $("#chat_first_screen").prop('scrollHeight')}, 0);
                                      $('#main-chat-input').val('');
                                  }
                              }
                          });
                      }
                      mainFirstTimeFlag = 0;
                  });
          }
          function uploadMainAttachments() {
              var formData = new FormData();
              var main_user_id = $('#main_user_id').val();
              for(var i=0; i<mainAttachments.length;i++){
                  formData.append('files[]', mainAttachments[i]);
              }
              formData.append('my_id', main_my_id);
              formData.append('user_id', main_user_id);
              formData.append('_token', "{{ csrf_token() }}");
              $.ajax({
                  data: formData,
                  async: false,
                  cache: false,
                  processData: false,
                  contentType: false,
                  url: "{{ url('frontend/upload_chat_attachments') }}",
                  type: 'POST',
                  error: function(xhr, status, error) {
                      mainAttachments = [];
                      messageMainAttachments = [];
                      attachmentsRemovedIndexes = [];
                      $('#files-names').html('');
                      sendMainMessageCalled = false;

                      alert('an error in upload. ' + error);

                  },
                  success: function(response) {
                      //alert(response);
                      messageMainAttachments = response;
                      addMainMessageToFirebase();
                  },
                  timeout: 7000
              });
          }
          function blockUser() {
              var id = parseInt( $('#main_user_id').val() );
              blocked_users.push(id);
              db.collection(usersCollection).where("id", "==", parseInt(main_my_id)).limit(1)
                  .get()
                  .then(function(querySnapshot) {
                      querySnapshot.forEach(function(doc) {
                          console.log(doc.id, " => ", doc.data());
                          db.collection(usersCollection).doc(doc.id).update({
                              blocked_users: blocked_users
                          });
                          getMainMessages();
                          //window.location.reload();
                      });
                  });
          }
          function unblockUser() {
              var id = parseInt( $('#main_user_id').val() );
              var index = blocked_users.indexOf(id);
              if (index > -1) {
                  blocked_users.splice(index, 1);
              }
              db.collection(usersCollection).where("id", "==", parseInt(main_my_id)).limit(1)
                  .get()
                  .then(function(querySnapshot) {
                      querySnapshot.forEach(function(doc) {
                          console.log(doc.id, " => ", doc.data());
                          db.collection(usersCollection).doc(doc.id).update({
                              blocked_users: blocked_users
                          });
                          //getUserDetails(id);
                          getMainMessages();
                          //window.location.reload();
                      });
                  });
          }
          function stopConversation() {
              var id = parseInt( $('#main_user_id').val() );
              conversation_stopped_users.push(id);
              db.collection(usersCollection).where("id", "==", parseInt(main_my_id)).limit(1)
                  .get()
                  .then(function(querySnapshot) {
                      querySnapshot.forEach(function(doc) {
                          console.log(doc.id, " => ", doc.data());
                          db.collection(usersCollection).doc(doc.id).update({
                              conversation_stopped_users: conversation_stopped_users
                          });
                          //getUserDetails(id);
                          getMainMessages();
                          //window.location.reload();
                      });
                  });
          }
          function unstopConversation() {
              var id = parseInt( $('#main_user_id').val() );
              //conversation_stopped_users.push(id);
              var index = conversation_stopped_users.indexOf(id);
              if (index > -1) {
                  conversation_stopped_users.splice(index, 1);
              }
              db.collection(usersCollection).where("id", "==", parseInt(main_my_id)).limit(1)
                  .get()
                  .then(function(querySnapshot) {
                      querySnapshot.forEach(function(doc) {
                          console.log(doc.id, " => ", doc.data());
                          db.collection(usersCollection).doc(doc.id).update({
                              conversation_stopped_users: conversation_stopped_users
                          });
                          //getUserDetails(id);
                          getMainMessages();
                          //window.location.reload();
                      });
                  });
          }

          function sendInvite() {
              var main_user_id = $('#main_user_id').val();
              db.collection(invitationsCollection).where("user_ids", "array-contains", main_my_id + '-' + main_user_id).limit(1)
                  .get()
                  .then(function(querySnapshot) {

                      if(querySnapshot.size == 0) {

                          db.collection(invitationsCollection).add({
                              sent_to: main_user_id,
                              sent_by: main_my_id,
                              sent_at: Date.now(),
                              user_ids: [main_user_id, main_my_id, main_my_id + '-' + main_user_id, main_user_id + '-' + main_my_id],
                              status: 'pending'
                          })
                              .then(function(docRef) {
                                  console.log("Document written with ID: ", docRef.id);
                                  getUserDetailsAfterInviteChanged(main_user_id);

                                  // send invite email and notification
                                  sendMainEmailNotification();
                                  // send invite email and notification
                              })
                              .catch(function(error) {
                                  console.error("Error adding document: ", error);
                              });

                      } else {
                          alert('Invite is already sent');
                      }

                  });
          }

          function acceptInvite() {
              var main_user_id = $('#main_user_id').val();
              db.collection(invitationsCollection).where("user_ids", "array-contains", main_my_id + '-' + main_user_id).limit(1)
                  .get()
                  .then(function(querySnapshot) {
                      querySnapshot.forEach(function(doc) {
                          console.log(doc.id, " => ", doc.data());
                          if(doc.data().sent_to == main_my_id) {
                              db.collection(invitationsCollection).doc(doc.id).update({
                                  status: 'accepted'
                              });
                          }
                      });
                      getUserDetailsAfterInviteChanged(main_user_id);
                  });
          }

          function rejectInvite() {
              var main_user_id = $('#main_user_id').val();
              db.collection(invitationsCollection).where("user_ids", "array-contains", main_my_id + '-' + main_user_id).limit(1)
                  .get()
                  .then(function(querySnapshot) {
                      querySnapshot.forEach(function(doc) {
                          console.log(doc.id, " => ", doc.data());
                          if(doc.data().sent_to == main_my_id) {
                              db.collection(invitationsCollection).doc(doc.id).update({
                                  status: 'rejected'
                              });
                          }
                      });
                      getUserDetailsAfterInviteChanged(main_user_id);
                  });
          }
          function getUserDetailsAfterInviteChanged(id) {
              var id = $('#chat_user_id_' + id).val();
              var name = $('#chat_user_name_' + id).val();
              var avatar = $('#chat_user_avatar_' + id).val();
              var chat_user_details_html = '<img src="' + avatar + '"/>' + name;
              $('#chat_user_details_section').html(chat_user_details_html);
              $('#chat_user_section').show();
              $('#main_user_id').val(id);
              getMainMessages();
              inviteChanged();
          }
          function inviteChanged() {
              var main_user_id = $('#main_user_id').val();
              var messageRef = db.collection(invitationsCollection).where("user_ids", "array-contains", main_my_id + '-' + main_user_id).limit(1);
              messageRef
                  .onSnapshot(function (doc) { // this is the event listener on messages collection
                      var docM = doc.docs[0];
                      if(docM != undefined) {
                          var data = docM.data();
                          doc.docChanges().forEach(function (change) {
                              if (change.type === 'added') {
                                  //alert(data.sent_to + '/' + main_my_id + '/' + data.status);
                                  if(data.sent_to == main_my_id && data.status == 'pending') {
                                      getMainMessages();
                                  }
                              }else if (change.type === 'modified') {
                                  if(data.sent_by == main_my_id && (data.status == 'accepted' || data.status == 'rejected')) {
                                      getMainMessages();
                                  }
                              }
                          });
                      }
                  });
          }

          function sendMainEmailNotification() {

              var sender_id = $('#main_my_id').val();
              var receiver_id = $('#main_user_id').val();

              var base_url = "{{ url('/') }}";
              $.ajax({
                  url: base_url + '/frontend/send_chat_invite_email_and_notification?sender_id=' + sender_id + '&receiver_id=' + receiver_id,
                  method: "GET",
                  success: function (data) {
                  },
                  error: function (data) {
                      alert('Could not send invitation')
                  }

              });

          }

          function getMainUnreadMessagesCount() {

              var messageRef = db.collection(messagesCollection);
              messageRef
                  .onSnapshot(function (doc) { // this is the event listener on messages collection
                      var docM = doc.docs[0];
                      var unreadCount = 0;
                      var sent_by_users = [];
                      message_users = [];
                      unreadMessagesUsers = [];
                      blocked_users = [];
                      conversation_stopped_users = [];

                      db.collection(messagesCollection)
                          //.where('sent_to', '==', main_my_id)
                          .orderBy('sent_at', 'desc')
                          .get().then(function (querySnapshot) {
                          querySnapshot.forEach(function (doc) {
                              var data = doc.data();
                              if(data.sent_to == main_my_id && data.is_read == 0) {
                                  //unreadCount++;

                                  // sent by
                                  if( !sent_by_users.includes(data.sent_by) ) {
                                      sent_by_users.push(data.sent_by);

                                      db.collection(messagesCollection)
                                          .where('sent_to', '==', main_my_id)
                                          .where('sent_by', '==', data.sent_by)
                                          .where('is_read', '==', 0)
                                          .get().then(function (msgSnapshot) {


                                          db.collection(usersCollection)
                                              .where('id', '==', parseInt(data.sent_by))
                                              .get().then(function (userSnapshot) {
                                              userSnapshot.forEach(function (userDoc) {
                                                  var userData = userDoc.data();

                                                  var updateFlag = false;
                                                  for (var key in unreadMessagesUsers) {
                                                      var user_id = unreadMessagesUsers[key].userData.id;
                                                      if(user_id == userData.id) {
                                                          updateFlag = true;
                                                          unreadMessagesUsers[key].messageCount = msgSnapshot.size;
                                                      }
                                                  }

                                                  if(updateFlag == false) {
                                                      unreadMessagesUsers.push({
                                                          messageCount: msgSnapshot.size,
                                                          userData: userData
                                                      });
                                                  }

                                                  message_users.push(userData.id);
                                                  unreadCount += msgSnapshot.size;
                                                  $('#main_unread_count').html(unreadCount);
                                              });
                                          });
                                      });
                                  }
                                  // sent by ends
                              }
                          });
                          $('#main_unread_count').html(unreadCount);

                      });

                      // blocked users
                      db.collection(usersCollection).where('id', '==', parseInt(main_my_id)) // query for blocked and stopped users
                          .get().then(function (mainUserSnapshot) {
                          mainUserSnapshot.forEach(function (mainUserDoc) {
                              var mainUserData = mainUserDoc.data();
                              blocked_users = mainUserData.blocked_users;
                              conversation_stopped_users = mainUserData.conversation_stopped_users;
                          });
                      });
                      // blocked users ends

                  });
          }

          function mainReadMessages() {
              var main_user_id = $('#main_user_id').val();
              db.collection(messagesCollection)
                  .where('user_ids', 'array-contains', main_my_id + '-' + main_user_id)
                  .get().then(function (querySnapshot) {
                  querySnapshot.forEach(function (doc) {
                      var data = doc.data();
                      if( data.sent_to == main_my_id && data.is_read == 0 ) {
                          db.collection(messagesCollection).doc(doc.id).update({
                              is_read: 1
                          });
                      }
                  });

              });
          }

      </script>
    @endif

    @yield("scripts")
    @stack('after-js')
  </body>
</html>