<?php
Route::get('/test' , function (){
  $link = 'uploads/images';

  if(is_dir($link)){
    return 'directory';

  }else return 'file';
});
Route::get('/', 'HomeController@index')->name('home');
Route::get('/get_account_value/{account_handle}', 'HomeController@getAccountValue')->name('get_account_value');

//Route::get('/laravel-send-email', 'EmailController@sendEMail');

Route::group(['prefix' => 'frontend', 'as' => 'frontend.', 'namespace' => 'Frontend'], function () {

    Route::get('social', 'SocialAccountsController@index')->name('social.home');
    /*SOCIAL ACCOUNTS HANDLES*/
    Route::get('add/{account}', 'SocialAccountsController@addAccount')->name('social.add_account');
    Route::post('post/{account}', 'SocialAccountsController@postAccount')->name('social.post_account');
    Route::get('verify/{account}/{id}', 'SocialAccountsController@verifyAccount')->name('social.verify_account');
    Route::post('verify/{account}', 'SocialAccountsController@postVerifyAccount')->name('social.post_verify_account');
    Route::get('remove/{id}', 'SocialAccountsController@removeAccount')->name('social.remove_account');

    Route::get('account/worth' , 'SocialAccountsController@accountWorth')->name('social.account_worth');
    Route::get('update_social_account_details' , 'SocialAccountsController@updateSocialAccountDetails')->name('social.update_social_account_details');
    Route::get('get_tiktok_feeds/{account_handle}' , 'SocialAccountsController@getTiktokFeeds')->name('social.get_tiktok_feeds');
    Route::get('test_tiktok/{account_handle}' , 'SocialAccountsController@testTiktok')->name('social.test_tiktok');
    Route::get('get_instagram_feeds/{account_handle}' , 'SocialAccountsController@getInstagramFeeds')->name('social.get_instagram_feeds');


    Route::get('user/dashboard' , 'UsersController@userDashboard')->name('user.dashboard');
    Route::get('admin/dashboard' , 'UsersController@adminDashboard')->name('admin.dashboard');

    Route::get('edit_profile', 'UsersController@editProfile')->name('user.edit_profile');
    Route::post('update_profile', 'UsersController@updateProfile')->name('user.update_profile');

    Route::get('create_ticket', 'TicketsController@create')->name('user.create_ticket');
    Route::post('post_ticket', 'TicketsController@store')->name('user.post_ticket');

    Route::get('campaigns/{status}', 'UsersController@userCampaigns')->name('user.campaigns');
    Route::get('change_campaign_status/{id}/{status}', 'UserCampaignsController@changeStatus')->name('user.change_campaign_status');
    Route::get('create_campaign/{media_account_id}', 'UserCampaignsController@create')->name('user.create_campaign');
    Route::post('post_campaign', 'UserCampaignsController@store')->name('user.post_campaign');
    Route::get('edit_campaign/{id}', 'UserCampaignsController@edit')->name('user.edit_campaign');
    Route::post('update_campaign', 'UserCampaignsController@update')->name('user.update_campaign');
    Route::get('delete_campaign/{id}', 'UserCampaignsController@delete')->name('user.delete_campaign');

    Route::get('user_notifications', 'UsersController@userNotifications')->name('user.notifications');
    Route::get('user_messages', 'UsersController@userMessages')->name('user.messages');
    Route::get('read_notifications/{id}', 'UsersController@readNotification')->name('user.read_notification')->middleware('auth');
    Route::get('create_notification', 'UserNotificationsController@create')->name('user.create_notification');
    Route::post('post_notification', 'UserNotificationsController@store')->name('user.post_notification');
    Route::get('get_notification_details/{id}', 'UsersController@getNotificationDetails')->name('user.get_notification_details');

    Route::get('user_packages', 'UserPackagesController@index')->name('user.packages');
    Route::get('create_package', 'UserPackagesController@create')->name('user.create_package');
    Route::post('post_package', 'UserPackagesController@store')->name('user.post_package');

    Route::get('influencer/{id}', 'UsersController@influencerDetails')->name('user.influencer_details');
    Route::get('browse_influencers', 'UsersController@browseInfluencers')->name('user.browse_influencers');

    Route::post('influencer/update_tags_services', 'UsersController@updateTagsServices')->name('user.influencer.update_tags_services');

    /*Route::get('add_to_cart/{id}', 'UserCartsController@addToCart')->name('user.add_to_cart');*/
    /*Route::get('campaign_cart', 'UserCartsController@campaignsCart')->name('user.campaign_cart');*/
    /*Route::get('delete_cart_item/{id}', 'UserCartsController@deleteCartItem')->name('user.delete_cart_item');*/
    Route::get('create_campaign_post', 'UserCartsController@createCampaignPost')->name('user.create_campaign_post');
    Route::post('store_campaign_post', 'UserCartsController@storeCampaignPost')->name('user.store_campaign_post');
    Route::post('buy_campaign_post', 'UserCartsController@buyCampaignPost')->name('user.buy_campaign_post');


    Route::get('cart', 'UserCartsController@campaignCartDetails')->name('user.campaign_cart_details');
    Route::get('cart/delete/{id}', 'UserCartsController@deleteCartItem')->name('user.delete_cart')->middleware('auth');
    Route::get('cart/edit/{id}', 'UserCartsController@editCartItem')->name('user.edit_cart')->middleware('auth');
    Route::post('cart/update/{id}', 'UserCartsController@updateCartItem')->name('user.update_campaign_post')->middleware('auth');


    Route::get('checkout/{id}', 'OrdersController@createOrder')->name('user.checkout')->middleware('auth');

    Route::get('order_details/{id}', 'OrdersController@orderDetails')->name('user.order_details')->middleware('auth');
    Route::get('order_status/{id}/{status}', 'OrdersController@updateOrderStatus')->name('user.order_status')->middleware('auth');
    Route::get('order_notification_scheduler', 'OrdersController@orderNotificationScheduler')->name('user.order_notification_scheduler');

    Route::get('list/orders', 'OrdersController@listOrders')->name('user.list_orders')->middleware('auth');

    Route::get('update_refundable/{type}/{action}' , 'PaymentController@updateRefundable')->name('user.updateRefundable')->middleware('auth');
    Route::get('payment/account/add' , 'PaymentController@addPayments')->name('user.addPayments')->middleware('auth');
    Route::post('payment/account/create/{type}' , 'PaymentController@savePayments')->name('user.savePayments')->middleware('auth');

    Route::get('/', 'PaymentController@index');
    // route for processing payment
    Route::get('paypal/{id}', 'PaymentController@payWithpaypal')->name('user.redirect_paypal');
    // route for check status of the payment
    Route::get('status', 'PaymentController@getPaymentStatus');

    Route::post('upload_chat_attachments', 'UsersController@uploadChatAttachments');

    Route::get('send_chat_invite_email_and_notification', 'UsersController@sendChatInviteEmailAndNotification');

    Route::get('archived_chat', 'UsersController@archivedChat');

});

Route::get('profile/{profileID}', 'Frontend\SocialAccountsController@viewProfile')->name('user.view_profile');
Route::post('profile_link/edit/{id}', 'Frontend\SocialAccountsController@editProfileLink')->name('user.edit_profile_link');
Route::get('profile_null_link/update/{id}', 'Frontend\SocialAccountsController@updateNullLink')->name('user.update_null_link');

Auth::routes(['register' => true]);
Route::get('verify_email', 'Auth\RegisterController@verifyEmail');

Route::group(['prefix' => 'auth', 'as' => 'auth.', 'namespace' => 'Auth'], function () {
    Route::post('validate_email', 'ForgotPasswordController@validateEmail')->name('validate_email');
});

Route::get('admin/reset', 'Admin\AdminsController@showResetFrom')->name('admin.reset');

Route::group(['prefix' => 'admin', 'as' => 'admin.', 'namespace' => 'Admin', 'middleware' => ['auth']], function () {
    Route::get('/', 'AdminsController@dashboard')->name('home');

    Route::delete('permissions/destroy', 'PermissionsController@massDestroy')->name('permissions.massDestroy');

    Route::resource('permissions', 'PermissionsController');

    Route::delete('roles/destroy', 'RolesController@massDestroy')->name('roles.massDestroy');

    Route::resource('roles', 'RolesController');

    Route::delete('users/destroy', 'UsersController@massDestroy')->name('users.massDestroy');

    Route::resource('users', 'UsersController');
    Route::get('change_status/{id}', 'UsersController@changeStatus')->name('users.change_status');

    Route::delete('admins/destroy', 'AdminsController@massDestroy')->name('admins.massDestroy');
    Route::resource('admins', 'AdminsController');
    Route::get('edit_profile', 'AdminsController@editProfile')->name('admins.edit_profile');
    Route::post('update_profile', 'AdminsController@updateProfile')->name('admins.update_profile');


    Route::delete('products/destroy', 'ProductsController@massDestroy')->name('products.massDestroy');

    Route::resource('products', 'ProductsController');

    Route::delete('tickets/destroy', 'TicketsController@massDestroy')->name('tickets.massDestroy');
    Route::get('tickets/action/{ticket_id}', 'TicketsController@takeAction')->name('tickets.action');
    Route::post('tickets/postAction', 'TicketsController@postAction')->name('tickets.post.action');
    Route::resource('tickets', 'TicketsController');

    Route::delete('notifications/destroy', 'NotificationsController@massDestroy')->name('notifications.massDestroy');
    Route::resource('notifications', 'NotificationsController');

    Route::delete('tags/destroy', 'TagsController@massDestroy')->name('tags.massDestroy');
    Route::resource('tags', 'TagsController');

    Route::delete('services/destroy', 'ServicesController@massDestroy')->name('services.massDestroy');
    Route::resource('services', 'ServicesController');

    Route::get('tag_users', 'TagUsersController@index')->name('tag_users.index');
    Route::get('tag_users/{id}/edit', 'TagUsersController@edit')->name('tag_users.edit');
    Route::put('tag_users/update', 'TagUsersController@update')->name('tag_users.update');

    Route::delete('campaigns/destroy', 'CampaignsController@massDestroy')->name('campaigns.massDestroy');
    Route::resource('campaigns', 'CampaignsController');
    Route::get('campaign_status/{id}/{flag}', 'CampaignsController@update_status')->name('campaigns.status');

    Route::get('featured_influencers', 'FeaturedInfluencersController@index')->name('featured_influencers.index');
    Route::get('featured_influencers/set_is_featured/{influencer_id}/{flag}', 'FeaturedInfluencersController@setIsFeatured')->name('featured_influencers.set_is_featured');
    Route::get('featured_influencers/set_show_on_frontend/{influencer_id}/{flag}', 'FeaturedInfluencersController@setShowOnFrontend')->name('featured_influencers.set_show_on_frontend');
    Route::get('featured_influencers/mass_destroy', 'FeaturedInfluencersController@massDestroy')->name('featured_influencers.mass_destroy');

    Route::post('settings/save', 'SettingsController@save')->name('settings.save');
    Route::get('settings', 'SettingsController@index')->name('settings.index');

    Route::get('notification_events', 'NotificationEventsController@index')->name('notification_events.index');
    Route::post('update_notification_events', 'NotificationEventsController@update')->name('notification_events.update');

    Route::get('site_reviews', 'SiteReviewController@index')->name('site_reviews.index');


    Route::get('failed_transfers', 'PaymentsController@failed_index')->name('failed_transfers.index');
    Route::get('failed_transfers/ignore/{id}', 'PaymentsController@ignore')->name('failed_transfers.ignore');
    Route::get('failed_transfers/refund/{order_id}', 'PaymentsController@refund')->name('failed_transfers.refund');
    Route::get('failed_transfers/mass_destroy', 'PaymentsController@massDestroy')->name('failed_transfers.mass_destroy');
    Route::get('failed_transfers/show/{id}', 'PaymentsController@show')->name('failed_transfers.show');
});
