<?php $__env->startSection('content'); ?>

    <div class="card">
        <div class="card-header">
            <?php echo e(trans('global.create')); ?> <?php echo e(trans('global.ticket.title_singular')); ?>

        </div>

        <div class="card-body">
            <form action="<?php echo e(route("admin.tickets.store")); ?>" method="POST" enctype="multipart/form-data" onsubmit="disableSubmitButton()">
                <?php echo csrf_field(); ?>

                <div class="form-group <?php echo e($errors->has('name') ? 'has-error' : ''); ?>">
                    <label for="start_date"><?php echo e(trans('global.ticket.fields.subject')); ?></label>
                    <input type="text" name="subject" class="form-control">
                    <?php if($errors->has('subject')): ?>
                        <em class="invalid-feedback">
                            <?php echo e($errors->first('subject')); ?>

                        </em>
                    <?php endif; ?>
                    <p class="helper-block">
                        <?php echo e(trans('global.ticket.fields.subject_helper')); ?>

                    </p>
                </div>

                <div class="form-group <?php echo e($errors->has('user_id') ? 'has-error' : ''); ?>">
                    <label for="against_user_id"><?php echo e(trans('global.ticket.fields.against_user_name')); ?>*</label>
                    <select  class="form-control" name="against_user_id">
                        <option value="0">Not Against any User</option>
                        <?php $__currentLoopData = $users; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $user): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                            <option value="<?php echo e($user->id); ?>"><?php echo e($user->name); ?></option>
                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    </select>

                    <?php if($errors->has('against_user_id')): ?>
                        <em class="invalid-feedback">
                            <?php echo e($errors->first('against_user_id')); ?>

                        </em>
                    <?php endif; ?>
                    <p class="helper-block">
                        <?php echo e(trans('global.ticket.fields.against_user_name_helper')); ?>

                    </p>
                </div>
                <div class="form-group <?php echo e($errors->has('description') ? 'has-error' : ''); ?>">
                    <label for="post_id"><?php echo e(trans('global.ticket.fields.description')); ?>*</label>
                    <textarea name="description" class="form-control"></textarea>

                    <?php if($errors->has('description')): ?>
                        <em class="invalid-feedback">
                            <?php echo e($errors->first('description')); ?>

                        </em>
                    <?php endif; ?>
                    <p class="helper-block">
                        <?php echo e(trans('global.ticket.fields.description_helper')); ?>

                    </p>
                </div>

                <div>
                    <input class="btn btn-danger" type="submit" value="<?php echo e(trans('global.save')); ?>">
                </div>
            </form>
        </div>
    </div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('scripts'); ?>
    <script>
        function disableSubmitButton() {
            $('.btn-danger').attr('disabled', true);
        }
    </script>
<?php $__env->stopSection(); ?>


<?php echo $__env->make('layouts.admin', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /var/www/html/cloutsource/resources/views/admin/tickets/create.blade.php ENDPATH**/ ?>