<?php $__env->startSection('content'); ?>


<div class="card">
    <div class="card-header">
        Register Events
    </div>

    <div class="card-body">
        <form action="<?php echo e(route('admin.notification_events.update')); ?>" method="POST" enctype="multipart/form-data">
            <?php echo csrf_field(); ?>
            <?php echo method_field('POST'); ?>
            <div class="form-group <?php echo e($errors->has('create_user_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.create_user_event')); ?></label>

                <textarea name="create_user_event" class="form-control"><?php echo e(array_key_exists('create_user_event', $eventsDetail) ? $eventsDetail['create_user_event'] : ''); ?></textarea>
                <?php if($errors->has('create_user_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('create_user_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.create_user_event_helper')); ?>

                </p>
            </div>

            <input type="hidden" name="section_name" value="register_events">

            <div>
                <input class="btn btn-success" type="submit" value="<?php echo e(trans('global.save')); ?>">
            </div>
        </form>
    </div>

</div>

<div class="card">
    <div class="card-header">
        Campaign Events
    </div>

    <div class="card-body">

        <form action="<?php echo e(route('admin.notification_events.update')); ?>" method="POST" enctype="multipart/form-data">
            <?php echo csrf_field(); ?>
            <?php echo method_field('POST'); ?>

            <div class="form-group <?php echo e($errors->has('create_campaign_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.create_campaign_event')); ?></label>

                <textarea name="create_campaign_event" class="form-control"><?php echo e(array_key_exists('create_campaign_event', $eventsDetail) ? $eventsDetail['create_campaign_event'] : ''); ?></textarea>
                <?php if($errors->has('create_campaign_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('create_campaign_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.create_campaign_event_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('in_progress_campaign_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.in_progress_campaign_event')); ?></label>

                <textarea name="in_progress_campaign_event" class="form-control"><?php echo e(array_key_exists('in_progress_campaign_event', $eventsDetail) ? $eventsDetail['in_progress_campaign_event'] : ''); ?></textarea>
                <?php if($errors->has('in_progress_campaign_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('in_progress_campaign_event')); ?>

                    </em>
                <?php endif; ?>

                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.in_progress_campaign_event_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('completed_campaign_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.completed_campaign_event')); ?></label>

                <textarea name="completed_campaign_event" class="form-control"><?php echo e(array_key_exists('completed_campaign_event', $eventsDetail) ? $eventsDetail['completed_campaign_event'] : ''); ?></textarea>
                <?php if($errors->has('completed_campaign_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('completed_campaign_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.completed_campaign_event_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('accepted_campaign_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.accepted_campaign_event')); ?></label>

                <textarea name="accepted_campaign_event" class="form-control"><?php echo e(array_key_exists('accepted_campaign_event', $eventsDetail) ? $eventsDetail['accepted_campaign_event'] : ''); ?></textarea>
                <?php if($errors->has('accepted_campaign_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('accepted_campaign_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.accepted_campaign_event_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('rejected_campaign_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.rejected_campaign_event')); ?></label>

                <textarea name="rejected_campaign_event" class="form-control"><?php echo e(array_key_exists('rejected_campaign_event', $eventsDetail) ? $eventsDetail['rejected_campaign_event'] : ''); ?></textarea>
                <?php if($errors->has('rejected_campaign_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('rejected_campaign_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.rejected_campaign_event_helper')); ?>

                </p>
            </div>
            <input type="hidden" name="section_name" value="campaign_events">
            <div>
                <input class="btn btn-success" type="submit" value="<?php echo e(trans('global.save')); ?>">
            </div>

        </form>

    </div>


</div>

<div class="card">
    <div class="card-header">
        Order Events
    </div>

    <div class="card-body">

        <form action="<?php echo e(route('admin.notification_events.update')); ?>" method="POST" enctype="multipart/form-data">
            <?php echo csrf_field(); ?>
            <?php echo method_field('POST'); ?>

            <div class="form-group <?php echo e($errors->has('create_order_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.create_order_event')); ?></label>

                <textarea name="create_order_event" class="form-control"><?php echo e(array_key_exists('create_order_event', $eventsDetail) ? $eventsDetail['create_order_event'] : ''); ?></textarea>
                <?php if($errors->has('create_order_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('create_order_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.create_order_event_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('in_progress_order_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.in_progress_order_event')); ?></label>

                <textarea name="in_progress_order_event" class="form-control"><?php echo e(array_key_exists('in_progress_order_event', $eventsDetail) ? $eventsDetail['in_progress_order_event'] : ''); ?></textarea>
                <?php if($errors->has('in_progress_order_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('in_progress_order_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.in_progress_order_event_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('completed_order_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.completed_order_event')); ?></label>

                <textarea name="completed_order_event" class="form-control"><?php echo e(array_key_exists('completed_order_event', $eventsDetail) ? $eventsDetail['completed_order_event'] : ''); ?></textarea>
                <?php if($errors->has('completed_order_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('completed_order_event')); ?>

                    </em>
                <?php endif; ?>

                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.completed_order_event_helper')); ?>

                </p>
            </div>
            <input type="hidden" name="section_name" value="order_events">
            <div>
                <input class="btn btn-success" type="submit" value="<?php echo e(trans('global.save')); ?>">
            </div>
        </form>

    </div>


</div>


<div class="card">
    <div class="card-header">
        Balance Events
    </div>

    <div class="card-body">

        <form action="<?php echo e(route('admin.notification_events.update')); ?>" method="POST" enctype="multipart/form-data">
            <?php echo csrf_field(); ?>
            <?php echo method_field('POST'); ?>

            <div class="form-group <?php echo e($errors->has('add_balance_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.add_balance_event')); ?></label>

                <textarea name="add_balance_event" class="form-control"><?php echo e(array_key_exists('add_balance_event', $eventsDetail) ? $eventsDetail['add_balance_event'] : ''); ?></textarea>
                <?php if($errors->has('add_balance_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('add_balance_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.add_balance_event_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('withdraw_balance_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.withdraw_balance_event')); ?></label>

                <textarea name="withdraw_balance_event" class="form-control"><?php echo e(array_key_exists('withdraw_balance_event', $eventsDetail) ? $eventsDetail['withdraw_balance_event'] : ''); ?></textarea>
                <?php if($errors->has('withdraw_balance_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('withdraw_balance_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.withdraw_balance_event_helper')); ?>

                </p>
            </div>

            <input type="hidden" name="section_name" value="balance_events">
            <div>
                <input class="btn btn-success" type="submit" value="<?php echo e(trans('global.save')); ?>">
            </div>

        </form>

    </div>


</div>


<div class="card">
    <div class="card-header">
        Ticket Events
    </div>

    <div class="card-body">

        <form action="<?php echo e(route('admin.notification_events.update')); ?>" method="POST" enctype="multipart/form-data">
            <?php echo csrf_field(); ?>
            <?php echo method_field('POST'); ?>

            <div class="form-group <?php echo e($errors->has('normal_ticket_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.normal_ticket_event')); ?></label>

                <textarea name="normal_ticket_event" class="form-control"><?php echo e(array_key_exists('normal_ticket_event', $eventsDetail) ? $eventsDetail['normal_ticket_event'] : ''); ?></textarea>
                <?php if($errors->has('normal_ticket_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('normal_ticket_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.normal_ticket_event_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('suspend_user_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.suspend_user_event')); ?></label>

                <textarea name="suspend_user_event" class="form-control"><?php echo e(array_key_exists('suspend_user_event', $eventsDetail) ? $eventsDetail['suspend_user_event'] : ''); ?></textarea>
                <?php if($errors->has('suspend_user_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('suspend_user_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.suspend_user_event_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('resolve_ticket_event') ? 'has-error' : ''); ?>">
                <label for="name"><?php echo e(trans('global.setting_events.fields.resolve_ticket_event')); ?></label>

                <textarea name="resolve_ticket_event" class="form-control"><?php echo e(array_key_exists('resolve_ticket_event', $eventsDetail) ? $eventsDetail['resolve_ticket_event'] : ''); ?></textarea>
                <?php if($errors->has('resolve_ticket_event')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('resolve_ticket_event')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.setting_events.fields.resolve_ticket_event_helper')); ?>

                </p>
            </div>
            <input type="hidden" name="section_name" value="ticket_events">
            <div>
                <input class="btn btn-success" type="submit" value="<?php echo e(trans('global.save')); ?>">
            </div>

        </form>

    </div>


</div>

<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.admin', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /var/www/html/cloutsource/resources/views/admin/notifications/notification_events.blade.php ENDPATH**/ ?>