<!DOCTYPE html>
<html>

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <meta name="csrf-token" content="<?php echo e(csrf_token()); ?>">

    <title><?php echo e(trans('global.site_title')); ?></title>
     <link rel="icon" type="image/png" sizes="16x16" href="<?php echo e(asset('frontend/images/favicon.png')); ?>">
    <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" rel="stylesheet" />
    <link rel="stylesheet" href="https://pro.fontawesome.com/releases/v5.14.0/css/all.css">
    <link href="https://cdn.datatables.net/1.10.19/css/jquery.dataTables.min.css" rel="stylesheet" />
    <link href="https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css" rel="stylesheet" />
    <link href="https://cdn.datatables.net/buttons/1.2.4/css/buttons.dataTables.min.css" rel="stylesheet" />
    <link href="https://cdn.datatables.net/select/1.3.0/css/select.dataTables.min.css" rel="stylesheet" />
    <link href="https://unpkg.com/@coreui/coreui/dist/css/coreui.min.css" rel="stylesheet" />
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.5/css/select2.min.css" rel="stylesheet" />
    <link href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datetimepicker/4.17.47/css/bootstrap-datetimepicker.min.css" rel="stylesheet" />
    <link href="https://cdnjs.cloudflare.com/ajax/libs/dropzone/5.5.1/min/dropzone.min.css" rel="stylesheet" />
    <link href="<?php echo e(asset('css/custom.css')); ?>" rel="stylesheet" />
    
    <link rel="stylesheet" href="<?php echo e(asset('frontend/css/custom_style.css')); ?>" />
    <?php echo $__env->yieldContent('styles'); ?>
</head>

<body class="app header-fixed sidebar-fixed aside-menu-fixed pace-done sidebar-lg-show">
    <header class="app-header navbar">
        <button class="navbar-toggler sidebar-toggler d-lg-none mr-auto" type="button" data-toggle="sidebar-show">
            <span class="navbar-toggler-icon"></span>
        </button>
        <a class="navbar-brand" href="#">
            <span class="navbar-brand-full"> <img src="<?php echo e(asset('frontend/images/adminlogo.png')); ?>" alt="" /></span>
            
        </a>

        <a href="#menu-toggle" class="btn btn-default" id="menu-toggle"><i class="fal fa-bars"></i></a>
     

        <ul class="nav navbar-nav ml-auto">
            <?php if(count(config('panel.available_languages', [])) > 1): ?>
                <li class="nav-item dropdown d-md-down-none">
                    <a class="nav-link" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">
                        <?php echo e(strtoupper(app()->getLocale())); ?>

                    </a>
                    <div class="dropdown-menu dropdown-menu-right">
                        <?php $__currentLoopData = config('panel.available_languages'); $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $langLocale => $langName): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                            <a class="dropdown-item" href="<?php echo e(url()->current()); ?>?change_language=<?php echo e($langLocale); ?>"><?php echo e(strtoupper($langLocale)); ?> (<?php echo e($langName); ?>)</a>
                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    </div>
                </li>
            <?php endif; ?>
        </ul>

        <div class="navbar-profile-info">
<div class="dropdown">
  <button class="dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
    Hi, <?php echo e(auth()->user()->name); ?>

  </button>
  <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
    <a class="dropdown-item" href="<?php echo e(url('admin/edit_profile')); ?>">Profile</a>
    <a class="dropdown-item" href="#" onclick="event.preventDefault(); document.getElementById('logoutform').submit();">Logout</a>
  </div>
</div>
</div>


    </header>

    <div class="app-body">
        <div id="wrapper">

        <!-- Sidebar -->
        <div id="sidebar-wrapper">
            <ul class="sidebar-nav">
                

            <li class="nav-item">
                <a href="<?php echo e(route("admin.home")); ?>" class="nav-link <?php echo e(request()->is('admin') ? 'active' : ''); ?>">
                    <i class="nav-icon fas fa-tachometer-alt"></i>
                    <?php echo e(trans('global.dashboard')); ?>

                </a>
            </li>

            <li class="nav-item">
                <a href="<?php echo e(route("admin.admins.index")); ?>" class="nav-link <?php echo e(request()->is('admin/admins') || request()->is('admin/admins/*') ? 'active' : ''); ?>">
                    <i class="fas fa-user nav-icon"></i>
                    <?php echo e(trans('global.user.admin_title')); ?>

                </a>
            </li>

            <li class="nav-item">
                <a href="<?php echo e(route("admin.users.index")); ?>" class="nav-link <?php echo e(request()->is('admin/users') || request()->is('admin/users/*') ? 'active' : ''); ?>">
                    <i class="fas fa-user nav-icon"></i>
                    <?php echo e(trans('global.user.title')); ?>

                </a>
            </li>

            <li class="nav-item nav-dropdown" style="display: none;">
                <a class="nav-link  nav-dropdown-toggle">
                    <i class="fas fa-users nav-icon"></i>
                    <?php echo e(trans('global.userManagement.title')); ?>

                </a>
                <ul class="nav-dropdown-items">
                    <li class="nav-item">
                        <a href="<?php echo e(route("admin.permissions.index")); ?>" class="nav-link <?php echo e(request()->is('admin/permissions') || request()->is('admin/permissions/*') ? 'active' : ''); ?>">
                            <i class="fas fa-unlock-alt nav-icon"></i>
                            <?php echo e(trans('global.permission.title')); ?>

                        </a>
                    </li>
                    <li class="nav-item">
                        <a href="<?php echo e(route("admin.roles.index")); ?>" class="nav-link <?php echo e(request()->is('admin/roles') || request()->is('admin/roles/*') ? 'active' : ''); ?>">
                            <i class="fas fa-briefcase nav-icon"></i>
                            <?php echo e(trans('global.role.title')); ?>

                        </a>
                    </li>
                    <li class="nav-item">
                        <a href="<?php echo e(route("admin.users.index")); ?>" class="nav-link <?php echo e(request()->is('admin/users') || request()->is('admin/users/*') ? 'active' : ''); ?>">
                            <i class="fas fa-users nav-icon"></i>
                            <?php echo e(trans('global.user.title')); ?>

                        </a>
                    </li>
                </ul>
            </li>
            <li class="nav-item" style="display: none;">
                <a href="<?php echo e(route("admin.products.index")); ?>" class="nav-link <?php echo e(request()->is('admin/products') || request()->is('admin/products/*') ? 'active' : ''); ?>">
                    <i class="fas fa-cogs nav-icon"></i>
                    <?php echo e(trans('global.product.title')); ?>

                </a>
            </li>

            <li class="nav-item">
                <a href="<?php echo e(route("admin.tickets.index")); ?>" class="nav-link <?php echo e(request()->is('admin/tickets') || request()->is('admin/tickets/*') ? 'active' : ''); ?>">
                    <i class="fa fa-ticket nav-icon"></i>
                    <?php echo e(trans('global.ticket.title')); ?>

                </a>
            </li>

            <li class="nav-item">
                <a href="<?php echo e(route("admin.failed_transfers.index")); ?>" class="nav-link <?php echo e(request()->is('admin/failed_transfers') || request()->is('admin/failed_transfers/*') ? 'active' : ''); ?>">
                    <i class="fa fa-ban nav-icon"></i>
                    Failed Transfers
                </a>
            </li>

            <li class="nav-item">
                <a href="<?php echo e(route("admin.notifications.index")); ?>" class="nav-link <?php echo e(request()->is('admin/notifications') || request()->is('admin/notifications/*') ? 'active' : ''); ?>">
                    <i class="fas fa-bell nav-icon"></i>
                    <?php echo e(trans('global.notifications.title')); ?>

                </a>
            </li>

            <li class="nav-item" style="display: none">
                <a href="<?php echo e(route("admin.notification_events.index")); ?>" class="nav-link <?php echo e(request()->is('admin/notification_events') || request()->is('admin/notification_events/*') ? 'active' : ''); ?>">
                    <i class="fas fa-bell nav-icon"></i>
                    <?php echo e(trans('global.setting_events.title')); ?>

                </a>
            </li>

            <li class="nav-item">
                <a href="<?php echo e(route("admin.featured_influencers.index")); ?>" class="nav-link">
                    <i class="fas fa-crown nav-icon"></i>
                    <?php echo e(trans('global.featured_influencers.title')); ?>

                </a>
            </li>
        
        <li class="nav-item">
            <a href="<?php echo e(route("admin.tags.index")); ?>" class="nav-link <?php echo e(request()->is('admin/tags') || request()->is('admin/tags/*') ? 'active' : ''); ?>">
                <i class="fas fa-tags nav-icon"></i>
                <?php echo e(trans('global.tags.title')); ?>

            </a>
        </li>
        

        
        <li class="nav-item">
            <a href="<?php echo e(route("admin.services.index")); ?>" class="nav-link <?php echo e(request()->is('admin/services') || request()->is('admin/services/*') ? 'active' : ''); ?>">
                <i class="fas fa-tags nav-icon"></i>
                <?php echo e(trans('global.services.title')); ?>

            </a>
        </li>
        



            <li class="nav-item">
                <a href="<?php echo e(route("admin.campaigns.index")); ?>" class="nav-link <?php echo e(request()->is('admin/campaigns') || request()->is('admin/campaigns/*') ? 'active' : ''); ?>">
                    <i class="fab fa-elementor nav-icon"></i>
                    <?php echo e(trans('global.campaign.title')); ?>

                </a>
            </li>
            
            <li class="nav-item" style="display: none;">
                <a href="<?php echo e(route("admin.site_reviews.index")); ?>" class="nav-link <?php echo e(request()->is('admin/site_reviews') || request()->is('admin/site_reviews/*') ? 'active' : ''); ?>">
                    <i class="fab fa-elementor nav-icon"></i>
                    <?php echo e(trans('global.site_review.title')); ?>

                </a>
            </li>
            

            <li class="nav-item" style="display: none">
                <a href="<?php echo e(route('admin.settings.index')); ?>" class="nav-link <?php echo e(request()->is('admin/settings') || request()->is('admin/settings/*') ? 'active' : ''); ?>">
                    <i class="fas fa-cogs nav-icon"></i>
                    <?php echo e(trans('global.settings.title')); ?>

                </a>
            </li>

            <li class="nav-item">
                <a href="#" class="nav-link" onclick="event.preventDefault(); document.getElementById('logoutform').submit();">
                    <i class="nav-icon fas fa-sign-out-alt"></i>
                    <?php echo e(trans('global.logout')); ?>

                </a>
            </li>
            </ul>
        </div>
        <!-- /#sidebar-wrapper -->

        <!-- Page Content -->
        <div id="page-content-wrapper">
            <div class="container-fluid">
                <div class="row">
             
                    <div class="col-lg-12">
                      <div class="homemain">
                      <?php echo $__env->make('flash-message', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
                      <?php echo $__env->yieldContent('content'); ?>
                      </div>
                        
                    </div>
                </div>
            </div>
        </div>
        <!-- /#page-content-wrapper -->

    </div>
    <!-- /#wrapper -->

<!--         <main class="main">


            <div style="padding-top: 20px" class="container-fluid">

                <?php echo $__env->make('flash-message', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

                <?php echo $__env->yieldContent('content'); ?>

            </div>


        </main> -->
        <form id="logoutform" action="<?php echo e(route('logout')); ?>" method="POST" style="display: none;">
            <?php echo e(csrf_field()); ?>

        </form>
    </div>
    

    <script src="<?php echo e(asset('js/jquery.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/popper.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/bootstrap.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/coreui.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/jquery.dataTables.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/dataTables.bootstrap4.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/dataTables.buttons.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/buttons.flash.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/buttons.html5.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/buttons.print.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/buttons.colVis.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/pdfmake.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/vfs_fonts.js')); ?>"></script>
    <script src="<?php echo e(asset('js/jszip.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/dataTables.select.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/ckeditor.js')); ?>"></script>
    <script src="<?php echo e(asset('js/moment.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/bootstrap-datetimepicker.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/select2.full.min.js')); ?>"></script>
    <script src="<?php echo e(asset('js/dropzone.min.js')); ?>"></script>

    <script src="<?php echo e(asset('js/main.js')); ?>"></script>
    <script>
        $(function() {
  let copyButtonTrans = '<?php echo e(trans('global.datatables.copy')); ?>'
  let csvButtonTrans = '<?php echo e(trans('global.datatables.csv')); ?>'
  let excelButtonTrans = '<?php echo e(trans('global.datatables.excel')); ?>'
  let pdfButtonTrans = '<?php echo e(trans('global.datatables.pdf')); ?>'
  let printButtonTrans = '<?php echo e(trans('global.datatables.print')); ?>'
  let colvisButtonTrans = '<?php echo e(trans('global.datatables.colvis')); ?>'

  let languages = {
    'en': 'https://cdn.datatables.net/plug-ins/1.10.19/i18n/English.json'
  };

  $.extend(true, $.fn.dataTable.Buttons.defaults.dom.button, { className: 'btn' })
  $.extend(true, $.fn.dataTable.defaults, {
    language: {
      url: languages.<?php echo e(app()->getLocale()); ?>

    },
    columnDefs: [{
        orderable: false,
        className: 'select-checkbox',
        targets: 0
    }, {
        orderable: false,
        searchable: false,
        targets: -1
    }],
    select: {
      style:    'multi+shift',
      selector: 'td:first-child'
    },
    order: [],
    scrollX: true,
    pageLength: 100,
    dom: 'lBfrtip<"actions">',
    buttons: [
      {
        extend: 'copy',
        className: 'btn-default',
        text: copyButtonTrans,
        exportOptions: {
          columns: ':visible'
        }
      },
      {
        extend: 'csv',
        className: 'btn-default',
        text: csvButtonTrans,
        exportOptions: {
          columns: ':visible'
        }
      },
      {
        extend: 'excel',
        className: 'btn-default',
        text: excelButtonTrans,
        exportOptions: {
          columns: ':visible'
        }
      },
      {
        extend: 'pdf',
        className: 'btn-default',
        text: pdfButtonTrans,
        exportOptions: {
          columns: ':visible'
        }
      },
      {
        extend: 'print',
        className: 'btn-default',
        text: printButtonTrans,
        exportOptions: {
          columns: ':visible'
        }
      },
      {
        extend: 'colvis',
        className: 'btn-default',
        text: colvisButtonTrans,
        exportOptions: {
          columns: ':visible'
        }
      }
    ]
  });

  $.fn.dataTable.ext.classes.sPageButton = '';
});

    </script>

<script>
$("#menu-toggle").click(function(e) {
  e.preventDefault();
  $("#wrapper").toggleClass("toggled");
});


</script>

<!-- <script>
  $('.dropdown').on('show.bs.dropdown', function() {
    $(this).find('.dropdown-menu').first().stop(true, true).slideDown();
  });

  // Add slideUp animation to Bootstrap dropdown when collapsing.
  $('.dropdown').on('hide.bs.dropdown', function() {
    $(this).find('.dropdown-menu').first().stop(true, true).slideUp();
  });
</script> -->


    <?php echo $__env->yieldContent('scripts'); ?>
</body>

</html>
<?php /**PATH /var/www/html/cloutsource/resources/views/layouts/admin.blade.php ENDPATH**/ ?>