<link rel="stylesheet" href="<?php echo e(asset('css/admin_dashboard.css')); ?>" />
<?php $__env->startSection('content'); ?>
    <section class="user-dashboard">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <div class="heading-text">
                        <h3>EARNING</h3>
                    </div>
                    <div class="chartcanvas" style="width:100%;">
                        <canvas id="canvas" class="chart" style="height: 300px"></canvas>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <section class="earningreport">
        <div class="container">
            <div class="row">
                <div class="earningreport-item">
                    <div class="inner-heading-text">
                        <h3>TOTAL EARNINGS</h3>
                    </div>
                    <div class="earningreport-inner">
                        <i class="far fa-chart-bar"></i>
                        <span>$<?php echo e(App\SocialmediaObject::number_format_short( $earningDetails['totalEarning'] )); ?></span>
                    </div>
                </div>
                <div class="earningreport-item">
                    <div class="inner-heading-text">
                        <h3>EARNING THIS MONTH</h3>
                    </div>
                    <div class="earningreport-inner">
                        <i class="far fa-chart-bar"></i>
                        <span>$<?php echo e(App\SocialmediaObject::number_format_short( $earningDetails['thisMonthEarning'] )); ?></span>
                    </div>
                </div>
                <div class="earningreport-item">
                    <div class="inner-heading-text">
                        <h3>EARNING THIS YEAR</h3>
                    </div>
                    <div class="earningreport-inner">
                        <i class="far fa-chart-bar"></i>
                        <span>$<?php echo e(App\SocialmediaObject::number_format_short( $earningDetails['thisYearEarning'] )); ?></span>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <section class="totalcampaign socialmedia-accounts">
        <div class="container">
            <div class="row">
                <div class="totalearningreport-item">
                    <div class="inner-heading-text">
                        <h3>SOCIAL MEDIA ACCOUNTS</h3>
                    </div>
                    <div class="socialmedia-piechart">
                        <div id="chart_div"></div>
                        <div class="social-media-account-info">
                            <h1><?php echo e($earningDetails['tiktokAccountsCount'] + $earningDetails['instagramAccountsCount']); ?></h1>
                        </div>
                    </div>
                </div>
                <div class="totalearningreport-item feature-profile">
                    <div class="inner-heading-text">
                        <h3>NUMBER OF FEATURED PROFILES</h3>
                    </div>
                    <div class="totalearningreport-inner">
                        <i class="fas fa-users"></i>
                        <span><?php echo e($earningDetails['featuredCount']); ?></span>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <section class="totalcampaign socialmedia-accounts">
        <div class="container">
            <div class="row">
                <div class="totalearningreport-item">
                    <div class="inner-heading-text">
                        <h3>TRANSACTIONS</h3>
                    </div>
                    <div class="socialmedia-piechart">
                        <div id="chart_div2"></div>
                        <div class="transaction-completed">
                            <span class="completed-acc">Deposits: &nbsp; <?php echo e($earningDetails['completedEarning']); ?></span>
                            <span class="pending-acc">Refunds: &nbsp; <?php echo e($earningDetails['pendingEarning']); ?></span>
                        </div>
                    </div>
                </div>
                <div class="totalearningreport-item feature-profile">
                    <div class="inner-heading-text">
                        <h3>NO OF USERS</h3>
                    </div>
                    <div class="totalearningreport-inner">
                        <i class="fas fa-users"></i>
                        <span><?php echo e($earningDetails['noOfUsers']); ?></span>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <section class="top-selling-profile">
        <div class="container">
            <div class="row">
                <div class="inner-heading-text">
                    <h3>TOP 10 SELLING PROFILES</h3>
                </div>
                <div class="top-selling-profile-parent">
                    <?php $__currentLoopData = $earningDetails['topTenInfluencers']; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $influencer): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                        <div class="top-selling-profile-item">
                            <div class="top-profile-img">
                                <img src="<?php echo e($influencer->profile_picture); ?>" alt="" />
                            </div>
                            <div class="top-profile-text">
                                <h6><?php echo e($influencer->account_name); ?></h6>
                                <span>$<?php echo e(\App\SocialmediaObject::number_format_short($influencer->transaction_amount)); ?></span>
                            </div>
                        </div>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>


                </div>
            </div>
        </div>
    </section>
    <input type="hidden" id="all_months_earnings" value="<?php echo e(implode( ',', $earningDetails['allMonthsEarnings'] )); ?>">
<?php $__env->startSection('scripts'); ?>
    ##parent-placeholder-16728d18790deb58b3b8c1df74f06e536b532695##

    <script src="<?php echo e(asset('frontend/js/Chart.min.js')); ?>"></script>


    <script src="https://www.gstatic.com/charts/loader.js"></script>
    <script>
        var all_months_earnings = $('#all_months_earnings').val();
        var all_months_earnings_array = all_months_earnings.split(',');
        var lineChartData = {
            labels: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
            datasets: [{
                label: 'Monthly Earnings',
                borderColor: 'blue',
                backgroundColor: 'blue',
                fill: false,
                data: [
                    all_months_earnings_array[0],
                    all_months_earnings_array[1],
                    all_months_earnings_array[2],
                    all_months_earnings_array[3],
                    all_months_earnings_array[4],
                    all_months_earnings_array[5],
                    all_months_earnings_array[6],
                    all_months_earnings_array[7],
                    all_months_earnings_array[8],
                    all_months_earnings_array[9],
                    all_months_earnings_array[10],
                    all_months_earnings_array[11]
                ],
                yAxisID: 'y-axis-1',
            }
            ]
        };

        window.onload = function() {
            var ctx = document.getElementById('canvas').getContext('2d');
            window.myLine = Chart.Line(ctx, {
                data: lineChartData,
                options: {
                    responsive: true,
                    hoverMode: 'index',
                    stacked: false,
                    title: {
                        display: false,
                        text: 'Chart.js Line Chart - Multi Axis'
                    },
                    scales: {
                        yAxes: [{
                            type: 'linear', // only linear but allow scale type registration. This allows extensions to exist solely for log scale for instance
                            display: true,
                            position: 'left',
                            id: 'y-axis-1',
                        }, {
                            type: 'linear', // only linear but allow scale type registration. This allows extensions to exist solely for log scale for instance
                            display: false,
                            position: 'right',
                            id: 'y-axis-2',

                            // grid line settings
                            gridLines: {
                                drawOnChartArea: false, // only want the grid lines for one axis to show up
                            },
                        }],
                    }
                }
            });
        };

    </script>



    <script>
        // Load the Visualization API and the piechart package.
        google.load('visualization', '1.0', {'packages':['corechart','line']});
        // Set a callback to run when the Google Visualization API is loaded.
        google.setOnLoadCallback(drawChart);
        // Callback that creates and populates a data table,
        // instantiates the pie chart, passes in the data and
        // draws it.
        function drawChart() {
// Create the data table.
            var data = new google.visualization.DataTable();
            data.addColumn('string', 'Topping');
            data.addColumn('number', 'Slices');
            data.addRows([
                ['TIKTOK', parseInt( "<?php echo e($earningDetails['tiktokAccountsCount']); ?>" )],
                ['INSTAGRAM', parseInt( "<?php echo e($earningDetails['instagramAccountsCount']); ?>" )]
            ]);
// Create the data table.
            var data2 = new google.visualization.DataTable();
            data2.addColumn('string', 'Topping');
            data2.addColumn('number', 'Slices');
            data2.addRows([
                ['Refunds', parseInt( "<?php echo e($earningDetails['pendingEarning']); ?>" )],
                ['Deposits', parseInt( "<?php echo e($earningDetails['completedEarning']); ?>" )]
            ]);
// Set chart options
            var options = {
                'width':400,
                'height':300,
                colors: ['#68c9d0', '#3e729a']};
// Set chart options
            var options2 = {
                'width':400,
                'height':300,
                colors: ['red', '#3266cc']};
// Instantiate and draw our chart, passing in some options.
            var chart = new google.visualization.PieChart(document.getElementById('chart_div'));
            chart.draw(data, options);
            var chart2 = new google.visualization.PieChart(document.getElementById('chart_div2'));
            chart2.draw(data2, options2);
        }

    </script>



<?php $__env->stopSection(); ?>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.admin', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /var/www/html/cloutsource/resources/views/admin/dashboard.blade.php ENDPATH**/ ?>