<?php $__env->startSection('content'); ?>

    <div class="card">
        <div class="card-header">
            <?php echo e(trans('global.edit')); ?> <?php echo e(trans('global.settings.title_singular')); ?>

        </div>

        <div class="card-body">
            <form action="<?php echo e(route('admin.settings.save')); ?>" method="POST" enctype="multipart/form-data">
                <?php echo csrf_field(); ?>
                <?php echo method_field('POST'); ?>
                <div class="form-group <?php echo e($errors->has('timezone') ? 'has-error' : ''); ?>">
                    <label for="name"><?php echo e(trans('global.settings.fields.timezone')); ?>*</label>
                    <select  class="form-control" name="timezone">
                        <?php $__currentLoopData = $timezonesList; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $val): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                            <option value="<?php echo e($val); ?>" <?php if($settings['timezone'] == $val): ?> selected <?php endif; ?>><?php echo e($val); ?></option>
                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    </select>
                    <?php if($errors->has('timezone')): ?>
                        <em class="invalid-feedback">
                            <?php echo e($errors->first('timezone')); ?>

                        </em>
                    <?php endif; ?>
                    <p class="helper-block">
                        <?php echo e(trans('global.settings.fields.timezone_helper')); ?>

                    </p>
                </div>

                <div class="form-group <?php echo e($errors->has('site_name') ? 'has-error' : ''); ?>">
                    <label for="name"><?php echo e(trans('global.settings.fields.site_name')); ?>*</label>
                    <input type="text" id="site_name" name="site_name" class="form-control" value="<?php echo e($settings['site_title']); ?>">
                    <?php if($errors->has('site_name')): ?>
                        <em class="invalid-feedback">
                            <?php echo e($errors->first('site_name')); ?>

                        </em>
                    <?php endif; ?>
                    <p class="helper-block">
                        <?php echo e(trans('global.settings.fields.site_name_helper')); ?>

                    </p>
                </div>

                <div class="form-group <?php echo e($errors->has('project_name') ? 'has-error' : ''); ?>">
                    <label for="name"><?php echo e(trans('global.settings.fields.project_name')); ?>*</label>
                    <input type="text" id="project_name" name="project_name" class="form-control" value="<?php echo e(old('project_name', isset($settings) ? $settings['project_title'] : '')); ?>">
                    <?php if($errors->has('project_name')): ?>
                        <em class="invalid-feedback">
                            <?php echo e($errors->first('project_name')); ?>

                        </em>
                    <?php endif; ?>
                    <p class="helper-block">
                        <?php echo e(trans('global.settings.fields.project_name_helper')); ?>

                    </p>
                </div>

                <div class="form-group <?php echo e($errors->has('email') ? 'has-error' : ''); ?>">
                        <label for="name"><?php echo e(trans('global.settings.fields.email')); ?>*</label>
                        <input type="text" id="email" name="email" class="form-control" value="<?php echo e($settings['email']); ?>">
                        <?php if($errors->has('email')): ?>
                            <em class="invalid-feedback">
                                <?php echo e($errors->first('email')); ?>

                            </em>
                        <?php endif; ?>
                        <p class="helper-block">
                            <?php echo e(trans('global.settings.fields.email_helper')); ?>

                        </p>   
                </div>

                <div class="form-group <?php echo e($errors->has('phone') ? 'has-error' : ''); ?>">
                        <label for="name"><?php echo e(trans('global.settings.fields.phone')); ?>*</label>
                        <input type="text" id="phone" name="phone" class="form-control" value="<?php echo e($settings['phone']); ?>">
                        <?php if($errors->has('phone')): ?>
                            <em class="invalid-feedback">
                                <?php echo e($errors->first('phone')); ?>

                            </em>
                        <?php endif; ?>
                        <p class="helper-block">
                            <?php echo e(trans('global.settings.fields.phone_helper')); ?>

                        </p>   
                </div>

                <div class="form-group <?php echo e($errors->has('show_influencers') ? 'has-error' : ''); ?>">
                    <label for="show_influencers"><?php echo e(trans('global.settings.fields.show_influencers')); ?></label>
                    <select  class="form-control" name="show_influencers">
                        <option value="Yes" <?php if($settings['show_influencers'] == 'Yes'): ?> selected <?php endif; ?>>Yes</option>
                        <option value="No" <?php if($settings['show_influencers'] == 'No'): ?> selected <?php endif; ?>>No</option>
                    </select>
                    <?php if($errors->has('show_influencers')): ?>
                        <em class="invalid-feedback">
                            <?php echo e($errors->first('show_influencers')); ?>

                        </em>
                    <?php endif; ?>
                    <p class="helper-block">
                        <?php echo e(trans('global.settings.fields.show_influencers_helper')); ?>

                    </p>
                </div>

                <div class="form-group <?php echo e($errors->has('address') ? 'has-error' : ''); ?>">
                        <label for="name"><?php echo e(trans('global.settings.fields.address')); ?></label>
                        <textarea id="address" name="address" class="form-control"><?php echo e($settings['address']); ?></textarea>
                        <?php if($errors->has('address')): ?>
                            <em class="invalid-feedback">
                                <?php echo e($errors->first('address')); ?>

                            </em>
                        <?php endif; ?>
                        <p class="helper-block">
                            <?php echo e(trans('global.settings.fields.address_helper')); ?>

                        </p>   
                </div>

                <div>
                    <input class="btn btn-success" type="submit" value="<?php echo e(trans('global.save')); ?>">
                </div>
            </form>
        </div>
    </div>


<?php $__env->stopSection(); ?>


<?php echo $__env->make('layouts.admin', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /var/www/html/cloutsource/resources/views/admin/settings.blade.php ENDPATH**/ ?>