<?php $__env->startSection('content'); ?>
    <div class="card">
        <div class="card-header">
            Failed Transfers
        </div>

        <div class="card-body">

                <table class="table table-bordered table-striped table-hover datatable table-responsive">
                    <thead>
                    <tr>
                        <th></th>
                        <th>Order ID</th>
                        <th>Amount</th>
                        <th>Payment Type</th>
                        <th>Transaction Type</th>
                        <th>Response</th>
                        <th>Status</th>
                        <th>Actions</th>
                    </tr>
                    </thead>
                    <tbody>
                    <?php $__currentLoopData = $failed_transfers; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $key => $failed): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                        <tr data-entry-id="<?php echo e($failed->id); ?>">
                            <td></td>
                            <td><?php echo e($failed->order_id); ?></td>
                            <td><?php echo e($failed->amount); ?></td>
                            <td><?php echo e($failed->payment_type); ?></td>
                            <td><?php echo e($failed->transaction_type); ?></td>
                            <td style="max-width: 400px;"><?php echo e($failed->response_msg); ?></td>
                            <td>
                                <?php if($failed->status == 'pending'): ?>
                                    <span class="badge badge-warning btn-sm"><?php echo e($failed->status); ?></span>
                                <?php else: ?>
                                    <span class="badge badge-info btn-sm"><?php echo e($failed->status); ?></span>
                                <?php endif; ?>
                            </td>
                            <td>
                                <a class="btn btn-xs btn-primary" href="<?php echo e(route('admin.failed_transfers.show', $failed->id)); ?>">
                                    View Campaign
                                </a>

                                <a class="btn btn-xs btn-primary" href="<?php echo e(url('frontend/order_details/'. $failed->order_id)); ?>">
                                    View Order
                                </a>

                                <?php if($failed->status == 'pending'): ?>
                                    <a href="<?php echo e(url('admin/failed_transfers/ignore/' . $failed->id)); ?>"><button class="btn btn-info">Ignore</button></a></li>
                                <?php endif; ?>
                                <?php if($failed->status != 'successful'): ?>
                                    <a href="<?php echo e(url('admin/failed_transfers/refund/' . $failed->id)); ?>"><button class="btn btn-success">Retry</button></a></li>
                                <?php endif; ?>

                            </td>
                        </tr>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
<?php $__env->startSection('scripts'); ?>
    ##parent-placeholder-16728d18790deb58b3b8c1df74f06e536b532695##
    <script>
        $(function () {
            let deleteButtonTrans = '<?php echo e(trans('global.datatables.delete')); ?>'
            let deleteButton = {
                text: deleteButtonTrans,
                url: "<?php echo e(url('admin/failed_transfers/mass_destroy')); ?>",
                className: 'btn-danger',
                action: function (e, dt, node, config) {
                    var ids = $.map(dt.rows({ selected: true }).nodes(), function (entry) {
                        return $(entry).data('entry-id')
                    });

                    if (ids.length === 0) {
                        alert('<?php echo e(trans('global.datatables.zero_selected')); ?>')

                        return
                    }

                    if (confirm('<?php echo e(trans('global.areYouSure')); ?>')) {
                        $.ajax({
                            method: 'GET',
                            url: config.url,
                            data: { ids: ids }})
                            .done(function () { location.reload() })
                    }
                }
            }
            let dtButtons = $.extend(true, [], $.fn.dataTable.defaults.buttons)
            dtButtons.push(deleteButton)

            $('.datatable:not(.ajaxTable)').DataTable({ buttons: dtButtons })
        })

    </script>
<?php $__env->stopSection(); ?>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('layouts.admin', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /var/www/html/cloutsource/resources/views/admin/failed_transfers/index.blade.php ENDPATH**/ ?>