<?php $__env->startSection('content'); ?>
    <div class="card">
        <div class="card-header">
            <?php echo e(trans('global.ticket.title_singular')); ?> <?php echo e(trans('global.list')); ?>

            <?php if (app(\Illuminate\Contracts\Auth\Access\Gate::class)->check('ticket_create')): ?>
                <a class="btn btn-success" href="<?php echo e(route("admin.tickets.create")); ?>" style="float: right;">
                    <?php echo e(trans('global.add')); ?> <?php echo e(trans('global.ticket.title_singular')); ?>

                </a>
            <?php endif; ?>
        </div>

        <div class="card-body">
          
                <table class=" table table-bordered table-striped table-hover datatable table-responsive">
                    <thead>
                    <tr>
                        <th width="10">

                        </th>
                        <th>
                            <?php echo e(trans('global.ticket.fields.subject')); ?>

                        </th>
                        <th>
                            <?php echo e(trans('global.ticket.fields.user_name')); ?>

                        </th>
                        <th>
                            <?php echo e(trans('global.ticket.fields.against_user_name')); ?>

                        </th>
                        <th>
                            <?php echo e(trans('global.ticket.fields.type')); ?>

                        </th>
                        <th>
                            <?php echo e(trans('global.ticket.fields.status')); ?>

                        </th>
                        <th>
                            <?php echo e(trans('global.ticket.fields.description')); ?>

                        </th>
                        <th>
                            <?php echo e(trans('global.ticket.fields.created_at')); ?>

                        </th>
                        <th>
                            &nbsp;
                        </th>
                    </tr>
                    </thead>
                    <tbody>
                    <?php $__currentLoopData = $tickets; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $key => $ticket): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                        <tr data-entry-id="<?php echo e($ticket->id); ?>">
                            <td>

                            </td>
                            <td>
                                <?php echo e($ticket->subject ?? ''); ?>

                            </td>

                            <td>
                                <?php echo e($ticket->user->name ?? ''); ?>

                            </td>
                            <td>
                                <?php echo e($ticket->against_user_id != 0 ? ($ticket->against_user->name ?? '') : 'None'); ?>

                            </td>
                            <td>
                                <?php echo e($ticket->type ?? ''); ?>

                            </td>
                            <td>
                                <?php echo e($ticket->status ?? ''); ?>

                            </td>
                            <td>
                                <?php echo e($ticket->description ?? ''); ?>

                            </td>
                            <td>
                                <?php echo e($ticket->created_at ?? ''); ?>

                            </td>
                            <td>
                                <?php if (app(\Illuminate\Contracts\Auth\Access\Gate::class)->check('ticket_show')): ?>
                                    <?php if(!empty($ticket->order_id)): ?>
                                        <a class="btn btn-xs btn-success" href="<?php echo e(route('frontend.user.order_details' , ['id' => $ticket->order_id])); ?>">
                                            View Order
                                        </a>
                                    <?php else: ?>
                                        <a class="btn btn-xs btn-primary" href="<?php echo e(route('admin.tickets.show', $ticket->id)); ?>">
                                            <?php echo e(trans('global.view')); ?>

                                        </a>
                                    <?php endif; ?>

                                <?php endif; ?>

                                <?php if(Auth::user()->id == $ticket->user_id): ?>
                                <?php if (app(\Illuminate\Contracts\Auth\Access\Gate::class)->check('ticket_edit')): ?>
                                    <a class="btn btn-xs btn-info" href="<?php echo e(route('admin.tickets.edit', $ticket->id)); ?>">
                                        <?php echo e(trans('global.edit')); ?>

                                    </a>
                                <?php endif; ?>
                                <?php endif; ?>

                                <?php if (app(\Illuminate\Contracts\Auth\Access\Gate::class)->check('ticket_action')): ?>
                                    <?php if($ticket->status == 'Initiated'): ?>
                                        <a class="btn btn-xs btn-info" href="<?php echo e(route('admin.tickets.action', $ticket->id)); ?>">
                                                <?php echo e(trans('global.take_action')); ?>

                                        </a>
                                    <?php endif; ?>
                                <?php endif; ?>

                                <?php if (app(\Illuminate\Contracts\Auth\Access\Gate::class)->check('ticket_delete')): ?>
                                    <form action="<?php echo e(route('admin.tickets.destroy', $ticket->id)); ?>" method="POST" onsubmit="return confirm('<?php echo e(trans('global.areYouSure')); ?>');" style="display: inline-block;">
                                        <input type="hidden" name="_method" value="DELETE">
                                        <input type="hidden" name="_token" value="<?php echo e(csrf_token()); ?>">
                                        <input type="submit" class="btn btn-xs btn-danger" value="<?php echo e(trans('global.delete')); ?>">
                                    </form>
                                <?php endif; ?>

                                <?php if($ticket->order): ?>
                                    <a class="btn btn-xs btn-info" href="<?php echo e(url('frontend/archived_chat?buyer_id=' . $ticket->order->buyer_id . '&seller_id=' . $ticket->order->seller_id)); ?>">
                                        Archived Chat
                                    </a>
                                <?php endif; ?>
                            </td>

                        </tr>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    </tbody>
                </table>
            </div>
    </div>
<?php $__env->startSection('scripts'); ?>
    ##parent-placeholder-16728d18790deb58b3b8c1df74f06e536b532695##
    <script>
        $(function () {
            let deleteButtonTrans = '<?php echo e(trans('global.datatables.delete')); ?>'
            let deleteButton = {
                text: deleteButtonTrans,
                url: "<?php echo e(route('admin.tickets.massDestroy')); ?>",
                className: 'btn-danger',
                action: function (e, dt, node, config) {
                    var ids = $.map(dt.rows({ selected: true }).nodes(), function (entry) {
                        return $(entry).data('entry-id')
                    });

                    if (ids.length === 0) {
                        alert('<?php echo e(trans('global.datatables.zero_selected')); ?>')

                        return
                    }

                    if (confirm('<?php echo e(trans('global.areYouSure')); ?>')) {
                        $.ajax({
                            headers: {'x-csrf-token': _token},
                            method: 'POST',
                            url: config.url,
                            data: { ids: ids, _method: 'DELETE' }})
                            .done(function () { location.reload() })
                    }
                }
            }
            let dtButtons = $.extend(true, [], $.fn.dataTable.defaults.buttons)
            <?php if (app(\Illuminate\Contracts\Auth\Access\Gate::class)->check('ticket_delete')): ?>
            dtButtons.push(deleteButton)
            <?php endif; ?>

            $('.datatable:not(.ajaxTable)').DataTable({ buttons: dtButtons })
        })

    </script>
<?php $__env->stopSection(); ?>
<?php $__env->stopSection(); ?>


<?php echo $__env->make('layouts.admin', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /var/www/html/cloutsource/resources/views/admin/tickets/index.blade.php ENDPATH**/ ?>