<!-- Header -->
<?php $__env->startSection('header'); ?>
    <?php echo $__env->make('partials.header', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('contents'); ?>
    <div class="section full-height banner-section">
        <div class="section">
            <?php echo $__env->make('flash-message', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
            <div class="container">
                <div class="campaign_heading">
                    <span>CAMPAIGN CART</span>
                </div>
                <div class="row">
                    <div class="col-md-12">
                        <div class= "campaign_list">

                            <div class="sort_div">
                                <a><strong>SORT</strong></a>
                                <select name="paginate" id="paginate">
                                    <option value="10" <?php echo e(isset($_REQUEST['pages']) && $_REQUEST['pages'] == 10 ? 'selected' : ''); ?>>10</option>
                                    <option value="50" <?php echo e(isset($_REQUEST['pages']) && $_REQUEST['pages'] == 50 ? 'selected' : ''); ?>>50</option>
                                    <option value="100" <?php echo e(isset($_REQUEST['pages']) && $_REQUEST['pages'] == 100 ? 'selected' : ''); ?>>100</option>
                                    <option value="150" <?php echo e(isset($_REQUEST['pages']) && $_REQUEST['pages'] == 150 ? 'selected' : ''); ?>>150</option>
                                </select>

                            </div>

                        </div>
                    </div>
                </div>
                <div class="row">

                    <div class="col-md-12">
                        <div class="table-responsive">
                            <!-- DATA TABLE STARTS -->
                            <?php if(count($cartItems)): ?>
                            <table id="dtBasicExample" class="table table-striped table-bordered" cellspacing="0" width="100%" style="background: #fff;">
                                <thead>
                                <tr>
                                    <th class="th-sm">CAMPAIGN NAME
                                    </th>
                                    <th class="th-sm">INFLUENCER
                                    </th>
                                    <th class="th-sm">POST DESCRTPTION
                                    </th>
                                    <th class="th-sm">POST FILE
                                    </th>
                                    <th class="th-sm">POST START DATE
                                    </th>
                                    <th class="th-sm">PRICE
                                    </th>
                                    <th class="th-sm">ACTIONS
                                    </th>

                                </tr>
                                </thead>
                                <tbody>


                                <?php $__currentLoopData = $cartItems; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $cartItem): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                    <tr>
                                        <td><?php echo e($cartItem->title); ?></td>
                                        <td><a href="<?php echo e(asset( 'frontend/influencer/' . $cartItem->influencer_id)); ?>"><?php echo e($cartItem->account_handle); ?></a></td>
                                        <td><?php echo e($cartItem->description); ?></td>
                                        <td>
                                            <?php if(!empty($cartItem->image)): ?>
                                                <img src="<?php echo e(asset('uploads/images/') . '/' . $cartItem->image); ?>" style="width: 200px;">
                                            <?php elseif(!empty($cartItem->video)): ?>
                                                <video width="200" height="120" controls>
                                                    <source src="<?php echo e(asset('uploads/images/'.$cartItem->video)); ?>" type="video/mp4">
                                                    Your browser does not support the video tag.
                                                </video>
                                            <?php else: ?>
                                                <img src="<?php echo e(asset('images/preview.jpg')); ?>" style="width: 200px;">
                                            <?php endif; ?>
                                        </td>
                                        <td><?php echo e(date('d-m-Y' , strtotime($cartItem->start_date) )); ?></td>
                                        <td>$<?php echo e($cartItem->price); ?></td>
                                        <td>
<!--                                                 <a class="fa fa-cog dropdown-toggle" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"></a>
                                                <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                                                    <a class="dropdown-item" href="<?php echo e(route('frontend.user.checkout',['id' => $cartItem->id])); ?>">Checkout</a>

                                                    <a class="dropdown-item" href="<?php echo e(route('frontend.user.delete_cart', ['id' => $cartItem->id])); ?>">Delete</a>

                                                    <a class="dropdown-item" href="<?php echo e(route('frontend.user.edit_cart', ['id' => $cartItem->id])); ?>">Edit</a>
                                                </div> -->

                                                <div class="dropdown campaign-action-dropdown">
                                                      <button class="dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                        <i class="fa fa-cog"></i>
                                                      </button>
                                                      <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                                                        <a class="dropdown-item" href="<?php echo e(route('frontend.user.checkout',['id' => $cartItem->id])); ?>">Checkout</a>

                                                        <a class="dropdown-item" href="<?php echo e(route('frontend.user.delete_cart', ['id' => $cartItem->id])); ?>">Delete</a>

                                                        <a class="dropdown-item" href="<?php echo e(route('frontend.user.edit_cart', ['id' => $cartItem->id])); ?>">Edit</a>
                                                      </div>
                                                    </div>


                                        </td>
                                    </tr>
                                <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>

                                </tbody>
                            </table>
                            <?php else: ?>
                                <tr><h4>No Item Found In Cart</h4></tr>
                            <?php endif; ?>
                            <!-- DATA TABLE ENDS -->
                            <?php echo e($cartItems->appends(request()->query())->links()); ?>


                            



                        </div>
                    </div>
                </div>




            </div>
        </div>




        <div class="section mt-5">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div id="switch">
                            <div id="circle"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('footer'); ?>
    <?php echo $__env->make('partials.footer', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
<?php $__env->stopSection(); ?>
<?php $__env->startSection('scripts'); ?>
    
    <script>
        $("#paginate").change(function(){
            var pages = $("#paginate").val();
            window.location.href = '<?php echo e(asset('/')); ?>' + 'frontend/cart?pages=' + pages;
        });
    </script>

<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.frontend', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /var/www/html/cloutsource/resources/views/frontend/cart/campaign_cart_details.blade.php ENDPATH**/ ?>