<?php $__env->startSection('content'); ?>

<div class="card">
    <div class="card-header">
        <?php echo e(trans('global.edit')); ?> <?php echo e(trans('global.campaign.title_singular')); ?>

    </div>

    <div class="card-body">
        <form action="<?php echo e(route("admin.campaigns.update", [$campaign->id])); ?>" method="POST" enctype="multipart/form-data">
            <?php echo csrf_field(); ?>
            <?php echo method_field('PUT'); ?>

            <div class="form-group <?php echo e($errors->has('name') ? 'has-error' : ''); ?>">
                <label for="start_date"><?php echo e(trans('global.campaign.fields.name')); ?></label>
                <input type="text" name="name" class="form-control" value="<?php echo e($campaign->name); ?>">
                <?php if($errors->has('name')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('name')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.campaign.fields.name_helper')); ?>

                </p>
            </div>
            <div class="form-group <?php echo e($errors->has('influencer_id') ? 'has-error' : ''); ?>">
                <label for="influencer_id"><?php echo e(trans('global.campaign.fields.influencer_name')); ?>*</label>
                <select  class="form-control" name="influencer_id">
                    <?php $__currentLoopData = $influencers; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $influencer): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                        <option value="<?php echo e($influencer->id); ?>" <?php if($campaign->influencer->id == $influencer->id): ?> selected <?php endif; ?>><?php echo e($influencer->name); ?></option>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                </select>

                <?php if($errors->has('influencer_id')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('influencer_id')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.campaign.fields.influencer_name_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('price') ? 'has-error' : ''); ?>">
                <label for="price"><?php echo e(trans('global.campaign.fields.price')); ?></label>
                <input type="text" name="price" class="form-control" value="<?php echo e($campaign->price); ?>">
                <?php if($errors->has('price')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('price')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.campaign.fields.name_helper')); ?>

                </p>
            </div>

            <div class="form-group <?php echo e($errors->has('duration') ? 'has-error' : ''); ?>">
                <label for="price"><?php echo e(trans('global.campaign.fields.duration')); ?></label>
                <input type="text" name="duration" class="form-control" value="<?php echo e($campaign->duration); ?>">
                <?php if($errors->has('duration')): ?>
                    <em class="invalid-feedback">
                        <?php echo e($errors->first('duration')); ?>

                    </em>
                <?php endif; ?>
                <p class="helper-block">
                    <?php echo e(trans('global.campaign.fields.duration_helper')); ?>

                </p>
            </div>

            <div>
                <input class="btn btn-danger" type="submit" value="<?php echo e(trans('global.save')); ?>">
            </div>
        </form>
    </div>
</div>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.admin', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /var/www/html/cloutsource/resources/views/admin/campaigns/edit.blade.php ENDPATH**/ ?>